# Relational and Item-Specific Encoding (RISE)

This memory task starts with an encoding test in two parts: identifying if an object on screen is alive or if one object can fit inside another. This implementation includes practice and trial phases and both encoding and recognition trials. During recognition, participants decide if images were seen before or presented together.

**Publication:** Relational and Item-Specific Encoding (RISE): Task Development and Psychometric Characteristics, Functional and Neuroanatomic Specificity of Episodic Memory Dysfunction in Schizophrenia: A Functional Magnetic Resonance Imaging Study of the Relational and Item-Specific Encoding Task

**Experiment DOI:** https://doi.org/10.17605/OSF.IO/ZEJ5W

**Functions assessed:** Cognitive

## Features

**Languages:** English, French

**Validation:**
  
  * Populations: Adult, Healthy, Disease

**Accessibility:** Hearing impairment

**Modalities:** fMRI

**Devices:** Computer, Laptop

**Species:** Homo sapiens

## Development

**Software:** PsychoPy version 2023.1.3

**Requirements:** mouse/keyboard required (practice); 2-button response box (fMRI)

## Administration

Run this task using Psychopy. The main repository contains subfolders for the encoding and recognition tasks, to allow for delayed recognition testing, if desired.

## Procedure and Conditions

The task includes practice and trial phases for both encoding and recognition. The encoding test has two conditions, where participants must identify either (1) if an object on screen is alive (living, item-specific episodic memory), or (2) if one object can fit inside another (inside, relational episodic memory). The recognition test is split into three runs, where participants must decide whether (1) one of the two objects was previously seen (item-specific recognition, two runs), or (2) the two objects were presented together previously (relational recognition, one run).

## Output Files

Log files are output to calculate event timing.

## Scoring

- accuracy & correct responses (per condition)
- reaction time (per condition)

## License and Attribution

**License**

This project is distributed under two distinct licenses:

Source Code: The source code of this project is distributed under the Academic Public License. This license allows for academic use and modification of the code but is not intended for commercial use.

Documentation: The documentation of this project, including but not limited to README files, wikis, and help files, is distributed under the Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License (CC BY-NC-SA 4.0). This license allows others to remix, adapt, and build upon our work non-commercially, as long as they credit the author and license their new creations under the identical terms.

Please read the LICENSE_code and LICENSE_doc files for the specific terms of these licenses.

**Attribution**

If you use this task in your work, please cite it as indicated on the Open Science Framework, e.g., (in APA format):

Lavigne, K. M., Ragland, J. D., & Lepage, M. (2024, April 26). Relational and Item-Specific Encoding (RISE). https://doi.org/10.17605/OSF.IO/ZEJ5W