﻿/****************** 
 * Rise_Enco Test *
 ******************/


// store info about the experiment session:
let expName = 'RISE_Enco';  // from the Builder filename that created this script
let expInfo = {
    'participant': '',
    'session': '',
    'choiceTrial': ["practiceV1", "trialV1", "practiceV2", "trialV2"],
};

// Start code blocks for 'Before Experiment'
// Run 'Before Experiment' code from code_instr_vivant
two_exemple = 1;

// Run 'Before Experiment' code from code_pr
rowPract = "0:2";
show_betw = 1;
timedAns = 0;

// Run 'Before Experiment' code from codePreRemind
lenghtRemind = 0;
timerRemind = null;
function buttonSelector(selectedButton) {
    selectedButton.fillColor = [(- 0.92), (- 0.24), (- 0.29)];
}

// Run 'Before Experiment' code from code_reminder
timeLastRun = 0;

// init psychoJS:
const psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color([1,1,1]),
  units: 'height',
  waitBlanking: true
});
// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
flowScheduler.add(langRoutineBegin());
flowScheduler.add(langRoutineEachFrame());
flowScheduler.add(langRoutineEnd());
flowScheduler.add(set_conditionRoutineBegin());
flowScheduler.add(set_conditionRoutineEachFrame());
flowScheduler.add(set_conditionRoutineEnd());
const skip_practiceLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(skip_practiceLoopBegin(skip_practiceLoopScheduler));
flowScheduler.add(skip_practiceLoopScheduler);
flowScheduler.add(skip_practiceLoopEnd);
const skip_trialLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(skip_trialLoopBegin(skip_trialLoopScheduler));
flowScheduler.add(skip_trialLoopScheduler);
flowScheduler.add(skip_trialLoopEnd);
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({
  expName: expName,
  expInfo: expInfo,
  resources: [
    // resources:
    {'name': 'default.png', 'path': 'https://pavlovia.org/assets/default/default.png'},
  ]
});

psychoJS.experimentLogger.setLevel(core.Logger.ServerLevel.DEBUG);

async function updateInfo() {
  currentLoop = psychoJS.experiment;  // right now there are no loops
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '2023.1.3';
  expInfo['OS'] = window.navigator.platform;


  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0 / Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0 / 60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  

  
  psychoJS.experiment.dataFileName = (("." + "/") + `data/${expInfo["participant"]}_${expName}_${expInfo["choiceTrial"]}_${expInfo["date"]}_${expInfo["session"]}`);


  return Scheduler.Event.NEXT;
}

async function experimentInit() {
  // Initialize components for Routine "lang"
  langClock = new util.Clock();
  // Run 'Begin Experiment' code from code_lang
  button_down = false;
  
  text_lang = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_lang',
    text: 'Veuillez sélectionner votre langue.\nAppuyez sur 1 pour Français.\n\nPlease select your language.\nPress 2 for English.',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.04,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -1.0 
  });
  
  keyLang = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "set_condition"
  set_conditionClock = new util.Clock();
  // Run 'Begin Experiment' code from code_set
  import * as re from 're';
  import * as time from 'time';
  import {datetime} from 'datetime';
  startingTime = datetime.now().strftime("%H:%M:%S.%f");
  startingTime = ("'" + startingTime);
  console.log("Starting time: ", startingTime);
  psychoJS.experiment.addData("sessionTime", startingTime);
  psychoJS.experiment.addData("sessionTime.RTTime", new core.Clock().getTime());
  expInfo["participant"] = re.sub("[^A-Za-z0-9]+", "", expInfo["participant"]);
  button_down = false;
  new psychoJS.eventManager.Mouse({"visible": false});
  psychoJS.window.mouseVisible = false;
  
  // Initialize components for Routine "instr_vivant"
  instr_vivantClock = new util.Clock();
  instr_text_vivant_1 = new visual.TextStim({
    win: psychoJS.window,
    name: 'instr_text_vivant_1',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.7, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -1.0 
  });
  
  instr_text_vivant_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'instr_text_vivant_2',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 2.0, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -2.0 
  });
  
  instr_text_vivant_3 = new visual.TextStim({
    win: psychoJS.window,
    name: 'instr_text_vivant_3',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.7, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -3.0 
  });
  
  instr_text_vivant_4 = new visual.TextStim({
    win: psychoJS.window,
    name: 'instr_text_vivant_4',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -4.0 
  });
  
  // Initialize components for Routine "ex"
  exClock = new util.Clock();
  item1_imgEx = new visual.ImageStim({
    win : psychoJS.window,
    name : 'item1_imgEx', units : undefined, 
    image : 'default.png', mask : undefined,
    anchor : 'center',
    ori : 0.0, pos : [(- 0.3), 0], size : [0.5, 0.5],
    color : new util.Color([1,1,1]), opacity : 1.0,
    flipHoriz : false, flipVert : false,
    texRes : 512.0, interpolate : false, depth : -1.0 
  });
  que_txtEx = new visual.TextStim({
    win: psychoJS.window,
    name: 'que_txtEx',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, (- 0.3)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: undefined,
    depth: -2.0 
  });
  
  item2_imgEx = new visual.ImageStim({
    win : psychoJS.window,
    name : 'item2_imgEx', units : undefined, 
    image : 'default.png', mask : undefined,
    anchor : 'center',
    ori : 0.0, pos : [0.3, 0], size : [0.5, 0.5],
    color : new util.Color([1,1,1]), opacity : undefined,
    flipHoriz : false, flipVert : false,
    texRes : 512.0, interpolate : false, depth : -3.0 
  });
  response_Ex = new visual.TextStim({
    win: psychoJS.window,
    name: 'response_Ex',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -4.0 
  });
  
  timer_Ex = new visual.TextStim({
    win: psychoJS.window,
    name: 'timer_Ex',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: undefined,
    depth: -5.0 
  });
  
  fix_text_Ex = new visual.TextStim({
    win: psychoJS.window,
    name: 'fix_text_Ex',
    text: '+',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.11,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -6.0 
  });
  
  key_Ex = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  text_Ex = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_Ex',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0.35], height: 0.04,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: undefined,
    depth: -8.0 
  });
  
  ans_yes_ex = new visual.TextStim({
    win: psychoJS.window,
    name: 'ans_yes_ex',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [(- 0.1), (- 0.38)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: undefined,
    depth: -9.0 
  });
  
  ans_no_ex = new visual.TextStim({
    win: psychoJS.window,
    name: 'ans_no_ex',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.1, (- 0.38)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: undefined,
    depth: -10.0 
  });
  
  // Initialize components for Routine "next_instr"
  next_instrClock = new util.Clock();
  text_next_instr = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_next_instr',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.7, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -1.0 
  });
  
  key_next_instr = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "pract"
  practClock = new util.Clock();
  ans_no_prac = new visual.TextStim({
    win: psychoJS.window,
    name: 'ans_no_prac',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.1, (- 0.38)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: undefined,
    depth: -1.0 
  });
  
  ans_yes_prac = new visual.TextStim({
    win: psychoJS.window,
    name: 'ans_yes_prac',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [(- 0.1), (- 0.38)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: undefined,
    depth: -2.0 
  });
  
  item1_img_pr = new visual.ImageStim({
    win : psychoJS.window,
    name : 'item1_img_pr', units : undefined, 
    image : 'default.png', mask : undefined,
    anchor : 'center',
    ori : 0.0, pos : [(- 0.3), 0], size : [0.5, 0.5],
    color : new util.Color([1,1,1]), opacity : 1.0,
    flipHoriz : false, flipVert : false,
    texRes : 512.0, interpolate : false, depth : -3.0 
  });
  que_text_pr = new visual.TextStim({
    win: psychoJS.window,
    name: 'que_text_pr',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, (- 0.3)], height: 0.06,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -4.0 
  });
  
  item2_img_pr = new visual.ImageStim({
    win : psychoJS.window,
    name : 'item2_img_pr', units : undefined, 
    image : 'default.png', mask : undefined,
    anchor : 'center',
    ori : 0.0, pos : [0.3, 0], size : [0.5, 0.5],
    color : new util.Color([1,1,1]), opacity : 1.0,
    flipHoriz : false, flipVert : false,
    texRes : 512.0, interpolate : false, depth : -5.0 
  });
  timer_pr = new visual.TextStim({
    win: psychoJS.window,
    name: 'timer_pr',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.01,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: 0.0,
    depth: -6.0 
  });
  
  timer_timed_pr = new visual.TextStim({
    win: psychoJS.window,
    name: 'timer_timed_pr',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.01,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: 0.0,
    depth: -7.0 
  });
  
  fix_text_pr = new visual.TextStim({
    win: psychoJS.window,
    name: 'fix_text_pr',
    text: '+',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.11,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -8.0 
  });
  
  key_prac = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "transition1"
  transition1Clock = new util.Clock();
  txt_transi1 = new visual.TextStim({
    win: psychoJS.window,
    name: 'txt_transi1',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -1.0 
  });
  
  key_transi1 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "preRemind"
  preRemindClock = new util.Clock();
  textPreRemind = new visual.TextStim({
    win: psychoJS.window,
    name: 'textPreRemind',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0.3], height: 0.04,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: undefined,
    depth: -1.0 
  });
  
  textPreRemind_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'textPreRemind_2',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, (- 0.3)], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('black'),  opacity: 1.0,
    depth: -2.0 
  });
  
  keyPreRemind = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  ansYesPreRemind = new visual.TextStim({
    win: psychoJS.window,
    name: 'ansYesPreRemind',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [(- 0.1), (- 0.05)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('black'),  opacity: 1.0,
    depth: -4.0 
  });
  
  ansNoPreRemind = new visual.TextStim({
    win: psychoJS.window,
    name: 'ansNoPreRemind',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.1, (- 0.05)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('black'),  opacity: 1.0,
    depth: -5.0 
  });
  
  polygonYes = new visual.Rect ({
    win: psychoJS.window, name: 'polygonYes', 
    width: [0.1, 0.1][0], height: [0.1, 0.1][1],
    ori: 0.0, pos: [(- 0.1), 0.05],
    anchor: 'center',
    lineWidth: 1.0, 
    colorSpace: 'rgb',
    lineColor: new util.Color('black'),
    fillColor: new util.Color('white'),
    opacity: undefined, depth: -6, interpolate: true,
  });
  
  polygonNo = new visual.Rect ({
    win: psychoJS.window, name: 'polygonNo', 
    width: [0.1, 0.1][0], height: [0.1, 0.1][1],
    ori: 0.0, pos: [0.1, 0.05],
    anchor: 'center',
    lineWidth: 1.0, 
    colorSpace: 'rgb',
    lineColor: new util.Color('black'),
    fillColor: new util.Color('white'),
    opacity: undefined, depth: -7, interpolate: true,
  });
  
  // Initialize components for Routine "remind"
  remindClock = new util.Clock();
  title_remind = new visual.TextStim({
    win: psychoJS.window,
    name: 'title_remind',
    text: '',
    font: 'Open Sans Black',
    units: undefined, 
    pos: [0, 0.1], height: 0.07,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('black'),  opacity: undefined,
    depth: -1.0 
  });
  
  text_remind = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_remind',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, (- 0.1)], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -2.0 
  });
  
  // Initialize components for Routine "ready"
  readyClock = new util.Clock();
  // Run 'Begin Experiment' code from code_rdy
  skipReminder = 0;
  trial = 1;
  rowTrial = "0:2";
  first_pulse = 0;
  
  txt_rdy = new visual.TextStim({
    win: psychoJS.window,
    name: 'txt_rdy',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -1.0 
  });
  
  key_rdy = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "cntdown"
  cntdownClock = new util.Clock();
  timer_ctdown = new visual.TextStim({
    win: psychoJS.window,
    name: 'timer_ctdown',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.08,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -1.0 
  });
  
  key_ctdown = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "reminder"
  reminderClock = new util.Clock();
  title_reminder = new visual.TextStim({
    win: psychoJS.window,
    name: 'title_reminder',
    text: '',
    font: 'Open Sans Black',
    units: undefined, 
    pos: [0, 0.1], height: 0.07,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('black'),  opacity: undefined,
    depth: -1.0 
  });
  
  text_reminder = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_reminder',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, (- 0.1)], height: 0.05,  wrapWidth: 1.5, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -2.0 
  });
  
  key_reminder = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "trial"
  trialClock = new util.Clock();
  item1_img = new visual.ImageStim({
    win : psychoJS.window,
    name : 'item1_img', units : undefined, 
    image : 'default.png', mask : undefined,
    anchor : 'center',
    ori : 0.0, pos : [(- 0.3), 0], size : [0.5, 0.5],
    color : new util.Color([1,1,1]), opacity : 1.0,
    flipHoriz : false, flipVert : false,
    texRes : 512.0, interpolate : false, depth : -1.0 
  });
  que_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'que_text',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, (- 0.3)], height: 0.06,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -2.0 
  });
  
  item2_img = new visual.ImageStim({
    win : psychoJS.window,
    name : 'item2_img', units : undefined, 
    image : 'default.png', mask : undefined,
    anchor : 'center',
    ori : 0.0, pos : [0.3, 0], size : [0.5, 0.5],
    color : new util.Color([1,1,1]), opacity : 1.0,
    flipHoriz : false, flipVert : false,
    texRes : 512.0, interpolate : false, depth : -3.0 
  });
  timer = new visual.TextStim({
    win: psychoJS.window,
    name: 'timer',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.01,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color('white'),  opacity: 0.0,
    depth: -4.0 
  });
  
  fix_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'fix_text',
    text: '+',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.11,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -5.0 
  });
  
  key = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  ans_yes_trial = new visual.TextStim({
    win: psychoJS.window,
    name: 'ans_yes_trial',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [(- 0.1), (- 0.38)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1,]),  opacity: undefined,
    depth: -7.0 
  });
  
  ans_no_trial = new visual.TextStim({
    win: psychoJS.window,
    name: 'ans_no_trial',
    text: '',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.1, (- 0.38)], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: undefined,
    depth: -8.0 
  });
  
  // Initialize components for Routine "thanks"
  thanksClock = new util.Clock();
  txt_thx = new visual.TextStim({
    win: psychoJS.window,
    name: 'txt_thx',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: 1.1, ori: 0.0,
    languageStyle: 'LTR',
    color: new util.Color([-1,-1,-1]),  opacity: 1.0,
    depth: -1.0 
  });
  
  key_thx = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}

function langRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'lang' ---
    t = 0;
    langClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // Run 'Begin Routine' code from code_lang
    button_down = false;
    new psychoJS.eventManager.Mouse({"visible": false});
    psychoJS.window.mouseVisible = false;
    
    keyLang.keys = undefined;
    keyLang.rt = undefined;
    _keyLang_allKeys = [];
    // keep track of which components have finished
    langComponents = [];
    langComponents.push(text_lang);
    langComponents.push(keyLang);
    
    langComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}

function langRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'lang' ---
    // get current time
    t = langClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    // Run 'Each Frame' code from code_lang
    var _pj;
    function _pj_snippets(container) {
        function in_es6(left, right) {
            if (((right instanceof Array) || ((typeof right) === "string"))) {
                return (right.indexOf(left) > (- 1));
            } else {
                if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                    return right.has(left);
                } else {
                    return (left in right);
                }
            }
        }
        container["in_es6"] = in_es6;
        return container;
    }
    _pj = {};
    _pj_snippets(_pj);
    function set_language(french_val, english_val) {
        return [french_val, english_val];
    }
    if ((joystickLang.getAllButtons()[0] || _pj.in_es6("1", keyLang.keys))) {
        [french, english] = set_language(true, false);
        text_lang.finished = true;
        continueRoutine = false;
    } else {
        if ((joystickLang.getAllButtons()[2] || _pj.in_es6("2", keyLang.keys))) {
            [french, english] = set_language(false, true);
            text_lang.finished = true;
            continueRoutine = false;
        }
    }
    
    
    // *text_lang* updates
    if (t >= 0.0 && text_lang.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_lang.tStart = t;  // (not accounting for frame time here)
      text_lang.frameNStart = frameN;  // exact frame index
      
      text_lang.setAutoDraw(true);
    }

    
    // *keyLang* updates
    if (t >= 0.0 && keyLang.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      keyLang.tStart = t;  // (not accounting for frame time here)
      keyLang.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { keyLang.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { keyLang.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { keyLang.clearEvents(); });
    }

    if (keyLang.status === PsychoJS.Status.STARTED) {
      let theseKeys = keyLang.getKeys({keyList: ['1', '2', 'esc'], waitRelease: false});
      _keyLang_allKeys = _keyLang_allKeys.concat(theseKeys);
      if (_keyLang_allKeys.length > 0) {
        keyLang.keys = _keyLang_allKeys[_keyLang_allKeys.length - 1].name;  // just the last key pressed
        keyLang.rt = _keyLang_allKeys[_keyLang_allKeys.length - 1].rt;
        keyLang.duration = _keyLang_allKeys[_keyLang_allKeys.length - 1].duration;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    langComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}

function langRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'lang' ---
    langComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // Run 'End Routine' code from code_lang
    lang = ((english === true) ? "en" : "fr");
    psychoJS.experiment.addData("language", lang);
    button_down = true;
    
    // update the trial handler
    if (currentLoop instanceof MultiStairHandler) {
      currentLoop.addResponse(keyLang.corr, level);
    }
    psychoJS.experiment.addData('keyLang.keys', keyLang.keys);
    if (typeof keyLang.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('keyLang.rt', keyLang.rt);
        psychoJS.experiment.addData('keyLang.duration', keyLang.duration);
        }
    
    keyLang.stop();
    // the Routine "lang" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}

function set_conditionRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'set_condition' ---
    t = 0;
    set_conditionClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // Run 'Begin Routine' code from code_set
    current_practice = 1;
    new psychoJS.eventManager.Mouse({"visible": false});
    psychoJS.window.mouseVisible = false;
    
    // keep track of which components have finished
    set_conditionComponents = [];
    
    set_conditionComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}

function set_conditionRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'set_condition' ---
    // get current time
    t = set_conditionClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    // Run 'Each Frame' code from code_set
    var _pj;
    function _pj_snippets(container) {
        function in_es6(left, right) {
            if (((right instanceof Array) || ((typeof right) === "string"))) {
                return (right.indexOf(left) > (- 1));
            } else {
                if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                    return right.has(left);
                } else {
                    return (left in right);
                }
            }
        }
        container["in_es6"] = in_es6;
        return container;
    }
    _pj = {};
    _pj_snippets(_pj);
    pracTxt = "conditions/txt_practices.csv";
    condition_files = {"practiceV1": ["conditions/Practice_Item-Specific_V1.csv", "conditions/Practice_Relational_V1.csv", "conditions/Encoding_V1/Encoding_Trial_V1.csv"], "trialV1": ["conditions/Practice_Item-Specific_V1.csv", "conditions/Practice_Relational_V1.csv", "conditions/Encoding_V1/Encoding_Trial_V1.csv"], "practiceV2": ["conditions/Practice_Item-Specific_V2.csv", "conditions/Practice_Relational_V2.csv", "conditions/Encoding_V2/Encoding_Trial_V2.csv"], "trialV2": ["conditions/Practice_Item-Specific_V2.csv", "conditions/Practice_Relational_V2.csv", "conditions/Encoding_V2/Encoding_Trial_V1.csv"]};
    if (_pj.in_es6(expInfo["choiceTrial"], condition_files)) {
        [practConditions, pracConditions2, trialConditions] = condition_files[expInfo["choiceTrial"]];
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    set_conditionComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}

function set_conditionRoutineEnd(snapshot) {
  return async function () {
    //--- Ending Routine 'set_condition' ---
    set_conditionComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // Run 'End Routine' code from code_set
    var _pj;
    function _pj_snippets(container) {
        function in_es6(left, right) {
            if (((right instanceof Array) || ((typeof right) === "string"))) {
                return (right.indexOf(left) > (- 1));
            } else {
                if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                    return right.has(left);
                } else {
                    return (left in right);
                }
            }
        }
        container["in_es6"] = in_es6;
        return container;
    }
    _pj = {};
    _pj_snippets(_pj);
    if (_pj.in_es6("practice", expInfo["choiceTrial"])) {
        skipP = 1;
        skipT = 0;
    } else {
        skipP = 0;
        skipT = 1;
    }
    
    // the Routine "set_condition" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    // Routines running outside a loop should always advance the datafile row
    if (currentLoop === psychoJS.experiment) {
      psychoJS.experiment.nextEntry(snapshot);
    }
    return Scheduler.Event.NEXT;
  }
}

function skip_practiceLoopBegin(skip_practiceLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    skip_practice = new TrialHandler({
      psychoJS: psychoJS,
      nReps: skipP, method: TrialHandler.Method.RANDOM,
      extraInfo: expInfo, originPath: undefined,
      trialList: undefined,
      seed: undefined, name: 'skip_practice'
    });
    psychoJS.experiment.addLoop(skip_practice); // add the loop to the experiment
    currentLoop = skip_practice;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    skip_practice.forEach(function() {
      snapshot = skip_practice.getSnapshot();
    
      skip_practiceLoopScheduler.add(importConditions(snapshot));
      const practices_blocLoopScheduler = new Scheduler(psychoJS);
      skip_practiceLoopScheduler.add(practices_blocLoopBegin(practices_blocLoopScheduler, snapshot));
      skip_practiceLoopScheduler.add(practices_blocLoopScheduler);
      skip_practiceLoopScheduler.add(practices_blocLoopEnd);
      skip_practiceLoopScheduler.add(skip_practiceLoopEndIteration(skip_practiceLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

function practices_blocLoopBegin(practices_blocLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    practices_bloc = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: pracTxt,
      seed: undefined, name: 'practices_bloc'
    });
    psychoJS.experiment.addLoop(practices_bloc); // add the loop to the experiment
    currentLoop = practices_bloc;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    practices_bloc.forEach(function() {
      snapshot = practices_bloc.getSnapshot();
    
      practices_blocLoopScheduler.add(importConditions(snapshot));
      practices_blocLoopScheduler.add(instr_vivantRoutineBegin(snapshot));
      practices_blocLoopScheduler.add(instr_vivantRoutineEachFrame());
      practices_blocLoopScheduler.add(instr_vivantRoutineEnd(snapshot));
      const loop_exLoopScheduler = new Scheduler(psychoJS);
      practices_blocLoopScheduler.add(loop_exLoopBegin(loop_exLoopScheduler, snapshot));
      practices_blocLoopScheduler.add(loop_exLoopScheduler);
      practices_blocLoopScheduler.add(loop_exLoopEnd);
      practices_blocLoopScheduler.add(next_instrRoutineBegin(snapshot));
      practices_blocLoopScheduler.add(next_instrRoutineEachFrame());
      practices_blocLoopScheduler.add(next_instrRoutineEnd(snapshot));
      const prac_repeatLoopScheduler = new Scheduler(psychoJS);
      practices_blocLoopScheduler.add(prac_repeatLoopBegin(prac_repeatLoopScheduler, snapshot));
      practices_blocLoopScheduler.add(prac_repeatLoopScheduler);
      practices_blocLoopScheduler.add(prac_repeatLoopEnd);
      practices_blocLoopScheduler.add(practices_blocLoopEndIteration(practices_blocLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

function loop_exLoopBegin(loop_exLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    loop_ex = new TrialHandler({
      psychoJS: psychoJS,
      nReps: two_exemple, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: undefined,
      seed: undefined, name: 'loop_ex'
    });
    psychoJS.experiment.addLoop(loop_ex); // add the loop to the experiment
    currentLoop = loop_ex;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    loop_ex.forEach(function() {
      snapshot = loop_ex.getSnapshot();
    
      loop_exLoopScheduler.add(importConditions(snapshot));
      loop_exLoopScheduler.add(exRoutineBegin(snapshot));
      loop_exLoopScheduler.add(exRoutineEachFrame());
      loop_exLoopScheduler.add(exRoutineEnd(snapshot));
      loop_exLoopScheduler.add(loop_exLoopEndIteration(loop_exLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

async function loop_exLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(loop_ex);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function loop_exLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      }
    return Scheduler.Event.NEXT;
    }
  };
}

function prac_repeatLoopBegin(prac_repeatLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    prac_repeat = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 100, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: undefined,
      seed: undefined, name: 'prac_repeat'
    });
    psychoJS.experiment.addLoop(prac_repeat); // add the loop to the experiment
    currentLoop = prac_repeat;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    prac_repeat.forEach(function() {
      snapshot = prac_repeat.getSnapshot();
    
      prac_repeatLoopScheduler.add(importConditions(snapshot));
      const practiceLoopScheduler = new Scheduler(psychoJS);
      prac_repeatLoopScheduler.add(practiceLoopBegin(practiceLoopScheduler, snapshot));
      prac_repeatLoopScheduler.add(practiceLoopScheduler);
      prac_repeatLoopScheduler.add(practiceLoopEnd);
      prac_repeatLoopScheduler.add(transition1RoutineBegin(snapshot));
      prac_repeatLoopScheduler.add(transition1RoutineEachFrame());
      prac_repeatLoopScheduler.add(transition1RoutineEnd(snapshot));
      prac_repeatLoopScheduler.add(prac_repeatLoopEndIteration(prac_repeatLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

function practiceLoopBegin(practiceLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    practice = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: practConditions,
      seed: undefined, name: 'practice'
    });
    psychoJS.experiment.addLoop(practice); // add the loop to the experiment
    currentLoop = practice;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    practice.forEach(function() {
      snapshot = practice.getSnapshot();
    
      practiceLoopScheduler.add(importConditions(snapshot));
      practiceLoopScheduler.add(practRoutineBegin(snapshot));
      practiceLoopScheduler.add(practRoutineEachFrame());
      practiceLoopScheduler.add(practRoutineEnd(snapshot));
      practiceLoopScheduler.add(practiceLoopEndIteration(practiceLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

async function practiceLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(practice);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function practiceLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        psychoJS.experiment.nextEntry(snapshot);
      }
    return Scheduler.Event.NEXT;
    }
  };
}

async function prac_repeatLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(prac_repeat);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function prac_repeatLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      }
    return Scheduler.Event.NEXT;
    }
  };
}

async function practices_blocLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(practices_bloc);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function practices_blocLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        psychoJS.experiment.nextEntry(snapshot);
      }
    return Scheduler.Event.NEXT;
    }
  };
}

async function skip_practiceLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(skip_practice);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function skip_practiceLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      }
    return Scheduler.Event.NEXT;
    }
  };
}

function skip_trialLoopBegin(skip_trialLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    skip_trial = new TrialHandler({
      psychoJS: psychoJS,
      nReps: skipT, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: undefined,
      seed: undefined, name: 'skip_trial'
    });
    psychoJS.experiment.addLoop(skip_trial); // add the loop to the experiment
    currentLoop = skip_trial;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    skip_trial.forEach(function() {
      snapshot = skip_trial.getSnapshot();
    
      skip_trialLoopScheduler.add(importConditions(snapshot));
      skip_trialLoopScheduler.add(preRemindRoutineBegin(snapshot));
      skip_trialLoopScheduler.add(preRemindRoutineEachFrame());
      skip_trialLoopScheduler.add(preRemindRoutineEnd(snapshot));
      skip_trialLoopScheduler.add(remindRoutineBegin(snapshot));
      skip_trialLoopScheduler.add(remindRoutineEachFrame());
      skip_trialLoopScheduler.add(remindRoutineEnd(snapshot));
      skip_trialLoopScheduler.add(readyRoutineBegin(snapshot));
      skip_trialLoopScheduler.add(readyRoutineEachFrame());
      skip_trialLoopScheduler.add(readyRoutineEnd(snapshot));
      skip_trialLoopScheduler.add(cntdownRoutineBegin(snapshot));
      skip_trialLoopScheduler.add(cntdownRoutineEachFrame());
      skip_trialLoopScheduler.add(cntdownRoutineEnd(snapshot));
      const blockLoopScheduler = new Scheduler(psychoJS);
      skip_trialLoopScheduler.add(blockLoopBegin(blockLoopScheduler, snapshot));
      skip_trialLoopScheduler.add(blockLoopScheduler);
      skip_trialLoopScheduler.add(blockLoopEnd);
      skip_trialLoopScheduler.add(thanksRoutineBegin(snapshot));
      skip_trialLoopScheduler.add(thanksRoutineEachFrame());
      skip_trialLoopScheduler.add(thanksRoutineEnd(snapshot));
      skip_trialLoopScheduler.add(skip_trialLoopEndIteration(skip_trialLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

function blockLoopBegin(blockLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    block = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 4, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: undefined,
      seed: undefined, name: 'block'
    });
    psychoJS.experiment.addLoop(block); // add the loop to the experiment
    currentLoop = block;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    block.forEach(function() {
      snapshot = block.getSnapshot();
    
      blockLoopScheduler.add(importConditions(snapshot));
      const skip_reminderLoopScheduler = new Scheduler(psychoJS);
      blockLoopScheduler.add(skip_reminderLoopBegin(skip_reminderLoopScheduler, snapshot));
      blockLoopScheduler.add(skip_reminderLoopScheduler);
      blockLoopScheduler.add(skip_reminderLoopEnd);
      const trialsLoopScheduler = new Scheduler(psychoJS);
      blockLoopScheduler.add(trialsLoopBegin(trialsLoopScheduler, snapshot));
      blockLoopScheduler.add(trialsLoopScheduler);
      blockLoopScheduler.add(trialsLoopEnd);
      blockLoopScheduler.add(blockLoopEndIteration(blockLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

function skip_reminderLoopBegin(skip_reminderLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    skip_reminder = new TrialHandler({
      psychoJS: psychoJS,
      nReps: skipReminder, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: undefined,
      seed: undefined, name: 'skip_reminder'
    });
    psychoJS.experiment.addLoop(skip_reminder); // add the loop to the experiment
    currentLoop = skip_reminder;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    skip_reminder.forEach(function() {
      snapshot = skip_reminder.getSnapshot();
    
      skip_reminderLoopScheduler.add(importConditions(snapshot));
      skip_reminderLoopScheduler.add(reminderRoutineBegin(snapshot));
      skip_reminderLoopScheduler.add(reminderRoutineEachFrame());
      skip_reminderLoopScheduler.add(reminderRoutineEnd(snapshot));
      skip_reminderLoopScheduler.add(skip_reminderLoopEndIteration(skip_reminderLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

async function skip_reminderLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(skip_reminder);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function skip_reminderLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      }
    return Scheduler.Event.NEXT;
    }
  };
}

function trialsLoopBegin(trialsLoopScheduler, snapshot) {
  return async function() {
    TrialHandler.fromSnapshot(snapshot); // update internal variables (.thisN etc) of the loop
    
    // set up handler to look after randomisation of conditions etc
    trials = new TrialHandler({
      psychoJS: psychoJS,
      nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
      extraInfo: expInfo, originPath: undefined,
      trialList: TrialHandler.importConditions(psychoJS.serverManager, trialConditions, rowTrial),
      seed: undefined, name: 'trials'
    });
    psychoJS.experiment.addLoop(trials); // add the loop to the experiment
    currentLoop = trials;  // we're now the current loop
    
    // Schedule all the trials in the trialList:
    trials.forEach(function() {
      snapshot = trials.getSnapshot();
    
      trialsLoopScheduler.add(importConditions(snapshot));
      trialsLoopScheduler.add(trialRoutineBegin(snapshot));
      trialsLoopScheduler.add(trialRoutineEachFrame());
      trialsLoopScheduler.add(trialRoutineEnd(snapshot));
      trialsLoopScheduler.add(trialsLoopEndIteration(trialsLoopScheduler, snapshot));
    });
    
    return Scheduler.Event.NEXT;
  }
}

async function trialsLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(trials);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function trialsLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        psychoJS.experiment.nextEntry(snapshot);
      }
    return Scheduler.Event.NEXT;
    }
  };
}

async function blockLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(block);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function blockLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        psychoJS.experiment.nextEntry(snapshot);
      }
    return Scheduler.Event.NEXT;
    }
  };
}

async function skip_trialLoopEnd() {
  // terminate loop
  psychoJS.experiment.removeLoop(skip_trial);
  // update the current loop from the ExperimentHandler
  if (psychoJS.experiment._unfinishedLoops.length>0)
    currentLoop = psychoJS.experiment._unfinishedLoops.at(-1);
  else
    currentLoop = psychoJS.experiment;  // so we use addData from the experiment
  return Scheduler.Event.NEXT;
}

function skip_trialLoopEndIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return async function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      }
    return Scheduler.Event.NEXT;
    }
  };
}

function instr_vivantRoutineBegin(snapshot) {
  return async function () {
    TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
    
    //--- Prepare to start Routine 'instr_vivant' ---
    t = 0;
    instr_vivantClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    // Run 'Begin Routine' code from code_instr_vivant
    if ((english === true)) {
        instr_text_vivant_1.text = instr_text_1_en;
        instr_text_vivant_2.text = instr_text_2_en;
        instr_text_vivant_3.text = instr_text_3_en;
    } else {
        instr_text_vivant_1.text = instr_text_1_fr;
        instr_text_vivant_2.text = instr_text_2_fr;
        instr_text_vivant_3.text = instr_text_3_fr;
    }
    curIns = 1;
    button_down = true;
    if ((current_practice > 1)) {
        practConditions = pracConditions2;
    }
    good_response = 0;
    
    // keep track of which components have finished
    instr_vivantComponents = [];
    instr_vivantComponents.push(instr_text_vivant_1);
    instr_vivantComponents.push(instr_text_vivant_2);
    instr_vivantComponents.push(instr_text_vivant_3);
    instr_vivantComponents.push(instr_text_vivant_4);
    
    instr_vivantComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    return Scheduler.Event.NEXT;
  }
}

function instr_vivantRoutineEachFrame() {
  return async function () {
    //--- Loop for each frame of Routine 'instr_vivant' ---
    // get current time
    t = instr_vivantClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    // Run 'Each Frame' code from code_instr_vivant
    var _pj;
    function _pj_snippets(container) {
        function in_es6(left, right) {
            if (((right instanceof Array) || ((typeof right) === "string"))) {
                return (right.indexOf(left) > (- 1));
            } else {
                if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                    return right.has(left);
                } else {
                    return (left in right);
                }
            }
        }
        container["in_es6"] = in_es6;
        return container;
    }
    _pj = {};
    _pj_snippets(_pj);
    keys = psychoJS.eventManager.getKeys();
    if (((button_down && (! joystick_2.getAllButtons()[0])) && (! _pj.in_es6("1", keys)))) {
        button_down = false;
    }
    if ((((! button_down) && (curIns === 1)) && (joystick_2.getAllButtons()[0] || _pj.in_es6("1", keys)))) {
        button_down = true;
        curIns = (curIns + 1);
    }
    if ((((! button_down) && (curIns >= 2)) && (joystick_2.getAllButtons()[0] || _pj.in_es6("1", keys)))) {
        button_down = true;
        continueRoutine = false;
    }
    
    
    // *instr_text_vivant_1* updates
    if (t >= 0.0 && instr_text_vivant_1.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      instr_text_vivant_1.tStart = t;  // (not accounting for frame time here)
      instr_text_vivant_1.frameNStart = frameN;  // exact frame index
      
      instr_text_vivant_1.setAutoDraw(true);
    }

    if (instr_text_vivant_1.status === PsychoJS.Status.STARTED && Boolean((curIns == 2))) {
      instr_text_vivant_1.setAutoDraw(false);
    }
    
    // *instr_text_vivant_2* updates
    if (((curIns == 2)) && instr_text_vivant_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      instr_text_vivant_2.tStart = t;  // (not accounting for frame time here)
      instr_text_vivant_2.frameNStart = frameN;  // exact frame index
      
      instr_text_vivant_2.setAutoDraw(true);
    }

    if (instr_text_vivant_2.status === PsychoJS.Status.STARTED && Boolean((curIns == 3))) {
      instr_text_vivant_2.setAutoDraw(false);
    }
    
    // *instr_text_vivant_3* updates
    instr_text_vivant_3.setAutoDraw(true);
  }

  
  // *instr_text_vivant_4* updates
  if (((curIns == 4)) && instr_text_vivant_4.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    instr_text_vivant_4.tStart = t;  // (not accounting for frame time here)
    instr_text_vivant_4.frameNStart = frameN;  // exact frame index
    
    instr_text_vivant_4.setAutoDraw(true);
  }

  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  instr_vivantComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function instr_vivantRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'instr_vivant' ---
  instr_vivantComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Run 'End Routine' code from code_instr_vivant
  if ((current_practice === 2)) {
      two_exemple = 2;
  } else {
      two_exemple = 1;
  }
  
  // the Routine "instr_vivant" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function exRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'ex' ---
  t = 0;
  exClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_ex
  var _pj;
  function _pj_snippets(container) {
      function in_es6(left, right) {
          if (((right instanceof Array) || ((typeof right) === "string"))) {
              return (right.indexOf(left) > (- 1));
          } else {
              if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                  return right.has(left);
              } else {
                  return (left in right);
              }
          }
      }
      container["in_es6"] = in_es6;
      return container;
  }
  _pj = {};
  _pj_snippets(_pj);
  trialClock = new core.Clock();
  trialClock.reset();
  timeElapsed = null;
  timeQue = 3;
  timeFix = 3;
  if ((current_practice === 1)) {
      if (_pj.in_es6("V1", expInfo["choiceTrial"])) {
          img1Ex = "images/Tack.bmp";
          img2Ex = "images/File.bmp";
      } else {
          img1Ex = "images/Disk.bmp";
          img2Ex = "images/Baseball.bmp";
      }
      if ((english === true)) {
          que_txtEx.text = "LIVING?";
          ans_yes_ex.text = "YES";
          ans_no_ex.text = "NO";
          text_Ex.text = "Go ahead and answer 'yes' or 'no' whether you think at \nleast one of these practice images is living.";
      } else {
          que_txtEx.text = "VIVANT?";
          ans_yes_ex.text = "OUI";
          ans_no_ex.text = "NON";
          text_Ex.text = "R\u00e9pondez par 'oui' ou par 'non' si vous pensez qu'au \nmoins une de ces images est vivante.";
      }
  } else {
      if ((current_practice === 2)) {
          if (_pj.in_es6("V1", expInfo["choiceTrial"])) {
              img1Ex = "images/HotDog.bmp";
              img2Ex = "images/Chest.bmp";
          } else {
              img1Ex = "images/Lipstick.bmp";
              img2Ex = "images/Hamper.bmp";
          }
          if ((english === true)) {
              que_txtEx.text = "INSIDE?";
              ans_yes_ex.text = "YES";
              ans_no_ex.text = "NO";
              if (_pj.in_es6("V1", expInfo["choiceTrial"])) {
                  text_Ex.text = "In this example there is a hotdog and a chest. You would respond \n'yes' to this example because a hotdog can fit inside a chest. \n\nGo ahead and push the 'yes' for this example.";
              } else {
                  text_Ex.text = "In this example there is a lipstick and a hamper. You would respond \n'yes' to this example because a lipstick can fit inside a hamper. \n\nGo ahead and push the 'yes' for this example.";
              }
          } else {
              que_txtEx.text = "\u00c0 L'INT\u00c9RIEUR?";
              ans_yes_ex.text = "OUI";
              ans_no_ex.text = "NON";
              if (_pj.in_es6("V1", expInfo["choiceTrial"])) {
                  text_Ex.text = "Dans cet exemple, il y a un hot-dog et un coffre. Vous r\u00e9pondriez \n'oui' \u00e0 cet exemple parce qu'un hot-dog peut tenir dans un coffre. \n\nAllez-y et appuyez sur 'oui' pour cet exemple.";
              } else {
                  text_Ex.text = "Dans cet exemple, il y a un rouge \u00e0 l\u00e8vres et un panier. Vous r\u00e9pondriez \n'oui' \u00e0 cet exemple parce qu'un rouge \u00e0 l\u00e8vres peut tenir dans un panier. \n\nAllez-y et appuyez sur 'oui' pour cet exemple.";
              }
          }
      } else {
          if ((current_practice === 3)) {
              if (_pj.in_es6("V1", expInfo["choiceTrial"])) {
                  img1Ex = "images/Chopsticks.bmp";
                  img2Ex = "images/Needle.bmp";
              } else {
                  img1Ex = "images/Kazoo.bmp";
                  img2Ex = "images/Dart.bmp";
              }
              if ((english === true)) {
                  que_txtEx.text = "INSIDE?";
                  ans_yes_ex.text = "YES";
                  ans_no_ex.text = "NO";
                  if (_pj.in_es6("V1", expInfo["choiceTrial"])) {
                      text_Ex.text = "In this example there is a chopsticks and a needle. In this example you \nwould respond 'no' because neither of the objects can fit inside the other. \n\nGo ahead and push the 'no' for this example.";
                  } else {
                      text_Ex.text = "In this example there is a kazoo and a dart. In this example you would \nrespond 'no' because neither of the objects can fit inside the other. \n\nGo ahead and push the 'no' for this example.";
                  }
              } else {
                  que_txtEx.text = "\u00c0 L'INT\u00c9RIEUR?";
                  ans_yes_ex.text = "OUI";
                  ans_no_ex.text = "NON";
                  if (_pj.in_es6("V1", expInfo["choiceTrial"])) {
                      text_Ex.text = "Dans cet exemple, il y a des baguettes et une aiguille. Dans cet exemple, \nvous r\u00e9pondriez 'non' car aucun des objets ne peut entrer dans l'autre. \n\nAllez-y et appuyez sur 'non' pour cet exemple.";
                  } else {
                      text_Ex.text = "Dans cet exemple, il y a un kazoo et une fl\u00e9chette. Dans cet exemple, vous \nr\u00e9pondriez 'non' car aucun des objets ne peut entrer dans l'autre. \n\nAllez-y et appuyez sur 'non' pour cet exemple.";
                  }
              }
          }
      }
  }
  item1_finished = false;
  que_finished = false;
  item2_finished = false;
  participant_answered = false;
  hide_img2 = false;
  no_answers = false;
  display_fix = false;
  response_Ex.text = "";
  
  item1_imgEx.setImage(img1Ex);
  item2_imgEx.setImage(img2Ex);
  key_Ex.keys = undefined;
  key_Ex.rt = undefined;
  _key_Ex_allKeys = [];
  // keep track of which components have finished
  exComponents = [];
  exComponents.push(item1_imgEx);
  exComponents.push(que_txtEx);
  exComponents.push(item2_imgEx);
  exComponents.push(response_Ex);
  exComponents.push(timer_Ex);
  exComponents.push(fix_text_Ex);
  exComponents.push(key_Ex);
  exComponents.push(text_Ex);
  exComponents.push(ans_yes_ex);
  exComponents.push(ans_no_ex);
  
  exComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function exRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'ex' ---
  // get current time
  t = exClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  // Run 'Each Frame' code from code_ex
  var _pj;
  function _pj_snippets(container) {
      function in_es6(left, right) {
          if (((right instanceof Array) || ((typeof right) === "string"))) {
              return (right.indexOf(left) > (- 1));
          } else {
              if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                  return right.has(left);
              } else {
                  return (left in right);
              }
          }
      }
      container["in_es6"] = in_es6;
      return container;
  }
  _pj = {};
  _pj_snippets(_pj);
  if (((button_down && (! joystick_Ex.getAllButtons()[0])) && (! _pj.in_es6("1", key_Ex.keys)))) {
      button_down = false;
  }
  if ((current_practice === 2)) {
      if ((((! item2_finished) && (! button_down)) && (joystick_Ex.getAllButtons()[0] || _pj.in_es6("1", key_Ex.keys)))) {
          button_down = true;
          response_Ex.text = 1;
          participant_answered = true;
      }
  }
  if ((current_practice === 3)) {
      if ((((! item2_finished) && (! button_down)) && (joystick_Ex.getAllButtons()[2] || _pj.in_es6("2", key_Ex.keys)))) {
          button_down = true;
          response_Ex.text = 2;
          participant_answered = true;
      }
  }
  if ((current_practice === 1)) {
      if ((((! item2_finished) && (! button_down)) && (joystick_Ex.getAllButtons()[0] || _pj.in_es6("1", key_Ex.keys)))) {
          button_down = true;
          response_Ex.text = 1;
          participant_answered = true;
      } else {
          if ((((! item2_finished) && (! button_down)) && (joystick_Ex.getAllButtons()[2] || _pj.in_es6("2", key_Ex.keys)))) {
              button_down = true;
              response_Ex.text = 2;
              participant_answered = true;
          } else {
              if ((((! no_answers) && (! participant_answered)) && (timer_Ex.status === PsychoJS.Status.FINISHED))) {
                  response_Ex.finished = true;
                  no_answers = true;
              }
          }
      }
  }
  if ((timer_Ex.status === PsychoJS.Status.FINISHED)) {
      response_Ex.finished = true;
      display_fix = true;
      continueRoutine = false;
  }
  
  
  // *item1_imgEx* updates
  if (t >= 0.0 && item1_imgEx.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    item1_imgEx.tStart = t;  // (not accounting for frame time here)
    item1_imgEx.frameNStart = frameN;  // exact frame index
    
    item1_imgEx.setAutoDraw(true);
  }

  if (item1_imgEx.status === PsychoJS.Status.STARTED && Boolean(participant_answered)) {
    item1_imgEx.setAutoDraw(false);
  }
  
  // *que_txtEx* updates
  if (t >= 0 && que_txtEx.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    que_txtEx.tStart = t;  // (not accounting for frame time here)
    que_txtEx.frameNStart = frameN;  // exact frame index
    
    que_txtEx.setAutoDraw(true);
  }

  if (que_txtEx.status === PsychoJS.Status.STARTED && Boolean(participant_answered)) {
    que_txtEx.setAutoDraw(false);
  }
  
  // *item2_imgEx* updates
  if (t >= 0 && item2_imgEx.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    item2_imgEx.tStart = t;  // (not accounting for frame time here)
    item2_imgEx.frameNStart = frameN;  // exact frame index
    
    item2_imgEx.setAutoDraw(true);
  }

  if (item2_imgEx.status === PsychoJS.Status.STARTED && Boolean(participant_answered)) {
    item2_imgEx.setAutoDraw(false);
  }
  
  // *response_Ex* updates
  if (t >= 0 && response_Ex.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    response_Ex.tStart = t;  // (not accounting for frame time here)
    response_Ex.frameNStart = frameN;  // exact frame index
    
    response_Ex.setAutoDraw(true);
  }

  if (response_Ex.status === PsychoJS.Status.STARTED && Boolean(participant_answered)) {
    response_Ex.setAutoDraw(false);
  }
  
  // *timer_Ex* updates
  if (t >= 0 && timer_Ex.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    timer_Ex.tStart = t;  // (not accounting for frame time here)
    timer_Ex.frameNStart = frameN;  // exact frame index
    
    timer_Ex.setAutoDraw(true);
  }

  if (timer_Ex.status === PsychoJS.Status.STARTED && Boolean(participant_answered)) {
    timer_Ex.setAutoDraw(false);
  }
  
  // *fix_text_Ex* updates
  if (((display_fix == 1)) && fix_text_Ex.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fix_text_Ex.tStart = t;  // (not accounting for frame time here)
    fix_text_Ex.frameNStart = frameN;  // exact frame index
    
    fix_text_Ex.setAutoDraw(true);
  }

  if (fix_text_Ex.status === PsychoJS.Status.STARTED && t >= (fix_text_Ex.tStart + timeFix)) {
    fix_text_Ex.setAutoDraw(false);
  }
  
  // *key_Ex* updates
  if (t >= 0.0 && key_Ex.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_Ex.tStart = t;  // (not accounting for frame time here)
    key_Ex.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_Ex.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_Ex.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_Ex.clearEvents(); });
  }

  if (key_Ex.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_Ex.getKeys({keyList: ['1', '2', 'esc'], waitRelease: false});
    _key_Ex_allKeys = _key_Ex_allKeys.concat(theseKeys);
    if (_key_Ex_allKeys.length > 0) {
      key_Ex.keys = _key_Ex_allKeys[_key_Ex_allKeys.length - 1].name;  // just the last key pressed
      key_Ex.rt = _key_Ex_allKeys[_key_Ex_allKeys.length - 1].rt;
      key_Ex.duration = _key_Ex_allKeys[_key_Ex_allKeys.length - 1].duration;
    }
  }
  
  
  // *text_Ex* updates
  if (t >= 0.0 && text_Ex.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    text_Ex.tStart = t;  // (not accounting for frame time here)
    text_Ex.frameNStart = frameN;  // exact frame index
    
    text_Ex.setAutoDraw(true);
  }

  
  // *ans_yes_ex* updates
  if (t >= 0.0 && ans_yes_ex.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    ans_yes_ex.tStart = t;  // (not accounting for frame time here)
    ans_yes_ex.frameNStart = frameN;  // exact frame index
    
    ans_yes_ex.setAutoDraw(true);
  }

  if (ans_yes_ex.status === PsychoJS.Status.STARTED && Boolean(participant_answered)) {
    ans_yes_ex.setAutoDraw(false);
  }
  
  // *ans_no_ex* updates
  if (t >= 0.0 && ans_no_ex.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    ans_no_ex.tStart = t;  // (not accounting for frame time here)
    ans_no_ex.frameNStart = frameN;  // exact frame index
    
    ans_no_ex.setAutoDraw(true);
  }

  if (ans_no_ex.status === PsychoJS.Status.STARTED && Boolean(participant_answered)) {
    ans_no_ex.setAutoDraw(false);
  }
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  exComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function exRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'ex' ---
  exComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Run 'End Routine' code from code_ex
  participant_answered = false;
  if ((current_practice === 2)) {
      current_practice += 1;
  } else {
      if ((current_practice === 3)) {
          current_practice -= 1;
      }
  }
  
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key_Ex.corr, level);
  }
  psychoJS.experiment.addData('key_Ex.keys', key_Ex.keys);
  if (typeof key_Ex.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key_Ex.rt', key_Ex.rt);
      psychoJS.experiment.addData('key_Ex.duration', key_Ex.duration);
      }
  
  key_Ex.stop();
  // the Routine "ex" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function next_instrRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'next_instr' ---
  t = 0;
  next_instrClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_next_instr
  if ((current_practice === 1)) {
      if ((english === true)) {
          text_next_instr.text = "Now we are going to try some practice items. \nAfter each pair of items, there will be a fixation\n cross (+). You should look at this cross when \nthere are no images on the screen.\n\nDo you have any questions before we start?\nRemember to respond as quickly as you can!\n\nRespond 'yes' to begin the practice.";
      } else {
          text_next_instr.text = "Nous allons maintenant essayer quelques objets\n de pratique. Apr\u00e8s chaque paire d'objets, il y aura\n une croix de fixation (+). Vous devez regarder\n cette croix lorsqu'il n'y a pas d'images \u00e0 l'\u00e9cran.\n\nAvez-vous des questions avant de commencer?\n\nSouvenez-vous de r\u00e9pondre aussi rapidement que possible!\n\nR\u00e9pondez 'oui' pour commencer la pratique.";
      }
  } else {
      if ((current_practice === 2)) {
          if ((english === true)) {
              text_next_instr.text = "Now we are going to try some practice items. \nAfter each pair of items, there will be a fixation\n cross (+). You should look at this cross when \nthere are no images on the screen.\n\nDo you have any questions before we start?\nRemember to respond as quickly as you can!\n\nRespond 'yes' to begin the practice.";
          } else {
              text_next_instr.text = "Nous allons maintenant essayer quelques objets\n de pratique. Apr\u00e8s chaque paire d'objets, il y aura\n une croix de fixation (+). Vous devez regarder\n cette croix lorsqu'il n'y a pas d'images \u00e0 l'\u00e9cran.\n\nAvez-vous des questions avant de commencer?\n\nSouvenez-vous de r\u00e9pondre aussi rapidement que possible!\n\nR\u00e9pondez 'oui' pour commencer la pratique.";
          }
      }
  }
  
  key_next_instr.keys = undefined;
  key_next_instr.rt = undefined;
  _key_next_instr_allKeys = [];
  // keep track of which components have finished
  next_instrComponents = [];
  next_instrComponents.push(text_next_instr);
  next_instrComponents.push(key_next_instr);
  
  next_instrComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function next_instrRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'next_instr' ---
  // get current time
  t = next_instrClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  // Run 'Each Frame' code from code_next_instr
  if ((button_down && (! joystick_3.getAllButtons()[0]))) {
      button_down = false;
  }
  if (((! button_down) && joystick_3.getAllButtons()[0])) {
      button_down = true;
      continueRoutine = false;
  }
  
  
  // *text_next_instr* updates
  if (t >= 0.0 && text_next_instr.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    text_next_instr.tStart = t;  // (not accounting for frame time here)
    text_next_instr.frameNStart = frameN;  // exact frame index
    
    text_next_instr.setAutoDraw(true);
  }

  
  // *key_next_instr* updates
  if (t >= 0.0 && key_next_instr.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_next_instr.tStart = t;  // (not accounting for frame time here)
    key_next_instr.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_next_instr.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_next_instr.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_next_instr.clearEvents(); });
  }

  if (key_next_instr.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_next_instr.getKeys({keyList: ['1'], waitRelease: false});
    _key_next_instr_allKeys = _key_next_instr_allKeys.concat(theseKeys);
    if (_key_next_instr_allKeys.length > 0) {
      key_next_instr.keys = _key_next_instr_allKeys[_key_next_instr_allKeys.length - 1].name;  // just the last key pressed
      key_next_instr.rt = _key_next_instr_allKeys[_key_next_instr_allKeys.length - 1].rt;
      key_next_instr.duration = _key_next_instr_allKeys[_key_next_instr_allKeys.length - 1].duration;
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  next_instrComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function next_instrRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'next_instr' ---
  next_instrComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key_next_instr.corr, level);
  }
  psychoJS.experiment.addData('key_next_instr.keys', key_next_instr.keys);
  if (typeof key_next_instr.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key_next_instr.rt', key_next_instr.rt);
      psychoJS.experiment.addData('key_next_instr.duration', key_next_instr.duration);
      routineTimer.reset();
      }
  
  key_next_instr.stop();
  // the Routine "next_instr" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function practRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'pract' ---
  t = 0;
  practClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_pr
  trialClock = new core.Clock();
  trialClock.reset();
  timeElapsed = null;
  img1 = LeftStim;
  img2 = RightStim;
  timeQue = (DurationQuestion / 1000);
  timeFix = (FixDelay / 1000);
  item1_finished = false;
  que_finished = false;
  item2_finished = false;
  participant_answered = false;
  no_answers = false;
  im2pratRT = null;
  response_pr = 0;
  display_fix = false;
  lenght = 0;
  time_last_responses_pract = 0;
  first_frame = true;
  startTime = 0;
  joyst = 0;
  if ((english === true)) {
      ans_yes_prac.text = "YES";
      ans_no_prac.text = "NO";
      que_text_pr.text = QuestionEnglish;
  } else {
      que_text_pr.text = QuestionFrench;
      ans_yes_prac.text = "OUI";
      ans_no_prac.text = "NON";
  }
  
  item1_img_pr.setImage(img1);
  item2_img_pr.setImage(img2);
  key_prac.keys = undefined;
  key_prac.rt = undefined;
  _key_prac_allKeys = [];
  // keep track of which components have finished
  practComponents = [];
  practComponents.push(ans_no_prac);
  practComponents.push(ans_yes_prac);
  practComponents.push(item1_img_pr);
  practComponents.push(que_text_pr);
  practComponents.push(item2_img_pr);
  practComponents.push(timer_pr);
  practComponents.push(timer_timed_pr);
  practComponents.push(fix_text_pr);
  practComponents.push(key_prac);
  
  practComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function practRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'pract' ---
  // get current time
  t = practClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  // Run 'Each Frame' code from code_pr
  if ((button_down && (! joystick_prac.getAllButtons()[1]))) {
      button_down = false;
  }
  if (first_frame) {
      startTime = joystick_prac.joystickClock.getTime();
      first_frame = false;
  }
  if ((key_prac.keys.length > 0)) {
      if (((key_prac.keys.slice((- 1))[0] === "e") || (key_prac.keys.slice((- 1))[0] === "escape"))) {
          core.quit();
      }
  }
  if (((key_prac.keys.length > lenght) && (! item2_finished))) {
      if ((key_prac.keys.slice((- 1))[0] === "1")) {
          response_pr = 1;
          participant_answered = true;
          lenght = key_prac.keys.length;
          time_last_responses_pract = key_prac.rt.slice((- 1))[0];
      } else {
          if ((key_prac.keys.slice((- 1))[0] === "2")) {
              response_pr = 2;
              participant_answered = true;
              lenght = key_prac.keys.length;
              time_last_responses_pract = key_prac.rt.slice((- 1))[0];
          }
      }
  } else {
      if ((((! item2_finished) && (! button_down)) && joystick_prac.getAllButtons()[1])) {
          response_pr = 1;
          participant_answered = true;
          button_down = true;
          psychoJS.experiment.addData(`pressedbuttonJ${joyst}`, 1);
          psychoJS.experiment.addData(`timebuttonJ${joyst}`, (joystick_prac.joystickClock.getTime() - startTime));
          joyst += 1;
          time_last_responses_pract = (joystick_prac.joystickClock.getTime() - startTime);
      } else {
          if ((((! item2_finished) && (! button_down)) && joystick_prac.getAllButtons()[2])) {
              response_pr = 2;
              participant_answered = true;
              button_down = true;
              psychoJS.experiment.addData(`pressedbuttonJ${joyst}`, 2);
              psychoJS.experiment.addData(`timebuttonJ${joyst}`, (joystick_prac.joystickClock.getTime() - startTime));
              joyst += 1;
              time_last_responses_pract = (joystick_prac.joystickClock.getTime() - startTime);
          } else {
              if ((((! no_answers) && (! participant_answered)) && (timer_pr.status === PsychoJS.Status.FINISHED))) {
                  no_answers = true;
              }
          }
      }
  }
  if ((((item2_img_pr.status === PsychoJS.Status.FINISHED) && (! item2_finished)) && (! no_answers))) {
      item2_finished = true;
  }
  if ((timer_pr.status === PsychoJS.Status.FINISHED)) {
      response_pr.finished = true;
      display_fix = true;
  }
  if ((fix_text_pr.status === PsychoJS.Status.FINISHED)) {
      continueRoutine = false;
  }
  
  
  // *ans_no_prac* updates
  if (t >= 0.0 && ans_no_prac.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    ans_no_prac.tStart = t;  // (not accounting for frame time here)
    ans_no_prac.frameNStart = frameN;  // exact frame index
    
    ans_no_prac.setAutoDraw(true);
  }

  if (ans_no_prac.status === PsychoJS.Status.STARTED && Boolean(show_img)) {
    ans_no_prac.setAutoDraw(false);
  }
  
  // *ans_yes_prac* updates
  if (t >= 0.0 && ans_yes_prac.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    ans_yes_prac.tStart = t;  // (not accounting for frame time here)
    ans_yes_prac.frameNStart = frameN;  // exact frame index
    
    ans_yes_prac.setAutoDraw(true);
  }

  if (ans_yes_prac.status === PsychoJS.Status.STARTED && Boolean(show_img)) {
    ans_yes_prac.setAutoDraw(false);
  }
  
  // *item1_img_pr* updates
  if (t >= 0.0 && item1_img_pr.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    item1_img_pr.tStart = t;  // (not accounting for frame time here)
    item1_img_pr.frameNStart = frameN;  // exact frame index
    
    item1_img_pr.setAutoDraw(true);
  }

  if (item1_img_pr.status === PsychoJS.Status.STARTED && Boolean(show_img)) {
    item1_img_pr.setAutoDraw(false);
  }
  
  // *que_text_pr* updates
  if (t >= 0 && que_text_pr.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    que_text_pr.tStart = t;  // (not accounting for frame time here)
    que_text_pr.frameNStart = frameN;  // exact frame index
    
    que_text_pr.setAutoDraw(true);
  }

  if (que_text_pr.status === PsychoJS.Status.STARTED && Boolean(show_img)) {
    que_text_pr.setAutoDraw(false);
  }
  
  // *item2_img_pr* updates
  if (t >= 0 && item2_img_pr.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    item2_img_pr.tStart = t;  // (not accounting for frame time here)
    item2_img_pr.frameNStart = frameN;  // exact frame index
    
    item2_img_pr.setAutoDraw(true);
  }

  if (item2_img_pr.status === PsychoJS.Status.STARTED && Boolean(show_img)) {
    item2_img_pr.setAutoDraw(false);
  }
  
  // *timer_pr* updates
  if (t >= 0 && timer_pr.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    timer_pr.tStart = t;  // (not accounting for frame time here)
    timer_pr.frameNStart = frameN;  // exact frame index
    
    timer_pr.setAutoDraw(true);
  }

  if (timer_pr.status === PsychoJS.Status.STARTED && Boolean(participant_answered)) {
    timer_pr.setAutoDraw(false);
  }
  
  // *timer_timed_pr* updates
  if (t >= 0 && timer_timed_pr.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    timer_timed_pr.tStart = t;  // (not accounting for frame time here)
    timer_timed_pr.frameNStart = frameN;  // exact frame index
    
    timer_timed_pr.setAutoDraw(true);
  }

  frameRemains = 0 + timer_time - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (timer_timed_pr.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    timer_timed_pr.setAutoDraw(false);
  }
  
  // *fix_text_pr* updates
  if (((display_fix == 1)) && fix_text_pr.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fix_text_pr.tStart = t;  // (not accounting for frame time here)
    fix_text_pr.frameNStart = frameN;  // exact frame index
    
    fix_text_pr.setAutoDraw(true);
  }

  if (fix_text_pr.status === PsychoJS.Status.STARTED && t >= (fix_text_pr.tStart + timeFix)) {
    fix_text_pr.setAutoDraw(false);
  }
  
  // *key_prac* updates
  if (t >= 0.0 && key_prac.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_prac.tStart = t;  // (not accounting for frame time here)
    key_prac.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_prac.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_prac.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_prac.clearEvents(); });
  }

  if (key_prac.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_prac.getKeys({keyList: [], waitRelease: false});
    _key_prac_allKeys = _key_prac_allKeys.concat(theseKeys);
    if (_key_prac_allKeys.length > 0) {
      key_prac.keys = _key_prac_allKeys.map((key) => key.name);  // storing all keys
      key_prac.rt = _key_prac_allKeys.map((key) => key.rt);
      key_prac.duration = _key_prac_allKeys.map((key) => key.duration);
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  practComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function practRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'pract' ---
  practComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Run 'End Routine' code from code_pr
  psychoJS.experiment.addData("imprat.RESP", response_pr);
  psychoJS.experiment.addData("imprat.CRESP", CorrectResponse);
  if ((response_pr === CorrectResponse)) {
      psychoJS.experiment.addData("imprat.ACC", 1);
      good_response += 1;
  } else {
      if (((response_pr === 1) || (response_pr === 2))) {
          psychoJS.experiment.addData("imprat.ACC", 0);
      } else {
          psychoJS.experiment.addData("imprat.ACC", "");
      }
  }
  if ((response_pr !== 0)) {
      psychoJS.experiment.addData("imprat.RT", time_last_responses_pract);
  } else {
      psychoJS.experiment.addData("imprat.RT", "");
  }
  psychoJS.experiment.addData("imprat.RTTime", (que_text_pr.tStartRefresh + time_last_responses_pract));
  item2_img_pr.opacity = 1;
  participant_answered = false;
  
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key_prac.corr, level);
  }
  psychoJS.experiment.addData('key_prac.keys', key_prac.keys);
  if (typeof key_prac.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key_prac.rt', key_prac.rt);
      psychoJS.experiment.addData('key_prac.duration', key_prac.duration);
      }
  
  key_prac.stop();
  // the Routine "pract" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function transition1RoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'transition1' ---
  t = 0;
  transition1Clock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_transi_1
  if ((english === true)) {
      if ((timedAns !== 5)) {
          txt_transi1.text = `You did not respond to all of the trials.
  Please try the practice again.`
  ;
      } else {
          txt_transi1.text = `Great job, you have completed the practice!`;
      }
  } else {
      if ((timedAns !== 5)) {
          txt_transi1.text = `Vous n'avez pas répondu à tous les essais.
  Veuillez essayer à nouveau la pratique.`
  ;
      } else {
          txt_transi1.text = `Bravo, vous avez terminé la pratique!`;
      }
  }
  key1pressed = false;
  key2pressed = false;
  
  key_transi1.keys = undefined;
  key_transi1.rt = undefined;
  _key_transi1_allKeys = [];
  // keep track of which components have finished
  transition1Components = [];
  transition1Components.push(txt_transi1);
  transition1Components.push(key_transi1);
  
  transition1Components.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function transition1RoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'transition1' ---
  // get current time
  t = transition1Clock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  // Run 'Each Frame' code from code_transi_1
  var _pj;
  function _pj_snippets(container) {
      function in_es6(left, right) {
          if (((right instanceof Array) || ((typeof right) === "string"))) {
              return (right.indexOf(left) > (- 1));
          } else {
              if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                  return right.has(left);
              } else {
                  return (left in right);
              }
          }
      }
      container["in_es6"] = in_es6;
      return container;
  }
  _pj = {};
  _pj_snippets(_pj);
  if (((button_down && (! joystick_3.getAllButtons()[1])) && (! _pj.in_es6("1", key_transi1.keys)))) {
      button_down = false;
  }
  if ((_pj.in_es6("r", key_transi1.keys) && (! button_down))) {
      timedAns = 0;
      button_down = true;
      continueRoutine = false;
  } else {
      if ((_pj.in_es6("space", key_transi1.keys) && (! button_down))) {
          timedAns = 0;
          button_down = true;
          practice.finished = true;
          prac_repeat.finished = true;
          continueRoutine = false;
          current_practice += 1;
      }
  }
  good_response = 0;
  
  
  // *txt_transi1* updates
  if (t >= 0.0 && txt_transi1.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    txt_transi1.tStart = t;  // (not accounting for frame time here)
    txt_transi1.frameNStart = frameN;  // exact frame index
    
    txt_transi1.setAutoDraw(true);
  }

  
  // *key_transi1* updates
  if (t >= 0.0 && key_transi1.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_transi1.tStart = t;  // (not accounting for frame time here)
    key_transi1.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_transi1.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_transi1.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_transi1.clearEvents(); });
  }

  if (key_transi1.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_transi1.getKeys({keyList: ['space', 'r', 'esc'], waitRelease: false});
    _key_transi1_allKeys = _key_transi1_allKeys.concat(theseKeys);
    if (_key_transi1_allKeys.length > 0) {
      key_transi1.keys = _key_transi1_allKeys[_key_transi1_allKeys.length - 1].name;  // just the last key pressed
      key_transi1.rt = _key_transi1_allKeys[_key_transi1_allKeys.length - 1].rt;
      key_transi1.duration = _key_transi1_allKeys[_key_transi1_allKeys.length - 1].duration;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  transition1Components.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function transition1RoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'transition1' ---
  transition1Components.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Run 'End Routine' code from code_transi_1
  timedAns = 0;
  
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key_transi1.corr, level);
  }
  psychoJS.experiment.addData('key_transi1.keys', key_transi1.keys);
  if (typeof key_transi1.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key_transi1.rt', key_transi1.rt);
      psychoJS.experiment.addData('key_transi1.duration', key_transi1.duration);
      }
  
  key_transi1.stop();
  // the Routine "transition1" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function preRemindRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'preRemind' ---
  t = 0;
  preRemindClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  // update component parameters for each repeat
  // Run 'Begin Routine' code from codePreRemind
  if ((english === true)) {
      textPreRemind.text = "There are going to be several blocks where \nyou will be asked to make a \u2018yes\u2019 or \u2018no\u2019 response\n to the question \u2018Living\u2019 or \u2018Inside\u2019.";
      textPreRemind_2.text = " You will see which question you should answer before \neach block begins and the question (\u2018Living?\u2019 or \u2018Inside?\u2019) \nwill be displayed under each pair of images.";
      ansYesPreRemind.text = "YES";
      ansNoPreRemind.text = "NO";
  } else {
      textPreRemind.text = "Il y aura plusieurs blocs o\u00f9 il vous sera \ndemand\u00e9 de r\u00e9pondre par 'oui' ou 'non' \u00e0 la question \n'Vivant' ou '\u00c0 l'int\u00e9rieur'.";
      textPreRemind_2.text = "Vous verrez quelle question vous devez r\u00e9pondre avant le d\u00e9but \nde chaque bloc et la question ('Vivant?' ou '\u00c0 l'int\u00e9rieur?') \nsera affich\u00e9e sous chaque paire d'images.";
      ansYesPreRemind.text = "OUI";
      ansNoPreRemind.text = "NON";
  }
  
  keyPreRemind.keys = undefined;
  keyPreRemind.rt = undefined;
  _keyPreRemind_allKeys = [];
  // keep track of which components have finished
  preRemindComponents = [];
  preRemindComponents.push(textPreRemind);
  preRemindComponents.push(textPreRemind_2);
  preRemindComponents.push(keyPreRemind);
  preRemindComponents.push(ansYesPreRemind);
  preRemindComponents.push(ansNoPreRemind);
  preRemindComponents.push(polygonYes);
  preRemindComponents.push(polygonNo);
  
  preRemindComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function preRemindRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'preRemind' ---
  // get current time
  t = preRemindClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  // Run 'Each Frame' code from codePreRemind
  if ((button_down && (! joystickPreRemind.getAllButtons()[1]))) {
      button_down = false;
  }
  if (((! button_down) && joystickPreRemind.getAllButtons()[1])) {
      button_down = true;
      continueRoutine = false;
  }
  if ((keyPreRemind.keys.length !== lenghtRemind)) {
      if ((keyPreRemind.keys.slice((- 1))[0] === "escape")) {
          core.quit();
      } else {
          if ((keyPreRemind.keys.slice((- 1))[0] === "space")) {
              continueRoutine = false;
          } else {
              if ((keyPreRemind.keys.slice((- 1))[0] === "1")) {
                  timerRemind = new core.Clock();
                  buttonSelector(polygonYes);
                  lenghtRemind = keyPreRemind.keys.length;
              } else {
                  if ((keyPreRemind.keys.slice((- 1))[0] === "2")) {
                      timerRemind = new core.Clock();
                      buttonSelector(polygonNo);
                      lenghtRemind = keyPreRemind.keys.length;
                  }
              }
          }
      }
  }
  if ((timerRemind !== null)) {
      if ((timerRemind.getTime() > 1)) {
          polygonNo.fillColor = [1, 1, 1];
          polygonYes.fillColor = [1, 1, 1];
          timerRemind = null;
      }
  }
  
  
  // *textPreRemind* updates
  if (t >= 0.0 && textPreRemind.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    textPreRemind.tStart = t;  // (not accounting for frame time here)
    textPreRemind.frameNStart = frameN;  // exact frame index
    
    textPreRemind.setAutoDraw(true);
  }

  
  // *textPreRemind_2* updates
  if (t >= 0.0 && textPreRemind_2.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    textPreRemind_2.tStart = t;  // (not accounting for frame time here)
    textPreRemind_2.frameNStart = frameN;  // exact frame index
    
    textPreRemind_2.setAutoDraw(true);
  }

  
  // *keyPreRemind* updates
  if (t >= 0.0 && keyPreRemind.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    keyPreRemind.tStart = t;  // (not accounting for frame time here)
    keyPreRemind.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { keyPreRemind.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { keyPreRemind.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { keyPreRemind.clearEvents(); });
  }

  if (keyPreRemind.status === PsychoJS.Status.STARTED) {
    let theseKeys = keyPreRemind.getKeys({keyList: [], waitRelease: false});
    _keyPreRemind_allKeys = _keyPreRemind_allKeys.concat(theseKeys);
    if (_keyPreRemind_allKeys.length > 0) {
      keyPreRemind.keys = _keyPreRemind_allKeys.map((key) => key.name);  // storing all keys
      keyPreRemind.rt = _keyPreRemind_allKeys.map((key) => key.rt);
      keyPreRemind.duration = _keyPreRemind_allKeys.map((key) => key.duration);
    }
  }
  
  
  // *ansYesPreRemind* updates
  if (t >= 0.0 && ansYesPreRemind.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    ansYesPreRemind.tStart = t;  // (not accounting for frame time here)
    ansYesPreRemind.frameNStart = frameN;  // exact frame index
    
    ansYesPreRemind.setAutoDraw(true);
  }

  
  // *ansNoPreRemind* updates
  if (t >= 0.0 && ansNoPreRemind.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    ansNoPreRemind.tStart = t;  // (not accounting for frame time here)
    ansNoPreRemind.frameNStart = frameN;  // exact frame index
    
    ansNoPreRemind.setAutoDraw(true);
  }

  
  // *polygonYes* updates
  if (t >= 0.0 && polygonYes.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    polygonYes.tStart = t;  // (not accounting for frame time here)
    polygonYes.frameNStart = frameN;  // exact frame index
    
    polygonYes.setAutoDraw(true);
  }

  
  // *polygonNo* updates
  if (t >= 0.0 && polygonNo.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    polygonNo.tStart = t;  // (not accounting for frame time here)
    polygonNo.frameNStart = frameN;  // exact frame index
    
    polygonNo.setAutoDraw(true);
  }

  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  preRemindComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function preRemindRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'preRemind' ---
  preRemindComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(keyPreRemind.corr, level);
  }
  psychoJS.experiment.addData('keyPreRemind.keys', keyPreRemind.keys);
  if (typeof keyPreRemind.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('keyPreRemind.rt', keyPreRemind.rt);
      psychoJS.experiment.addData('keyPreRemind.duration', keyPreRemind.duration);
      }
  
  keyPreRemind.stop();
  // the Routine "preRemind" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function remindRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'remind' ---
  t = 0;
  remindClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  routineTimer.add(6.000000);
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_remind
  if ((english === true)) {
      title_remind.text = "Living?";
      text_remind.text = "Reminder: \nRespond \u2018yes\u2019 (index finger). \nRespond \u2018no\u2019 (middle finger).";
  } else {
      title_remind.text = "Vivant?";
      text_remind.text = "Rappel: \nR\u00e9pondez 'oui' (index). \nR\u00e9pondez 'non' (majeur).";
  }
  
  // keep track of which components have finished
  remindComponents = [];
  remindComponents.push(title_remind);
  remindComponents.push(text_remind);
  
  remindComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function remindRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'remind' ---
  // get current time
  t = remindClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *title_remind* updates
  if (t >= 0.0 && title_remind.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    title_remind.tStart = t;  // (not accounting for frame time here)
    title_remind.frameNStart = frameN;  // exact frame index
    
    title_remind.setAutoDraw(true);
  }

  frameRemains = 0.0 + 6 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (title_remind.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    title_remind.setAutoDraw(false);
  }
  
  // *text_remind* updates
  if (t >= 0.0 && text_remind.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    text_remind.tStart = t;  // (not accounting for frame time here)
    text_remind.frameNStart = frameN;  // exact frame index
    
    text_remind.setAutoDraw(true);
  }

  frameRemains = 0.0 + 6 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (text_remind.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    text_remind.setAutoDraw(false);
  }
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  remindComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine && routineTimer.getTime() > 0) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function remindRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'remind' ---
  remindComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function readyRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'ready' ---
  t = 0;
  readyClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_rdy
  if ((english === true)) {
      txt_rdy.text = "GET READY!";
  } else {
      txt_rdy.text = "SOYEZ PR\u00caT!";
  }
  
  key_rdy.keys = undefined;
  key_rdy.rt = undefined;
  _key_rdy_allKeys = [];
  // keep track of which components have finished
  readyComponents = [];
  readyComponents.push(txt_rdy);
  readyComponents.push(key_rdy);
  
  readyComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function readyRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'ready' ---
  // get current time
  t = readyClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  // Run 'Each Frame' code from code_rdy
  if ((key_rdy.keys.length > 0)) {
      if ((key_rdy.keys.slice((- 1))[0] === "escape")) {
          core.quit();
      } else {
          if (((key_rdy.keys.slice((- 1))[0] === "5") || (key_rdy.keys.slice((- 1))[0] === 5))) {
              first_pulse = key_rdy.rt.slice((- 1))[0];
              continueRoutine = false;
          }
      }
  }
  
  
  // *txt_rdy* updates
  if (t >= 0.0 && txt_rdy.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    txt_rdy.tStart = t;  // (not accounting for frame time here)
    txt_rdy.frameNStart = frameN;  // exact frame index
    
    txt_rdy.setAutoDraw(true);
  }

  
  // *key_rdy* updates
  if (t >= 0.0 && key_rdy.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_rdy.tStart = t;  // (not accounting for frame time here)
    key_rdy.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_rdy.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_rdy.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_rdy.clearEvents(); });
  }

  if (key_rdy.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_rdy.getKeys({keyList: [], waitRelease: false});
    _key_rdy_allKeys = _key_rdy_allKeys.concat(theseKeys);
    if (_key_rdy_allKeys.length > 0) {
      key_rdy.keys = _key_rdy_allKeys.map((key) => key.name);  // storing all keys
      key_rdy.rt = _key_rdy_allKeys.map((key) => key.rt);
      key_rdy.duration = _key_rdy_allKeys.map((key) => key.duration);
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  readyComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function readyRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'ready' ---
  readyComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key_rdy.corr, level);
  }
  psychoJS.experiment.addData('key_rdy.keys', key_rdy.keys);
  if (typeof key_rdy.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key_rdy.rt', key_rdy.rt);
      psychoJS.experiment.addData('key_rdy.duration', key_rdy.duration);
      routineTimer.reset();
      }
  
  key_rdy.stop();
  // the Routine "ready" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function cntdownRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'cntdown' ---
  t = 0;
  cntdownClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  routineTimer.add(5.000000);
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_ctdown
  
          // add-on: list(s: string): string[]
          function list(s) {
              // if s is a string, we return a list of its characters
              if (typeof s === 'string')
                  return s.split('');
              else
                  // otherwise we return s:
                  return s;
          }
  
          signal_received = true;
  signal_times = list();
  
  key_ctdown.keys = undefined;
  key_ctdown.rt = undefined;
  _key_ctdown_allKeys = [];
  // keep track of which components have finished
  cntdownComponents = [];
  cntdownComponents.push(timer_ctdown);
  cntdownComponents.push(key_ctdown);
  
  cntdownComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function cntdownRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'cntdown' ---
  // get current time
  t = cntdownClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  // Run 'Each Frame' code from code_ctdown
  var _pj;
  function _pj_snippets(container) {
      function in_es6(left, right) {
          if (((right instanceof Array) || ((typeof right) === "string"))) {
              return (right.indexOf(left) > (- 1));
          } else {
              if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                  return right.has(left);
              } else {
                  return (left in right);
              }
          }
      }
      container["in_es6"] = in_es6;
      return container;
  }
  _pj = {};
  _pj_snippets(_pj);
  keys = psychoJS.eventManager.getKeys();
  if ((signal_received && (! _pj.in_es6("5", keys)))) {
      signal_received = false;
  }
  if (((! signal_received) && _pj.in_es6("5", keys))) {
      signal_times.push(t);
      signal_received = true;
  }
  
  
  // *timer_ctdown* updates
  if (t >= 0.0 && timer_ctdown.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    timer_ctdown.tStart = t;  // (not accounting for frame time here)
    timer_ctdown.frameNStart = frameN;  // exact frame index
    
    timer_ctdown.setAutoDraw(true);
  }

  frameRemains = 0.0 + 5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (timer_ctdown.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    timer_ctdown.setAutoDraw(false);
  }
  
  if (timer_ctdown.status === PsychoJS.Status.STARTED){ // only update if being drawn
    timer_ctdown.setText(int(abs(round((5 - t), ndigits=1))), false);
  }
  
  // *key_ctdown* updates
  if (t >= 0.0 && key_ctdown.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_ctdown.tStart = t;  // (not accounting for frame time here)
    key_ctdown.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_ctdown.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_ctdown.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_ctdown.clearEvents(); });
  }

  frameRemains = 0.0 + 5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (key_ctdown.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    key_ctdown.status = PsychoJS.Status.FINISHED;
  }

  if (key_ctdown.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_ctdown.getKeys({keyList: ['esc'], waitRelease: false});
    _key_ctdown_allKeys = _key_ctdown_allKeys.concat(theseKeys);
    if (_key_ctdown_allKeys.length > 0) {
      key_ctdown.keys = _key_ctdown_allKeys[_key_ctdown_allKeys.length - 1].name;  // just the last key pressed
      key_ctdown.rt = _key_ctdown_allKeys[_key_ctdown_allKeys.length - 1].rt;
      key_ctdown.duration = _key_ctdown_allKeys[_key_ctdown_allKeys.length - 1].duration;
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  cntdownComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine && routineTimer.getTime() > 0) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function cntdownRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'cntdown' ---
  cntdownComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Run 'End Routine' code from code_ctdown
  psychoJS.experiment.addData("signal_ctdown.time", signal_times);
  bloc = 1;
  
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key_ctdown.corr, level);
  }
  psychoJS.experiment.addData('key_ctdown.keys', key_ctdown.keys);
  if (typeof key_ctdown.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key_ctdown.rt', key_ctdown.rt);
      psychoJS.experiment.addData('key_ctdown.duration', key_ctdown.duration);
      routineTimer.reset();
      }
  
  key_ctdown.stop();
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function reminderRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'reminder' ---
  t = 0;
  reminderClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  routineTimer.add(6.000000);
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_reminder
  if ((skipReminder !== 0)) {
      trial += 1;
  }
  if ((trial === 2)) {
      rowTrial = "9:18";
  } else {
      if ((trial === 3)) {
          rowTrial = "18:27";
      } else {
          if ((trial === 4)) {
              rowTrial = "27:36";
          }
      }
  }
  if (((trial % 2) === 0)) {
      if ((english === true)) {
          title_reminder.text = "Inside?";
          text_reminder.text = "Reminder: \nRespond \u2018yes\u2019 (index finger).\nRespond \u2018no\u2019 (middle finger).";
      } else {
          title_reminder.text = "\u00c0 l'int\u00e9rieur?";
          text_reminder.text = "Rappel : \nR\u00e9pondez 'oui' (index).\nR\u00e9pondez 'non' (majeur).";
      }
  } else {
      if ((english === true)) {
          title_reminder.text = "Living?";
          text_reminder.text = "Reminder: \nRespond \u2018yes\u2019 (index finger).\nRespond \u2018no\u2019 (middle finger).";
      } else {
          title_reminder.text = "Vivant?";
          text_reminder.text = "Rappel: \nR\u00e9pondez 'oui' (index).\nR\u00e9pondez 'non' (majeur).";
      }
  }
  
  key_reminder.keys = undefined;
  key_reminder.rt = undefined;
  _key_reminder_allKeys = [];
  // keep track of which components have finished
  reminderComponents = [];
  reminderComponents.push(title_reminder);
  reminderComponents.push(text_reminder);
  reminderComponents.push(key_reminder);
  
  reminderComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function reminderRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'reminder' ---
  // get current time
  t = reminderClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *title_reminder* updates
  if (t >= 0.0 && title_reminder.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    title_reminder.tStart = t;  // (not accounting for frame time here)
    title_reminder.frameNStart = frameN;  // exact frame index
    
    title_reminder.setAutoDraw(true);
  }

  frameRemains = 0.0 + 6 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (title_reminder.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    title_reminder.setAutoDraw(false);
  }
  
  // *text_reminder* updates
  if (t >= 0.0 && text_reminder.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    text_reminder.tStart = t;  // (not accounting for frame time here)
    text_reminder.frameNStart = frameN;  // exact frame index
    
    text_reminder.setAutoDraw(true);
  }

  frameRemains = 0.0 + 6 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (text_reminder.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    text_reminder.setAutoDraw(false);
  }
  
  // *key_reminder* updates
  if (t >= 0.0 && key_reminder.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_reminder.tStart = t;  // (not accounting for frame time here)
    key_reminder.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_reminder.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_reminder.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_reminder.clearEvents(); });
  }

  frameRemains = 0.0 + 6 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (key_reminder.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    key_reminder.status = PsychoJS.Status.FINISHED;
  }

  if (key_reminder.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_reminder.getKeys({keyList: ['esc'], waitRelease: false});
    _key_reminder_allKeys = _key_reminder_allKeys.concat(theseKeys);
    if (_key_reminder_allKeys.length > 0) {
      key_reminder.keys = _key_reminder_allKeys[_key_reminder_allKeys.length - 1].name;  // just the last key pressed
      key_reminder.rt = _key_reminder_allKeys[_key_reminder_allKeys.length - 1].rt;
      key_reminder.duration = _key_reminder_allKeys[_key_reminder_allKeys.length - 1].duration;
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  reminderComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine && routineTimer.getTime() > 0) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function reminderRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'reminder' ---
  reminderComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Run 'End Routine' code from code_reminder
  if ((trial === 2)) {
      psychoJS.experiment.addData(`block${(trial - 1)}TotalTime`, (title_reminder.tStartRefresh - (txt_rdy.tStartRefresh + first_pulse)));
      timeLastRun = (title_reminder.tStartRefresh + 6);
      console.log("timeLastRun", timeLastRun);
  } else {
      if ((trial === 3)) {
          psychoJS.experiment.addData(`block${(trial - 1)}TotalTime`, (title_reminder.tStartRefresh - timeLastRun));
          timeLastRun = (title_reminder.tStartRefresh + 6);
          console.log("timeLastRun", timeLastRun);
      } else {
          if ((trial === 4)) {
              psychoJS.experiment.addData(`block${(trial - 1)}TotalTime`, (title_reminder.tStartRefresh - timeLastRun));
              timeLastRun = (title_reminder.tStartRefresh + 6);
              console.log("timeLastRun", timeLastRun);
          }
      }
  }
  
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key_reminder.corr, level);
  }
  psychoJS.experiment.addData('key_reminder.keys', key_reminder.keys);
  if (typeof key_reminder.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key_reminder.rt', key_reminder.rt);
      psychoJS.experiment.addData('key_reminder.duration', key_reminder.duration);
      routineTimer.reset();
      }
  
  key_reminder.stop();
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function trialRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'trial' ---
  t = 0;
  trialClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code
  
          // add-on: list(s: string): string[]
          function list(s) {
              // if s is a string, we return a list of its characters
              if (typeof s === 'string')
                  return s.split('');
              else
                  // otherwise we return s:
                  return s;
          }
  
          signal_received = true;
  button_down = true;
  first_frame = true;
  signal_times = list();
  response_time = (- 1.0);
  img1 = LeftStim;
  img2 = RightStim;
  timeQue = (DurationQuestion / 1000);
  timeFix = (FixDelay / 1000);
  n_secs_img1 = 2.0;
  n_secs_img2 = 2.0;
  item1_finished = false;
  que_finished = false;
  item2_finished = false;
  participant_answered = false;
  no_answers = false;
  responses = 0;
  display_fix = false;
  time_last_responses = 0;
  skipReminder = 1;
  im2RT = null;
  lenght = 0;
  button = 1;
  joyst = 1;
  startTime = joystick.joystickClock.getTime();
  if ((english === true)) {
      que_text.text = QuestionEnglish;
      ans_yes_trial.text = "YES";
      ans_no_trial.text = "NO";
  } else {
      que_text.text = QuestionFrench;
      ans_yes_trial.text = "OUI";
      ans_no_trial.text = "NON";
  }
  
  item1_img.setImage(img1);
  item2_img.setImage(img2);
  key.keys = undefined;
  key.rt = undefined;
  _key_allKeys = [];
  // keep track of which components have finished
  trialComponents = [];
  trialComponents.push(item1_img);
  trialComponents.push(que_text);
  trialComponents.push(item2_img);
  trialComponents.push(timer);
  trialComponents.push(fix_text);
  trialComponents.push(key);
  trialComponents.push(ans_yes_trial);
  trialComponents.push(ans_no_trial);
  
  trialComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function trialRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'trial' ---
  // get current time
  t = trialClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  // Run 'Each Frame' code from code
  var _pj;
  function _pj_snippets(container) {
      function in_es6(left, right) {
          if (((right instanceof Array) || ((typeof right) === "string"))) {
              return (right.indexOf(left) > (- 1));
          } else {
              if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                  return right.has(left);
              } else {
                  return (left in right);
              }
          }
      }
      container["in_es6"] = in_es6;
      return container;
  }
  _pj = {};
  _pj_snippets(_pj);
  keys = psychoJS.eventManager.getKeys();
  if (first_frame) {
      startTime = joystick.joystickClock.getTime();
      first_frame = false;
  }
  if (((button_down && (! joystick.getAllButtons()[1])) && (! joystick.getAllButtons()[2]))) {
      button_down = false;
  }
  if ((signal_received && (! _pj.in_es6("5", keys)))) {
      signal_received = false;
  }
  if (((! signal_received) && _pj.in_es6("5", keys))) {
      signal_times.push(t);
      signal_received = true;
  }
  if ((key.keys.length !== lenght)) {
      if (((key.keys.slice((- 1))[0] === "1") && (! item2_finished))) {
          responses = 1;
          participant_answered = true;
          lenght = key.keys.length;
          button += 1;
          time_last_responses = key.rt.slice((- 1))[0];
      }
      if (((key.keys.slice((- 1))[0] === "2") && (! item2_finished))) {
          responses = 2;
          participant_answered = true;
          lenght = key.keys.length;
          button += 1;
          time_last_responses = key.rt.slice((- 1))[0];
      } else {
          lenght = key.keys.length;
          button += 1;
      }
  } else {
      if (((joystick.getAllButtons()[1] && (! item2_finished)) && (! button_down))) {
          responses = 1;
          participant_answered = true;
          psychoJS.experiment.addData(`pressedbuttonJ${joyst}`, 1);
          psychoJS.experiment.addData(`timebuttonJ${joyst}`, (joystick.joystickClock.getTime() - startTime));
          joyst += 1;
          time_last_responses = (joystick.joystickClock.getTime() - startTime);
          button_down = true;
      } else {
          if (((joystick.getAllButtons()[2] && (! item2_finished)) && (! button_down))) {
              responses = 2;
              participant_answered = true;
              psychoJS.experiment.addData(`pressedbuttonJ${joyst}`, 2);
              psychoJS.experiment.addData(`timebuttonJ${joyst}`, (joystick.joystickClock.getTime() - startTime));
              joyst += 1;
              time_last_responses = (joystick.joystickClock.getTime() - startTime);
              button_down = true;
          } else {
              if ((((! no_answers) && (! participant_answered)) && (timer.status === PsychoJS.Status.FINISHED))) {
                  no_answers = true;
              }
          }
      }
  }
  if ((key.keys.length > 0)) {
      if ((key.keys.slice((- 1))[0] === "escape")) {
          core.quit();
      }
  }
  if ((timer.status === PsychoJS.Status.FINISHED)) {
      item2_finished = true;
      display_fix = true;
  }
  if ((fix_text.status === PsychoJS.Status.FINISHED)) {
      continueRoutine = false;
  }
  
  
  // *item1_img* updates
  if (t >= 0.0 && item1_img.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    item1_img.tStart = t;  // (not accounting for frame time here)
    item1_img.frameNStart = frameN;  // exact frame index
    
    item1_img.setAutoDraw(true);
  }

  if (item1_img.status === PsychoJS.Status.STARTED && Boolean((display_fix == 1))) {
    item1_img.setAutoDraw(false);
  }
  
  // *que_text* updates
  if (t >= 0 && que_text.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    que_text.tStart = t;  // (not accounting for frame time here)
    que_text.frameNStart = frameN;  // exact frame index
    
    que_text.setAutoDraw(true);
  }

  if (que_text.status === PsychoJS.Status.STARTED && Boolean((display_fix == 1))) {
    que_text.setAutoDraw(false);
  }
  
  // *item2_img* updates
  if (t >= 0 && item2_img.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    item2_img.tStart = t;  // (not accounting for frame time here)
    item2_img.frameNStart = frameN;  // exact frame index
    
    item2_img.setAutoDraw(true);
  }

  if (item2_img.status === PsychoJS.Status.STARTED && Boolean((display_fix == 1))) {
    item2_img.setAutoDraw(false);
  }
  
  // *timer* updates
  if (t >= 0 && timer.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    timer.tStart = t;  // (not accounting for frame time here)
    timer.frameNStart = frameN;  // exact frame index
    
    timer.setAutoDraw(true);
  }

  frameRemains = 0 + 4 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (timer.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    timer.setAutoDraw(false);
  }
  
  // *fix_text* updates
  if (((display_fix == 1)) && fix_text.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fix_text.tStart = t;  // (not accounting for frame time here)
    fix_text.frameNStart = frameN;  // exact frame index
    
    fix_text.setAutoDraw(true);
  }

  if (fix_text.status === PsychoJS.Status.STARTED && t >= (fix_text.tStart + timeFix)) {
    fix_text.setAutoDraw(false);
  }
  
  // *key* updates
  if (t >= 0.0 && key.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key.tStart = t;  // (not accounting for frame time here)
    key.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key.clearEvents(); });
  }

  if (key.status === PsychoJS.Status.STARTED) {
    let theseKeys = key.getKeys({keyList: [], waitRelease: false});
    _key_allKeys = _key_allKeys.concat(theseKeys);
    if (_key_allKeys.length > 0) {
      key.keys = _key_allKeys.map((key) => key.name);  // storing all keys
      key.rt = _key_allKeys.map((key) => key.rt);
      key.duration = _key_allKeys.map((key) => key.duration);
    }
  }
  
  
  // *ans_yes_trial* updates
  if (t >= 0.0 && ans_yes_trial.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    ans_yes_trial.tStart = t;  // (not accounting for frame time here)
    ans_yes_trial.frameNStart = frameN;  // exact frame index
    
    ans_yes_trial.setAutoDraw(true);
  }

  if (ans_yes_trial.status === PsychoJS.Status.STARTED && Boolean((display_fix == 1))) {
    ans_yes_trial.setAutoDraw(false);
  }
  
  // *ans_no_trial* updates
  if (t >= 0.0 && ans_no_trial.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    ans_no_trial.tStart = t;  // (not accounting for frame time here)
    ans_no_trial.frameNStart = frameN;  // exact frame index
    
    ans_no_trial.setAutoDraw(true);
  }

  if (ans_no_trial.status === PsychoJS.Status.STARTED && Boolean((display_fix == 1))) {
    ans_no_trial.setAutoDraw(false);
  }
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  trialComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function trialRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'trial' ---
  trialComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Run 'End Routine' code from code
  /* Syntax Error: Fix Python code */
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key.corr, level);
  }
  psychoJS.experiment.addData('key.keys', key.keys);
  if (typeof key.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key.rt', key.rt);
      psychoJS.experiment.addData('key.duration', key.duration);
      }
  
  key.stop();
  // the Routine "trial" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function thanksRoutineBegin(snapshot) {
return async function () {
  TrialHandler.fromSnapshot(snapshot); // ensure that .thisN vals are up to date
  
  //--- Prepare to start Routine 'thanks' ---
  t = 0;
  thanksClock.reset(); // clock
  frameN = -1;
  continueRoutine = true; // until we're told otherwise
  routineTimer.add(10.000000);
  // update component parameters for each repeat
  // Run 'Begin Routine' code from code_thx
  if ((english === true)) {
      txt_thx.text = "Great job, you have completed the task!\n\nJust relax until the scanner stops.";
  } else {
      txt_thx.text = "Excellent travail, vous avez termin\u00e9 la t\u00e2che!\n\nD\u00e9tendez-vous simplement jusqu'\u00e0 l'arr\u00eat du scanner.";
  }
  
  key_thx.keys = undefined;
  key_thx.rt = undefined;
  _key_thx_allKeys = [];
  // keep track of which components have finished
  thanksComponents = [];
  thanksComponents.push(txt_thx);
  thanksComponents.push(key_thx);
  
  thanksComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  return Scheduler.Event.NEXT;
}
}

function thanksRoutineEachFrame() {
return async function () {
  //--- Loop for each frame of Routine 'thanks' ---
  // get current time
  t = thanksClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *txt_thx* updates
  if (t >= 0.0 && txt_thx.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    txt_thx.tStart = t;  // (not accounting for frame time here)
    txt_thx.frameNStart = frameN;  // exact frame index
    
    txt_thx.setAutoDraw(true);
  }

  frameRemains = 0.0 + 10.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (txt_thx.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    txt_thx.setAutoDraw(false);
  }
  
  // *key_thx* updates
  if (t >= 0.0 && key_thx.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_thx.tStart = t;  // (not accounting for frame time here)
    key_thx.frameNStart = frameN;  // exact frame index
    
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_thx.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_thx.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_thx.clearEvents(); });
  }

  frameRemains = 0.0 + 10 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (key_thx.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    key_thx.status = PsychoJS.Status.FINISHED;
  }

  if (key_thx.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_thx.getKeys({keyList: ['esc'], waitRelease: false});
    _key_thx_allKeys = _key_thx_allKeys.concat(theseKeys);
    if (_key_thx_allKeys.length > 0) {
      key_thx.keys = _key_thx_allKeys[_key_thx_allKeys.length - 1].name;  // just the last key pressed
      key_thx.rt = _key_thx_allKeys[_key_thx_allKeys.length - 1].rt;
      key_thx.duration = _key_thx_allKeys[_key_thx_allKeys.length - 1].duration;
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  thanksComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }
  });
  
  // refresh the screen if continuing
  if (continueRoutine && routineTimer.getTime() > 0) {
    return Scheduler.Event.FLIP_REPEAT;
  } else {
    return Scheduler.Event.NEXT;
  }
};
}

function thanksRoutineEnd(snapshot) {
return async function () {
  //--- Ending Routine 'thanks' ---
  thanksComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }
  });
  // Run 'End Routine' code from code_thx
  psychoJS.experiment.addData("block4TotalTime", (txt_thx.tStartRefresh - timeLastRun));
  psychoJS.experiment.addData("RunTotalTime", (txt_thx.tStartRefresh - (txt_rdy.tStartRefresh + first_pulse)));
  psychoJS.experiment.addData("ExperiementTotalTime", txt_thx.tStartRefresh);
  
  // update the trial handler
  if (currentLoop instanceof MultiStairHandler) {
    currentLoop.addResponse(key_thx.corr, level);
  }
  psychoJS.experiment.addData('key_thx.keys', key_thx.keys);
  if (typeof key_thx.keys !== 'undefined') {  // we had a response
      psychoJS.experiment.addData('key_thx.rt', key_thx.rt);
      psychoJS.experiment.addData('key_thx.duration', key_thx.duration);
      routineTimer.reset();
      }
  
  key_thx.stop();
  // Routines running outside a loop should always advance the datafile row
  if (currentLoop === psychoJS.experiment) {
    psychoJS.experiment.nextEntry(snapshot);
  }
  return Scheduler.Event.NEXT;
}
}

function importConditions(currentLoop) {
  return async function () {
    psychoJS.importAttributes(currentLoop.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}

async function quitPsychoJS(message, isCompleted) {
// Check for and save orphaned data
if (psychoJS.experiment.isEntryEmpty()) {
  psychoJS.experiment.nextEntry();
}
































psychoJS.window.close();
psychoJS.quit({message: message, isCompleted: isCompleted});

return Scheduler.Event.QUIT;
}
