﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2023.1.3),
    on March 24, 2024, at 13:08
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

# --- Import packages ---
from psychopy import locale_setup
from psychopy import prefs
from psychopy import plugins
plugins.activatePlugins()
prefs.hardware['audioLib'] = 'ptb'
prefs.hardware['audioLatencyMode'] = '3'
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.tools import environmenttools
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard

# Run 'Before Experiment' code from code_instr_vivant
two_exemple = 1
# Run 'Before Experiment' code from code_pr
show_betw = 1
timedAns = 0
# Run 'Before Experiment' code from codePreRemind
lenghtRemind = 0
timerRemind = None

def buttonSelector(selectedButton):
    selectedButton.fillColor = [-0.92, -0.24, -0.29]

# Run 'Before Experiment' code from code_reminder
timeLastRun = 0


# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2023.1.3'
expName = 'RISE_Enco'  # from the Builder filename that created this script
expInfo = {
    'participant': '',
    'session': '',
    'choiceTrial': ['practiceV1', 'trialV1', 'practiceV2', 'trialV2'],
}
# --- Show participant info dialog --
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s_%s_%s' % (expInfo['participant'], expName, expInfo['choiceTrial'], expInfo['date'], expInfo['session'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\Users\\caron\\OneDrive\\Documents\\Douglas\\RISE\\clean_main_branch_RISE\\rise-encoding\\RISE_Enco_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.DEBUG)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation
from psychopy.hardware import joystick as joysticklib  # joystick/gamepad accsss
from psychopy.experiment.components.joystick import virtualJoystick as virtualjoysticklib
from psychopy.hardware import joystick as joysticklib  # joystick/gamepad accsss
from psychopy.experiment.components.joystick import virtualJoystick as virtualjoysticklib
from psychopy.hardware import joystick as joysticklib  # joystick/gamepad accsss
from psychopy.experiment.components.joystick import virtualJoystick as virtualjoysticklib
from psychopy.hardware import joystick as joysticklib  # joystick/gamepad accsss
from psychopy.experiment.components.joystick import virtualJoystick as virtualjoysticklib
from psychopy.hardware import joystick as joysticklib  # joystick/gamepad accsss
from psychopy.experiment.components.joystick import virtualJoystick as virtualjoysticklib
from psychopy.hardware import joystick as joysticklib  # joystick/gamepad accsss
from psychopy.experiment.components.joystick import virtualJoystick as virtualjoysticklib
from psychopy.hardware import joystick as joysticklib  # joystick/gamepad accsss
from psychopy.experiment.components.joystick import virtualJoystick as virtualjoysticklib
from psychopy.hardware import joystick as joysticklib  # joystick/gamepad accsss
from psychopy.experiment.components.joystick import virtualJoystick as virtualjoysticklib

# --- Setup the Window ---
win = visual.Window(
    size=[1920, 1080], fullscr=True, screen=1, 
    winType='pyglet', allowStencil=False,
    monitor='testMonitor', color=[1,1,1], colorSpace='rgb',
    backgroundImage='', backgroundFit='none',
    blendMode='avg', useFBO=True, 
    units='height')
win.mouseVisible = False
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# --- Setup input devices ---
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# --- Initialize components for Routine "lang" ---
# Run 'Begin Experiment' code from code_lang
# No buttons is currently pressed
button_down = False

text_lang = visual.TextStim(win=win, name='text_lang',
    text='Veuillez sélectionner votre langue.\nAppuyez sur 1 pour Français.\n\nPlease select your language.\nPress 2 for English.',
    font='Open Sans',
    pos=(0, 0), height=0.04, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);
x, y = [None, None]
joystickLang = type('', (), {})() # Create an object to use as a name space
joystickLang.device = None
joystickLang.device_number = 0
joystickLang.joystickClock = core.Clock()
joystickLang.xFactor = 1
joystickLang.yFactor = 1

try:
    numJoysticks = joysticklib.getNumJoysticks()
    if numJoysticks > 0:
        try:
            joystickCache
        except NameError:
            joystickCache={}
        if not 0 in joystickCache:
            joystickCache[0] = joysticklib.Joystick(0)
        joystickLang.device = joystickCache[0]
        if win.units == 'height':
            joystickLang.xFactor = 0.5 * win.size[0]/win.size[1]
            joystickLang.yFactor = 0.5
    else:
        joystickLang.device = virtualjoysticklib.VirtualJoystick(0)
        logging.warning("joystick_{}: Using keyboard+mouse emulation 'ctrl' + 'Alt' + digit.".format(joystickLang.device_number))
except Exception:
    pass
    
if not joystickLang.device:
    logging.error('No joystick/gamepad device found.')
    core.quit()

joystickLang.status = None
joystickLang.clock = core.Clock()
joystickLang.numButtons = joystickLang.device.getNumButtons()
joystickLang.getNumButtons = joystickLang.device.getNumButtons
joystickLang.getAllButtons = joystickLang.device.getAllButtons
joystickLang.getX = lambda: joystickLang.xFactor * joystickLang.device.getX()
joystickLang.getY = lambda: joystickLang.yFactor * joystickLang.device.getY()

keyLang = keyboard.Keyboard()

# --- Initialize components for Routine "set_condition" ---
# Run 'Begin Experiment' code from code_set
import re, time
from datetime import datetime

# Save starting session time
startingTime = datetime.now().strftime("%H:%M:%S.%f")
startingTime = "\'"+startingTime
print("Starting time: ", startingTime)
#startingTime = datetime.utcnow().strftime("%H:%M:%S.%f")[:-3]
thisExp.addData("sessionTime", startingTime)
thisExp.addData("sessionTime.RTTime", core.Clock().getTime())

# Remove illegal characters in participants' name to avoid errors in filenames
expInfo['participant']= re.sub('[^A-Za-z0-9]+', '', expInfo['participant'])
# No buttons is currently pressed
button_down = False

# Hide the mouse cursor
event.Mouse(visible=False)
win.mouseVisible = False

# --- Initialize components for Routine "instr_vivant" ---
instr_text_vivant_1 = visual.TextStim(win=win, name='instr_text_vivant_1',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=1.7, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);
instr_text_vivant_2 = visual.TextStim(win=win, name='instr_text_vivant_2',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=2.0, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-2.0);
instr_text_vivant_3 = visual.TextStim(win=win, name='instr_text_vivant_3',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=1.7, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-3.0);
instr_text_vivant_4 = visual.TextStim(win=win, name='instr_text_vivant_4',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=1.5, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-4.0);
x, y = [None, None]
joystick_2 = type('', (), {})() # Create an object to use as a name space
joystick_2.device = None
joystick_2.device_number = 0
joystick_2.joystickClock = core.Clock()
joystick_2.xFactor = 1
joystick_2.yFactor = 1

try:
    numJoysticks = joysticklib.getNumJoysticks()
    if numJoysticks > 0:
        try:
            joystickCache
        except NameError:
            joystickCache={}
        if not 0 in joystickCache:
            joystickCache[0] = joysticklib.Joystick(0)
        joystick_2.device = joystickCache[0]
        if win.units == 'height':
            joystick_2.xFactor = 0.5 * win.size[0]/win.size[1]
            joystick_2.yFactor = 0.5
    else:
        joystick_2.device = virtualjoysticklib.VirtualJoystick(0)
        logging.warning("joystick_{}: Using keyboard+mouse emulation 'ctrl' + 'Alt' + digit.".format(joystick_2.device_number))
except Exception:
    pass
    
if not joystick_2.device:
    logging.error('No joystick/gamepad device found.')
    core.quit()

joystick_2.status = None
joystick_2.clock = core.Clock()
joystick_2.numButtons = joystick_2.device.getNumButtons()
joystick_2.getNumButtons = joystick_2.device.getNumButtons
joystick_2.getAllButtons = joystick_2.device.getAllButtons
joystick_2.getX = lambda: joystick_2.xFactor * joystick_2.device.getX()
joystick_2.getY = lambda: joystick_2.yFactor * joystick_2.device.getY()


# --- Initialize components for Routine "ex" ---
item1_imgEx = visual.ImageStim(
    win=win,
    name='item1_imgEx', 
    image='default.png', mask=None, anchor='center',
    ori=0.0, pos=(-.3, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=1.0,
    flipHoriz=False, flipVert=False,
    texRes=512.0, interpolate=False, depth=-1.0)
que_txtEx = visual.TextStim(win=win, name='que_txtEx',
    text=None,
    font='Open Sans',
    pos=(0, -.3), height=0.05, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
item2_imgEx = visual.ImageStim(
    win=win,
    name='item2_imgEx', 
    image='default.png', mask=None, anchor='center',
    ori=0.0, pos=(.3, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=512.0, interpolate=False, depth=-3.0)
response_Ex = visual.TextStim(win=win, name='response_Ex',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);
timer_Ex = visual.TextStim(win=win, name='timer_Ex',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-5.0);
fix_text_Ex = visual.TextStim(win=win, name='fix_text_Ex',
    text='+',
    font='Open Sans',
    pos=(0, 0), height=0.11, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-6.0);
key_Ex = keyboard.Keyboard()
x, y = [None, None]
joystick_Ex = type('', (), {})() # Create an object to use as a name space
joystick_Ex.device = None
joystick_Ex.device_number = 0
joystick_Ex.joystickClock = core.Clock()
joystick_Ex.xFactor = 1
joystick_Ex.yFactor = 1

try:
    numJoysticks = joysticklib.getNumJoysticks()
    if numJoysticks > 0:
        try:
            joystickCache
        except NameError:
            joystickCache={}
        if not 0 in joystickCache:
            joystickCache[0] = joysticklib.Joystick(0)
        joystick_Ex.device = joystickCache[0]
        if win.units == 'height':
            joystick_Ex.xFactor = 0.5 * win.size[0]/win.size[1]
            joystick_Ex.yFactor = 0.5
    else:
        joystick_Ex.device = virtualjoysticklib.VirtualJoystick(0)
        logging.warning("joystick_{}: Using keyboard+mouse emulation 'ctrl' + 'Alt' + digit.".format(joystick_Ex.device_number))
except Exception:
    pass
    
if not joystick_Ex.device:
    logging.error('No joystick/gamepad device found.')
    core.quit()

joystick_Ex.status = None
joystick_Ex.clock = core.Clock()
joystick_Ex.numButtons = joystick_Ex.device.getNumButtons()
joystick_Ex.getNumButtons = joystick_Ex.device.getNumButtons
joystick_Ex.getAllButtons = joystick_Ex.device.getAllButtons
joystick_Ex.getX = lambda: joystick_Ex.xFactor * joystick_Ex.device.getX()
joystick_Ex.getY = lambda: joystick_Ex.yFactor * joystick_Ex.device.getY()

text_Ex = visual.TextStim(win=win, name='text_Ex',
    text=None,
    font='Open Sans',
    pos=(0, 0.35), height=0.04, wrapWidth=1.5, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-9.0);
ans_yes_ex = visual.TextStim(win=win, name='ans_yes_ex',
    text=None,
    font='Open Sans',
    pos=(-.1, -.38), height=0.05, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-10.0);
ans_no_ex = visual.TextStim(win=win, name='ans_no_ex',
    text=None,
    font='Open Sans',
    pos=(.1, -.38), height=0.05, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-11.0);

# --- Initialize components for Routine "next_instr" ---
text_next_instr = visual.TextStim(win=win, name='text_next_instr',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=1.7, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);
key_next_instr = keyboard.Keyboard()
x, y = [None, None]
joystick_3 = type('', (), {})() # Create an object to use as a name space
joystick_3.device = None
joystick_3.device_number = 0
joystick_3.joystickClock = core.Clock()
joystick_3.xFactor = 1
joystick_3.yFactor = 1

try:
    numJoysticks = joysticklib.getNumJoysticks()
    if numJoysticks > 0:
        try:
            joystickCache
        except NameError:
            joystickCache={}
        if not 0 in joystickCache:
            joystickCache[0] = joysticklib.Joystick(0)
        joystick_3.device = joystickCache[0]
        if win.units == 'height':
            joystick_3.xFactor = 0.5 * win.size[0]/win.size[1]
            joystick_3.yFactor = 0.5
    else:
        joystick_3.device = virtualjoysticklib.VirtualJoystick(0)
        logging.warning("joystick_{}: Using keyboard+mouse emulation 'ctrl' + 'Alt' + digit.".format(joystick_3.device_number))
except Exception:
    pass
    
if not joystick_3.device:
    logging.error('No joystick/gamepad device found.')
    core.quit()

joystick_3.status = None
joystick_3.clock = core.Clock()
joystick_3.numButtons = joystick_3.device.getNumButtons()
joystick_3.getNumButtons = joystick_3.device.getNumButtons
joystick_3.getAllButtons = joystick_3.device.getAllButtons
joystick_3.getX = lambda: joystick_3.xFactor * joystick_3.device.getX()
joystick_3.getY = lambda: joystick_3.yFactor * joystick_3.device.getY()


# --- Initialize components for Routine "pract" ---
ans_no_prac = visual.TextStim(win=win, name='ans_no_prac',
    text=None,
    font='Open Sans',
    pos=(.1, -.38), height=0.05, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
ans_yes_prac = visual.TextStim(win=win, name='ans_yes_prac',
    text=None,
    font='Open Sans',
    pos=(-.1, -.38), height=0.05, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
item1_img_pr = visual.ImageStim(
    win=win,
    name='item1_img_pr', 
    image='default.png', mask=None, anchor='center',
    ori=0.0, pos=(-.3, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=1.0,
    flipHoriz=False, flipVert=False,
    texRes=512.0, interpolate=False, depth=-3.0)
que_text_pr = visual.TextStim(win=win, name='que_text_pr',
    text=None,
    font='Arial',
    pos=(0, -.3), height=0.06, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-4.0);
item2_img_pr = visual.ImageStim(
    win=win,
    name='item2_img_pr', 
    image='default.png', mask=None, anchor='center',
    ori=0.0, pos=(.3, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=1.0,
    flipHoriz=False, flipVert=False,
    texRes=512.0, interpolate=False, depth=-5.0)
timer_pr = visual.TextStim(win=win, name='timer_pr',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.01, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=0.0, 
    languageStyle='LTR',
    depth=-6.0);
timer_timed_pr = visual.TextStim(win=win, name='timer_timed_pr',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.01, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=0.0, 
    languageStyle='LTR',
    depth=-7.0);
fix_text_pr = visual.TextStim(win=win, name='fix_text_pr',
    text='+',
    font='Arial',
    pos=(0, 0), height=0.11, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-8.0);
key_prac = keyboard.Keyboard()
x, y = [None, None]
joystick_prac = type('', (), {})() # Create an object to use as a name space
joystick_prac.device = None
joystick_prac.device_number = 0
joystick_prac.joystickClock = core.Clock()
joystick_prac.xFactor = 1
joystick_prac.yFactor = 1

try:
    numJoysticks = joysticklib.getNumJoysticks()
    if numJoysticks > 0:
        try:
            joystickCache
        except NameError:
            joystickCache={}
        if not 0 in joystickCache:
            joystickCache[0] = joysticklib.Joystick(0)
        joystick_prac.device = joystickCache[0]
        if win.units == 'height':
            joystick_prac.xFactor = 0.5 * win.size[0]/win.size[1]
            joystick_prac.yFactor = 0.5
    else:
        joystick_prac.device = virtualjoysticklib.VirtualJoystick(0)
        logging.warning("joystick_{}: Using keyboard+mouse emulation 'ctrl' + 'Alt' + digit.".format(joystick_prac.device_number))
except Exception:
    pass
    
if not joystick_prac.device:
    logging.error('No joystick/gamepad device found.')
    core.quit()

joystick_prac.status = None
joystick_prac.clock = core.Clock()
joystick_prac.numButtons = joystick_prac.device.getNumButtons()
joystick_prac.getNumButtons = joystick_prac.device.getNumButtons
joystick_prac.getAllButtons = joystick_prac.device.getAllButtons
joystick_prac.getX = lambda: joystick_prac.xFactor * joystick_prac.device.getX()
joystick_prac.getY = lambda: joystick_prac.yFactor * joystick_prac.device.getY()


# --- Initialize components for Routine "transition1" ---
txt_transi1 = visual.TextStim(win=win, name='txt_transi1',
    text=None,
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=1.5, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);
key_transi1 = keyboard.Keyboard()
x, y = [None, None]
joystick_transi1 = type('', (), {})() # Create an object to use as a name space
joystick_transi1.device = None
joystick_transi1.device_number = 0
joystick_transi1.joystickClock = core.Clock()
joystick_transi1.xFactor = 1
joystick_transi1.yFactor = 1

try:
    numJoysticks = joysticklib.getNumJoysticks()
    if numJoysticks > 0:
        try:
            joystickCache
        except NameError:
            joystickCache={}
        if not 0 in joystickCache:
            joystickCache[0] = joysticklib.Joystick(0)
        joystick_transi1.device = joystickCache[0]
        if win.units == 'height':
            joystick_transi1.xFactor = 0.5 * win.size[0]/win.size[1]
            joystick_transi1.yFactor = 0.5
    else:
        joystick_transi1.device = virtualjoysticklib.VirtualJoystick(0)
        logging.warning("joystick_{}: Using keyboard+mouse emulation 'ctrl' + 'Alt' + digit.".format(joystick_transi1.device_number))
except Exception:
    pass
    
if not joystick_transi1.device:
    logging.error('No joystick/gamepad device found.')
    core.quit()

joystick_transi1.status = None
joystick_transi1.clock = core.Clock()
joystick_transi1.numButtons = joystick_transi1.device.getNumButtons()
joystick_transi1.getNumButtons = joystick_transi1.device.getNumButtons
joystick_transi1.getAllButtons = joystick_transi1.device.getAllButtons
joystick_transi1.getX = lambda: joystick_transi1.xFactor * joystick_transi1.device.getX()
joystick_transi1.getY = lambda: joystick_transi1.yFactor * joystick_transi1.device.getY()


# --- Initialize components for Routine "preRemind" ---
textPreRemind = visual.TextStim(win=win, name='textPreRemind',
    text=None,
    font='Open Sans',
    pos=(0, 0.3), height=0.04, wrapWidth=1.5, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
textPreRemind_2 = visual.TextStim(win=win, name='textPreRemind_2',
    text=None,
    font='Open Sans',
    pos=(0, -0.3), height=0.05, wrapWidth=1.5, ori=0.0, 
    color='black', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-2.0);
keyPreRemind = keyboard.Keyboard()
x, y = [None, None]
joystickPreRemind = type('', (), {})() # Create an object to use as a name space
joystickPreRemind.device = None
joystickPreRemind.device_number = 0
joystickPreRemind.joystickClock = core.Clock()
joystickPreRemind.xFactor = 1
joystickPreRemind.yFactor = 1

try:
    numJoysticks = joysticklib.getNumJoysticks()
    if numJoysticks > 0:
        try:
            joystickCache
        except NameError:
            joystickCache={}
        if not 0 in joystickCache:
            joystickCache[0] = joysticklib.Joystick(0)
        joystickPreRemind.device = joystickCache[0]
        if win.units == 'height':
            joystickPreRemind.xFactor = 0.5 * win.size[0]/win.size[1]
            joystickPreRemind.yFactor = 0.5
    else:
        joystickPreRemind.device = virtualjoysticklib.VirtualJoystick(0)
        logging.warning("joystick_{}: Using keyboard+mouse emulation 'ctrl' + 'Alt' + digit.".format(joystickPreRemind.device_number))
except Exception:
    pass
    
if not joystickPreRemind.device:
    logging.error('No joystick/gamepad device found.')
    core.quit()

joystickPreRemind.status = None
joystickPreRemind.clock = core.Clock()
joystickPreRemind.numButtons = joystickPreRemind.device.getNumButtons()
joystickPreRemind.getNumButtons = joystickPreRemind.device.getNumButtons
joystickPreRemind.getAllButtons = joystickPreRemind.device.getAllButtons
joystickPreRemind.getX = lambda: joystickPreRemind.xFactor * joystickPreRemind.device.getX()
joystickPreRemind.getY = lambda: joystickPreRemind.yFactor * joystickPreRemind.device.getY()

ansYesPreRemind = visual.TextStim(win=win, name='ansYesPreRemind',
    text=None,
    font='Open Sans',
    pos=(-.1, -0.05), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-5.0);
ansNoPreRemind = visual.TextStim(win=win, name='ansNoPreRemind',
    text=None,
    font='Open Sans',
    pos=(.1, -0.05), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-6.0);
polygonYes = visual.Rect(
    win=win, name='polygonYes',
    width=(0.1, 0.1)[0], height=(0.1, 0.1)[1],
    ori=0.0, pos=(-.1, 0.05), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='black', fillColor='white',
    opacity=None, depth=-7.0, interpolate=True)
polygonNo = visual.Rect(
    win=win, name='polygonNo',
    width=(0.1, 0.1)[0], height=(0.1, 0.1)[1],
    ori=0.0, pos=(.1, 0.05), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor='black', fillColor='white',
    opacity=None, depth=-8.0, interpolate=True)

# --- Initialize components for Routine "remind" ---
title_remind = visual.TextStim(win=win, name='title_remind',
    text=None,
    font='Open Sans Black',
    pos=(0, 0.1), height=0.07, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
text_remind = visual.TextStim(win=win, name='text_remind',
    text=None,
    font='Open Sans',
    pos=(0, -0.1), height=0.05, wrapWidth=1.5, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-2.0);

# --- Initialize components for Routine "ready" ---
# Run 'Begin Experiment' code from code_rdy
#To skip the first reminer for the first trial
skipReminder = 0
#To keep track of which trial we are in
trial = 1
rowTrial = '0:2'
first_pulse = 0
txt_rdy = visual.TextStim(win=win, name='txt_rdy',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);
key_rdy = keyboard.Keyboard()

# --- Initialize components for Routine "cntdown" ---
timer_ctdown = visual.TextStim(win=win, name='timer_ctdown',
    text='',
    font='Arial',
    pos=(0, 0), height=0.08, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);
key_ctdown = keyboard.Keyboard()

# --- Initialize components for Routine "reminder" ---
title_reminder = visual.TextStim(win=win, name='title_reminder',
    text=None,
    font='Open Sans Black',
    pos=(0, 0.1), height=0.07, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
text_reminder = visual.TextStim(win=win, name='text_reminder',
    text=None,
    font='Open Sans',
    pos=(0, -0.1), height=0.05, wrapWidth=1.5, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-2.0);
key_reminder = keyboard.Keyboard()

# --- Initialize components for Routine "trial" ---
item1_img = visual.ImageStim(
    win=win,
    name='item1_img', 
    image='default.png', mask=None, anchor='center',
    ori=0.0, pos=(-.3, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=1.0,
    flipHoriz=False, flipVert=False,
    texRes=512.0, interpolate=False, depth=-1.0)
que_text = visual.TextStim(win=win, name='que_text',
    text=None,
    font='Arial',
    pos=(0, -.3), height=0.06, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-2.0);
item2_img = visual.ImageStim(
    win=win,
    name='item2_img', 
    image='default.png', mask=None, anchor='center',
    ori=0.0, pos=(.3, 0), size=(0.5, 0.5),
    color=[1,1,1], colorSpace='rgb', opacity=1.0,
    flipHoriz=False, flipVert=False,
    texRes=512.0, interpolate=False, depth=-3.0)
timer = visual.TextStim(win=win, name='timer',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.01, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=0.0, 
    languageStyle='LTR',
    depth=-4.0);
fix_text = visual.TextStim(win=win, name='fix_text',
    text='+',
    font='Arial',
    pos=(0, 0), height=0.11, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-5.0);
key = keyboard.Keyboard()
x, y = [None, None]
joystick = type('', (), {})() # Create an object to use as a name space
joystick.device = None
joystick.device_number = 0
joystick.joystickClock = core.Clock()
joystick.xFactor = 1
joystick.yFactor = 1

try:
    numJoysticks = joysticklib.getNumJoysticks()
    if numJoysticks > 0:
        try:
            joystickCache
        except NameError:
            joystickCache={}
        if not 0 in joystickCache:
            joystickCache[0] = joysticklib.Joystick(0)
        joystick.device = joystickCache[0]
        if win.units == 'height':
            joystick.xFactor = 0.5 * win.size[0]/win.size[1]
            joystick.yFactor = 0.5
    else:
        joystick.device = virtualjoysticklib.VirtualJoystick(0)
        logging.warning("joystick_{}: Using keyboard+mouse emulation 'ctrl' + 'Alt' + digit.".format(joystick.device_number))
except Exception:
    pass
    
if not joystick.device:
    logging.error('No joystick/gamepad device found.')
    core.quit()

joystick.status = None
joystick.clock = core.Clock()
joystick.numButtons = joystick.device.getNumButtons()
joystick.getNumButtons = joystick.device.getNumButtons
joystick.getAllButtons = joystick.device.getAllButtons
joystick.getX = lambda: joystick.xFactor * joystick.device.getX()
joystick.getY = lambda: joystick.yFactor * joystick.device.getY()

ans_yes_trial = visual.TextStim(win=win, name='ans_yes_trial',
    text=None,
    font='Open Sans',
    pos=(-.1, -.38), height=0.05, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1,], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-8.0);
ans_no_trial = visual.TextStim(win=win, name='ans_no_trial',
    text=None,
    font='Open Sans',
    pos=(.1, -.38), height=0.05, wrapWidth=None, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-9.0);

# --- Initialize components for Routine "thanks" ---
txt_thx = visual.TextStim(win=win, name='txt_thx',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=1.1, ori=0.0, 
    color=[-1,-1,-1], colorSpace='rgb', opacity=1.0, 
    languageStyle='LTR',
    depth=-1.0);
key_thx = keyboard.Keyboard()

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.Clock()  # to track time remaining of each (possibly non-slip) routine 

# --- Prepare to start Routine "lang" ---
continueRoutine = True
# update component parameters for each repeat
# Run 'Begin Routine' code from code_lang
# Joystick's button is not pressed by default
button_down = False

# Hide the mouse cursor
event.Mouse(visible=False)
win.mouseVisible = False


joystickLang.oldButtonState = joystickLang.device.getAllButtons()[:]
joystickLang.activeButtons=[1, 2]
# setup some python lists for storing info about the joystickLang
gotValidClick = False  # until a click is received
keyLang.keys = []
keyLang.rt = []
_keyLang_allKeys = []
# keep track of which components have finished
langComponents = [text_lang, joystickLang, keyLang]
for thisComponent in langComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "lang" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    # Run 'Each Frame' code from code_lang
    #Perform actions depending to the pressed button/key
    #Set french or english variable to true when the language is selected
    def set_language(french_val, english_val):
        return french_val, english_val
    
    if joystickLang.getAllButtons()[0] or "1" in keyLang.keys:
        french, english = set_language(True, False)
        text_lang.finished = True
        continueRoutine = False 
    elif joystickLang.getAllButtons()[2] or "2" in keyLang.keys:
        french, english = set_language(False, True)
        text_lang.finished = True
        continueRoutine = False
        
    
    # *text_lang* updates
    
    # if text_lang is starting this frame...
    if text_lang.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_lang.frameNStart = frameN  # exact frame index
        text_lang.tStart = t  # local t and not account for scr refresh
        text_lang.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_lang, 'tStartRefresh')  # time at next scr refresh
        # add timestamp to datafile
        thisExp.timestampOnFlip(win, 'text_lang.started')
        # update status
        text_lang.status = STARTED
        text_lang.setAutoDraw(True)
    
    # if text_lang is active this frame...
    if text_lang.status == STARTED:
        # update params
        pass
    
    # *keyLang* updates
    waitOnFlip = False
    
    # if keyLang is starting this frame...
    if keyLang.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        keyLang.frameNStart = frameN  # exact frame index
        keyLang.tStart = t  # local t and not account for scr refresh
        keyLang.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(keyLang, 'tStartRefresh')  # time at next scr refresh
        # update status
        keyLang.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(keyLang.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(keyLang.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if keyLang.status == STARTED and not waitOnFlip:
        theseKeys = keyLang.getKeys(keyList=['1','2','esc'], waitRelease=False)
        _keyLang_allKeys.extend(theseKeys)
        if len(_keyLang_allKeys):
            keyLang.keys = _keyLang_allKeys[-1].name  # just the last key pressed
            keyLang.rt = _keyLang_allKeys[-1].rt
            keyLang.duration = _keyLang_allKeys[-1].duration
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in langComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "lang" ---
for thisComponent in langComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# Run 'End Routine' code from code_lang
lang = 'en' if english==True else 'fr'
thisExp.addData('language', lang)
button_down = True
# store data for thisExp (ExperimentHandler)
# store data for thisExp (ExperimentHandler)
x, y = joystickLang.getX(), joystickLang.getY()
joystickLang.newButtonState = joystickLang.getAllButtons()[:]
joystickLang.pressedState = [joystickLang.newButtonState[i] for i in range(joystickLang.numButtons)]
joystickLang.time = joystickLang.joystickClock.getTime()
thisExp.addData('joystickLang.x', x)
thisExp.addData('joystickLang.y', y)
[thisExp.addData('joystickLang.button_{0}'.format(i), int(joystickLang.pressedState[i])) for i in joystickLang.activeButtons]
thisExp.addData('joystickLang.time', joystickLang.time)
thisExp.nextEntry()
# check responses
if keyLang.keys in ['', [], None]:  # No response was made
    keyLang.keys = None
thisExp.addData('keyLang.keys',keyLang.keys)
if keyLang.keys != None:  # we had a response
    thisExp.addData('keyLang.rt', keyLang.rt)
    thisExp.addData('keyLang.duration', keyLang.duration)
thisExp.nextEntry()
# the Routine "lang" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# --- Prepare to start Routine "set_condition" ---
continueRoutine = True
# update component parameters for each repeat
# Run 'Begin Routine' code from code_set
# increment this variable to keep track of the current practice
current_practice = 1

# Hide the mouse cursor
event.Mouse(visible=False)
win.mouseVisible = False
# keep track of which components have finished
set_conditionComponents = []
for thisComponent in set_conditionComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
frameN = -1

# --- Run Routine "set_condition" ---
routineForceEnded = not continueRoutine
while continueRoutine:
    # get current time
    t = routineTimer.getTime()
    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    # Run 'Each Frame' code from code_set
    pracTxt = "conditions/txt_practices.csv"
    
    #To set the CSV depending on which option we choose
    condition_files = {
        "practiceV1": ("conditions/Practice_Item-Specific_V1.csv", "conditions/Practice_Relational_V1.csv", "conditions/Encoding_V1/Encoding_Trial_V1.csv"),
        "trialV1": ("conditions/Practice_Item-Specific_V1.csv", "conditions/Practice_Relational_V1.csv", "conditions/Encoding_V1/Encoding_Trial_V1.csv"),
        "practiceV2": ("conditions/Practice_Item-Specific_V2.csv", "conditions/Practice_Relational_V2.csv", "conditions/Encoding_V2/Encoding_Trial_V2.csv"),
        "trialV2": ("conditions/Practice_Item-Specific_V2.csv", "conditions/Practice_Relational_V2.csv", "conditions/Encoding_V2/Encoding_Trial_V1.csv"),
    }
    
    if expInfo['choiceTrial'] in condition_files:
        practConditions, pracConditions2, trialConditions = condition_files[expInfo['choiceTrial']]
        
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
        if eyetracker:
            eyetracker.setConnectionState(False)
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        routineForceEnded = True
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in set_conditionComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# --- Ending Routine "set_condition" ---
for thisComponent in set_conditionComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# Run 'End Routine' code from code_set
# to skip or not the practice depending on the choice trial
if "practice" in expInfo['choiceTrial']:
    skipP = 1
    skipT = 0
else:
    skipP = 0
    skipT = 1
# the Routine "set_condition" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
skip_practice = data.TrialHandler(nReps=skipP, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='skip_practice')
thisExp.addLoop(skip_practice)  # add the loop to the experiment
thisSkip_practice = skip_practice.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisSkip_practice.rgb)
if thisSkip_practice != None:
    for paramName in thisSkip_practice:
        exec('{} = thisSkip_practice[paramName]'.format(paramName))

for thisSkip_practice in skip_practice:
    currentLoop = skip_practice
    # abbreviate parameter names if possible (e.g. rgb = thisSkip_practice.rgb)
    if thisSkip_practice != None:
        for paramName in thisSkip_practice:
            exec('{} = thisSkip_practice[paramName]'.format(paramName))
    
    # set up handler to look after randomisation of conditions etc
    practices_bloc = data.TrialHandler(nReps=1.0, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(pracTxt),
        seed=None, name='practices_bloc')
    thisExp.addLoop(practices_bloc)  # add the loop to the experiment
    thisPractices_bloc = practices_bloc.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisPractices_bloc.rgb)
    if thisPractices_bloc != None:
        for paramName in thisPractices_bloc:
            exec('{} = thisPractices_bloc[paramName]'.format(paramName))
    
    for thisPractices_bloc in practices_bloc:
        currentLoop = practices_bloc
        # abbreviate parameter names if possible (e.g. rgb = thisPractices_bloc.rgb)
        if thisPractices_bloc != None:
            for paramName in thisPractices_bloc:
                exec('{} = thisPractices_bloc[paramName]'.format(paramName))
        
        # --- Prepare to start Routine "instr_vivant" ---
        continueRoutine = True
        # update component parameters for each repeat
        # Run 'Begin Routine' code from code_instr_vivant
        # Find a font that is available on the system.
        #fm = visual.textbox2.getFontManager()
        #available_font_names=fm.getFontFamilyStyles()
        #print(available_font_names)
        
        #Change displayed text based on the language previously chosen
        if english == True:
            instr_text_vivant_1.text = instr_text_1_en
            instr_text_vivant_2.text = instr_text_2_en
            instr_text_vivant_3.text = instr_text_3_en
        else:
            instr_text_vivant_1.text = instr_text_1_fr
            instr_text_vivant_2.text = instr_text_2_fr 
            instr_text_vivant_3.text = instr_text_3_fr
        
        #Display 3 instructions
        curIns = 1
        
        # The button was previously pressed
        button_down = True
        
        if current_practice > 1:
            practConditions = pracConditions2
            
        
        # Count the good response of the participant 
        good_response = 0
        
        joystick_2.oldButtonState = joystick_2.device.getAllButtons()[:]
        joystick_2.activeButtons=[1]
        # setup some python lists for storing info about the joystick_2
        gotValidClick = False  # until a click is received
        # keep track of which components have finished
        instr_vivantComponents = [instr_text_vivant_1, instr_text_vivant_2, instr_text_vivant_3, instr_text_vivant_4, joystick_2]
        for thisComponent in instr_vivantComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "instr_vivant" ---
        routineForceEnded = not continueRoutine
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # Run 'Each Frame' code from code_instr_vivant
            # Check if we pressed keyboard keys
            keys = event.getKeys()
            
            # Reset buttons if they are not pressed
            if button_down  and not joystick_2.getAllButtons()[0] and not '1' in keys:
               button_down = False
            
            # Go to next instruction if '1' or '2' is pressed
            if not button_down and curIns == 1 and (joystick_2.getAllButtons()[0] or '1' in keys):
                button_down = True
                curIns = curIns + 1
            
            # Go to next routine
            if not button_down and curIns >= 2 and (joystick_2.getAllButtons()[0] or '1' in keys):
                button_down = True
                continueRoutine = False
             
            
            # *instr_text_vivant_1* updates
            
            # if instr_text_vivant_1 is starting this frame...
            if instr_text_vivant_1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                instr_text_vivant_1.frameNStart = frameN  # exact frame index
                instr_text_vivant_1.tStart = t  # local t and not account for scr refresh
                instr_text_vivant_1.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(instr_text_vivant_1, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'instr_text_vivant_1.started')
                # update status
                instr_text_vivant_1.status = STARTED
                instr_text_vivant_1.setAutoDraw(True)
            
            # if instr_text_vivant_1 is active this frame...
            if instr_text_vivant_1.status == STARTED:
                # update params
                pass
            
            # if instr_text_vivant_1 is stopping this frame...
            if instr_text_vivant_1.status == STARTED:
                if bool(curIns == 2):
                    # keep track of stop time/frame for later
                    instr_text_vivant_1.tStop = t  # not accounting for scr refresh
                    instr_text_vivant_1.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'instr_text_vivant_1.stopped')
                    # update status
                    instr_text_vivant_1.status = FINISHED
                    instr_text_vivant_1.setAutoDraw(False)
            
            # *instr_text_vivant_2* updates
            
            # if instr_text_vivant_2 is starting this frame...
            if instr_text_vivant_2.status == NOT_STARTED and curIns == 2:
                # keep track of start time/frame for later
                instr_text_vivant_2.frameNStart = frameN  # exact frame index
                instr_text_vivant_2.tStart = t  # local t and not account for scr refresh
                instr_text_vivant_2.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(instr_text_vivant_2, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'instr_text_vivant_2.started')
                # update status
                instr_text_vivant_2.status = STARTED
                instr_text_vivant_2.setAutoDraw(True)
            
            # if instr_text_vivant_2 is active this frame...
            if instr_text_vivant_2.status == STARTED:
                # update params
                pass
            
            # if instr_text_vivant_2 is stopping this frame...
            if instr_text_vivant_2.status == STARTED:
                if bool(curIns == 3):
                    # keep track of stop time/frame for later
                    instr_text_vivant_2.tStop = t  # not accounting for scr refresh
                    instr_text_vivant_2.frameNStop = frameN  # exact frame index
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'instr_text_vivant_2.stopped')
                    # update status
                    instr_text_vivant_2.status = FINISHED
                    instr_text_vivant_2.setAutoDraw(False)
            
            # *instr_text_vivant_3* updates
            
            # if instr_text_vivant_3 is active this frame...
            if instr_text_vivant_3.status == STARTED:
                # update params
                pass
            
            # *instr_text_vivant_4* updates
            
            # if instr_text_vivant_4 is starting this frame...
            if instr_text_vivant_4.status == NOT_STARTED and curIns == 4:
                # keep track of start time/frame for later
                instr_text_vivant_4.frameNStart = frameN  # exact frame index
                instr_text_vivant_4.tStart = t  # local t and not account for scr refresh
                instr_text_vivant_4.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(instr_text_vivant_4, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'instr_text_vivant_4.started')
                # update status
                instr_text_vivant_4.status = STARTED
                instr_text_vivant_4.setAutoDraw(True)
            
            # if instr_text_vivant_4 is active this frame...
            if instr_text_vivant_4.status == STARTED:
                # update params
                pass
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
                if eyetracker:
                    eyetracker.setConnectionState(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in instr_vivantComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "instr_vivant" ---
        for thisComponent in instr_vivantComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # Run 'End Routine' code from code_instr_vivant
        if current_practice == 2:
            two_exemple = 2
        else:
            two_exemple = 1
            
        # store data for practices_bloc (TrialHandler)
        # store data for practices_bloc (TrialHandler)
        x, y = joystick_2.getX(), joystick_2.getY()
        joystick_2.newButtonState = joystick_2.getAllButtons()[:]
        joystick_2.pressedState = [joystick_2.newButtonState[i] for i in range(joystick_2.numButtons)]
        joystick_2.time = joystick_2.joystickClock.getTime()
        practices_bloc.addData('joystick_2.x', x)
        practices_bloc.addData('joystick_2.y', y)
        [practices_bloc.addData('joystick_2.button_{0}'.format(i), int(joystick_2.pressedState[i])) for i in joystick_2.activeButtons]
        practices_bloc.addData('joystick_2.time', joystick_2.time)
        # the Routine "instr_vivant" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # set up handler to look after randomisation of conditions etc
        loop_ex = data.TrialHandler(nReps=two_exemple, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=[None],
            seed=None, name='loop_ex')
        thisExp.addLoop(loop_ex)  # add the loop to the experiment
        thisLoop_ex = loop_ex.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisLoop_ex.rgb)
        if thisLoop_ex != None:
            for paramName in thisLoop_ex:
                exec('{} = thisLoop_ex[paramName]'.format(paramName))
        
        for thisLoop_ex in loop_ex:
            currentLoop = loop_ex
            # abbreviate parameter names if possible (e.g. rgb = thisLoop_ex.rgb)
            if thisLoop_ex != None:
                for paramName in thisLoop_ex:
                    exec('{} = thisLoop_ex[paramName]'.format(paramName))
            
            # --- Prepare to start Routine "ex" ---
            continueRoutine = True
            # update component parameters for each repeat
            # Run 'Begin Routine' code from code_ex
            trialClock = core.Clock()
            trialClock.reset() 
            timeElapsed= None
            
            timeQue = 3
            timeFix = 3
            
            if current_practice == 1:
                if "V1" in expInfo['choiceTrial']:
                    img1Ex = "images/Tack.bmp"
                    img2Ex = "images/File.bmp"
                else:
                    img1Ex = "images/Disk.bmp"
                    img2Ex = "images/Baseball.bmp"
                if english == True:
                    que_txtEx.text = "LIVING?"
                    ans_yes_ex.text = "YES"
                    ans_no_ex.text = "NO"
                    text_Ex.text = "Go ahead and answer 'yes' or 'no' whether you think at \nleast one of these practice images is living."
                else:
                    que_txtEx.text = "VIVANT?"
                    ans_yes_ex.text = "OUI"
                    ans_no_ex.text = "NON"
                    text_Ex.text = "Répondez par 'oui' ou par 'non' si vous pensez qu'au \nmoins une de ces images est vivante."
            elif current_practice == 2:
                if "V1" in expInfo['choiceTrial']:
                    img1Ex = "images/HotDog.bmp"
                    img2Ex = "images/Chest.bmp"
                else:
                    img1Ex = "images/Lipstick.bmp"
                    img2Ex = "images/Hamper.bmp"
                if english == True:
                    que_txtEx.text = "INSIDE?"
                    ans_yes_ex.text = "YES"
                    ans_no_ex.text = "NO"
                    if "V1" in expInfo['choiceTrial']:
                        text_Ex.text = "In this example there is a hotdog and a chest. You would respond \n'yes' to this example because a hotdog can fit inside a chest. \n\nGo ahead and push the 'yes' for this example."
                    else:
                        text_Ex.text = "In this example there is a lipstick and a hamper. You would respond \n'yes' to this example because a lipstick can fit inside a hamper. \n\nGo ahead and push the 'yes' for this example."
                else:
                    que_txtEx.text = "À L'INTÉRIEUR?"
                    ans_yes_ex.text = "OUI"
                    ans_no_ex.text = "NON"
                    if "V1" in expInfo['choiceTrial']:
                        text_Ex.text = "Dans cet exemple, il y a un hot-dog et un coffre. Vous répondriez \n'oui' à cet exemple parce qu'un hot-dog peut tenir dans un coffre. \n\nAllez-y et appuyez sur 'oui' pour cet exemple."        
                    else:
                        text_Ex.text = "Dans cet exemple, il y a un rouge à lèvres et un panier. Vous répondriez \n'oui' à cet exemple parce qu'un rouge à lèvres peut tenir dans un panier. \n\nAllez-y et appuyez sur 'oui' pour cet exemple."
            elif current_practice == 3:
                if "V1" in expInfo['choiceTrial']:
                    img1Ex = "images/Chopsticks.bmp"
                    img2Ex = "images/Needle.bmp"
                else:
                    img1Ex = "images/Kazoo.bmp"
                    img2Ex = "images/Dart.bmp"
                if english == True:
                    que_txtEx.text = "INSIDE?"
                    ans_yes_ex.text = "YES"
                    ans_no_ex.text = "NO"
                    if "V1" in expInfo['choiceTrial']:
                        text_Ex.text = "In this example there is a chopsticks and a needle. In this example you \nwould respond 'no' because neither of the objects can fit inside the other. \n\nGo ahead and push the 'no' for this example."
                    else:
                        text_Ex.text = "In this example there is a kazoo and a dart. In this example you would \nrespond 'no' because neither of the objects can fit inside the other. \n\nGo ahead and push the 'no' for this example."
                else:
                    que_txtEx.text = "À L'INTÉRIEUR?"
                    ans_yes_ex.text = "OUI"
                    ans_no_ex.text = "NON"
                    if "V1" in expInfo['choiceTrial']:
                        text_Ex.text = "Dans cet exemple, il y a des baguettes et une aiguille. Dans cet exemple, \nvous répondriez 'non' car aucun des objets ne peut entrer dans l'autre. \n\nAllez-y et appuyez sur 'non' pour cet exemple."      
                    else:
                        text_Ex.text = "Dans cet exemple, il y a un kazoo et une fléchette. Dans cet exemple, vous \nrépondriez 'non' car aucun des objets ne peut entrer dans l'autre. \n\nAllez-y et appuyez sur 'non' pour cet exemple."
            
                
             #By default the elements did not start so they are not finished
            item1_finished = False
            que_finished = False
            item2_finished = False
            
            # Record if the participant answered
            participant_answered = False
            hide_img2 = False
            
            # When true, we reached the end of img2 without any answer
            no_answers = False
            display_fix = False
            
            # Reset the response of the participant
            response_Ex.text = ""
            item1_imgEx.setImage(img1Ex)
            item2_imgEx.setImage(img2Ex)
            key_Ex.keys = []
            key_Ex.rt = []
            _key_Ex_allKeys = []
            joystick_Ex.oldButtonState = joystick_Ex.device.getAllButtons()[:]
            joystick_Ex.activeButtons=[1, 2]
            # setup some python lists for storing info about the joystick_Ex
            gotValidClick = False  # until a click is received
            # keep track of which components have finished
            exComponents = [item1_imgEx, que_txtEx, item2_imgEx, response_Ex, timer_Ex, fix_text_Ex, key_Ex, joystick_Ex, text_Ex, ans_yes_ex, ans_no_ex]
            for thisComponent in exComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "ex" ---
            routineForceEnded = not continueRoutine
            while continueRoutine:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                # Run 'Each Frame' code from code_ex
                # Reset buttons if they are not pressed
                if button_down and not joystick_Ex.getAllButtons()[0] and not '1' in key_Ex.keys:
                   button_down = False
                
                if current_practice == 2:
                   # Button 1 is pressed
                    if not item2_finished and not button_down and (joystick_Ex.getAllButtons()[0] or "1" in key_Ex.keys):
                        button_down = True
                        response_Ex.text = 1
                        participant_answered = True 
                if current_practice == 3:
                    # Button 2 is pressed
                    if not item2_finished and not button_down and (joystick_Ex.getAllButtons()[2] or "2" in key_Ex.keys):
                        button_down = True
                        response_Ex.text = 2
                        participant_answered = True
                if current_practice == 1:
                    # Register participant's answers
                    # Button 1 is pressed
                    if not item2_finished and not button_down and (joystick_Ex.getAllButtons()[0] or "1" in key_Ex.keys):
                        button_down = True
                        response_Ex.text = 1
                        participant_answered = True
                
                    # Register participant's answers
                    # Button 2 is pressed
                    elif not item2_finished and not button_down and (joystick_Ex.getAllButtons()[2] or "2" in key_Ex.keys):
                        button_down = True
                        response_Ex.text = 2
                        participant_answered = True
                
                    # Register participant's answers
                    #4s countdown are done
                    elif not no_answers and not participant_answered and timer_Ex.status == FINISHED:
                        response_Ex.finished = True
                        no_answers = True
                
                #Set the boolean to true when the item2 is done
                if timer_Ex.status == FINISHED:
                    response_Ex.finished = True
                    display_fix = True
                    continueRoutine = False
                
                #Go to next routine when fixation cross is done
                #if fix_text_Ex.status == FINISHED:
                #    continueRoutine = False
                
                # *item1_imgEx* updates
                
                # if item1_imgEx is starting this frame...
                if item1_imgEx.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    item1_imgEx.frameNStart = frameN  # exact frame index
                    item1_imgEx.tStart = t  # local t and not account for scr refresh
                    item1_imgEx.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(item1_imgEx, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'item1_imgEx.started')
                    # update status
                    item1_imgEx.status = STARTED
                    item1_imgEx.setAutoDraw(True)
                
                # if item1_imgEx is active this frame...
                if item1_imgEx.status == STARTED:
                    # update params
                    pass
                
                # if item1_imgEx is stopping this frame...
                if item1_imgEx.status == STARTED:
                    if bool(participant_answered):
                        # keep track of stop time/frame for later
                        item1_imgEx.tStop = t  # not accounting for scr refresh
                        item1_imgEx.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'item1_imgEx.stopped')
                        # update status
                        item1_imgEx.status = FINISHED
                        item1_imgEx.setAutoDraw(False)
                
                # *que_txtEx* updates
                
                # if que_txtEx is starting this frame...
                if que_txtEx.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                    # keep track of start time/frame for later
                    que_txtEx.frameNStart = frameN  # exact frame index
                    que_txtEx.tStart = t  # local t and not account for scr refresh
                    que_txtEx.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(que_txtEx, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'que_txtEx.started')
                    # update status
                    que_txtEx.status = STARTED
                    que_txtEx.setAutoDraw(True)
                
                # if que_txtEx is active this frame...
                if que_txtEx.status == STARTED:
                    # update params
                    pass
                
                # if que_txtEx is stopping this frame...
                if que_txtEx.status == STARTED:
                    if bool(participant_answered):
                        # keep track of stop time/frame for later
                        que_txtEx.tStop = t  # not accounting for scr refresh
                        que_txtEx.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'que_txtEx.stopped')
                        # update status
                        que_txtEx.status = FINISHED
                        que_txtEx.setAutoDraw(False)
                
                # *item2_imgEx* updates
                
                # if item2_imgEx is starting this frame...
                if item2_imgEx.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                    # keep track of start time/frame for later
                    item2_imgEx.frameNStart = frameN  # exact frame index
                    item2_imgEx.tStart = t  # local t and not account for scr refresh
                    item2_imgEx.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(item2_imgEx, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'item2_imgEx.started')
                    # update status
                    item2_imgEx.status = STARTED
                    item2_imgEx.setAutoDraw(True)
                
                # if item2_imgEx is active this frame...
                if item2_imgEx.status == STARTED:
                    # update params
                    pass
                
                # if item2_imgEx is stopping this frame...
                if item2_imgEx.status == STARTED:
                    if bool(participant_answered):
                        # keep track of stop time/frame for later
                        item2_imgEx.tStop = t  # not accounting for scr refresh
                        item2_imgEx.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'item2_imgEx.stopped')
                        # update status
                        item2_imgEx.status = FINISHED
                        item2_imgEx.setAutoDraw(False)
                
                # *response_Ex* updates
                
                # if response_Ex is starting this frame...
                if response_Ex.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                    # keep track of start time/frame for later
                    response_Ex.frameNStart = frameN  # exact frame index
                    response_Ex.tStart = t  # local t and not account for scr refresh
                    response_Ex.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(response_Ex, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'response_Ex.started')
                    # update status
                    response_Ex.status = STARTED
                    response_Ex.setAutoDraw(True)
                
                # if response_Ex is active this frame...
                if response_Ex.status == STARTED:
                    # update params
                    pass
                
                # if response_Ex is stopping this frame...
                if response_Ex.status == STARTED:
                    if bool(participant_answered):
                        # keep track of stop time/frame for later
                        response_Ex.tStop = t  # not accounting for scr refresh
                        response_Ex.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'response_Ex.stopped')
                        # update status
                        response_Ex.status = FINISHED
                        response_Ex.setAutoDraw(False)
                
                # *timer_Ex* updates
                
                # if timer_Ex is starting this frame...
                if timer_Ex.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                    # keep track of start time/frame for later
                    timer_Ex.frameNStart = frameN  # exact frame index
                    timer_Ex.tStart = t  # local t and not account for scr refresh
                    timer_Ex.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(timer_Ex, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'timer_Ex.started')
                    # update status
                    timer_Ex.status = STARTED
                    timer_Ex.setAutoDraw(True)
                
                # if timer_Ex is active this frame...
                if timer_Ex.status == STARTED:
                    # update params
                    pass
                
                # if timer_Ex is stopping this frame...
                if timer_Ex.status == STARTED:
                    if bool(participant_answered):
                        # keep track of stop time/frame for later
                        timer_Ex.tStop = t  # not accounting for scr refresh
                        timer_Ex.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'timer_Ex.stopped')
                        # update status
                        timer_Ex.status = FINISHED
                        timer_Ex.setAutoDraw(False)
                
                # *fix_text_Ex* updates
                
                # if fix_text_Ex is starting this frame...
                if fix_text_Ex.status == NOT_STARTED and display_fix == 1:
                    # keep track of start time/frame for later
                    fix_text_Ex.frameNStart = frameN  # exact frame index
                    fix_text_Ex.tStart = t  # local t and not account for scr refresh
                    fix_text_Ex.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fix_text_Ex, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'fix_text_Ex.started')
                    # update status
                    fix_text_Ex.status = STARTED
                    fix_text_Ex.setAutoDraw(True)
                
                # if fix_text_Ex is active this frame...
                if fix_text_Ex.status == STARTED:
                    # update params
                    pass
                
                # if fix_text_Ex is stopping this frame...
                if fix_text_Ex.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fix_text_Ex.tStartRefresh + timeFix-frameTolerance:
                        # keep track of stop time/frame for later
                        fix_text_Ex.tStop = t  # not accounting for scr refresh
                        fix_text_Ex.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'fix_text_Ex.stopped')
                        # update status
                        fix_text_Ex.status = FINISHED
                        fix_text_Ex.setAutoDraw(False)
                
                # *key_Ex* updates
                waitOnFlip = False
                
                # if key_Ex is starting this frame...
                if key_Ex.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    key_Ex.frameNStart = frameN  # exact frame index
                    key_Ex.tStart = t  # local t and not account for scr refresh
                    key_Ex.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key_Ex, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'key_Ex.started')
                    # update status
                    key_Ex.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key_Ex.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(key_Ex.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if key_Ex.status == STARTED and not waitOnFlip:
                    theseKeys = key_Ex.getKeys(keyList=['1','2','esc'], waitRelease=False)
                    _key_Ex_allKeys.extend(theseKeys)
                    if len(_key_Ex_allKeys):
                        key_Ex.keys = _key_Ex_allKeys[-1].name  # just the last key pressed
                        key_Ex.rt = _key_Ex_allKeys[-1].rt
                        key_Ex.duration = _key_Ex_allKeys[-1].duration
                
                # *text_Ex* updates
                
                # if text_Ex is starting this frame...
                if text_Ex.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    text_Ex.frameNStart = frameN  # exact frame index
                    text_Ex.tStart = t  # local t and not account for scr refresh
                    text_Ex.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(text_Ex, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'text_Ex.started')
                    # update status
                    text_Ex.status = STARTED
                    text_Ex.setAutoDraw(True)
                
                # if text_Ex is active this frame...
                if text_Ex.status == STARTED:
                    # update params
                    pass
                
                # *ans_yes_ex* updates
                
                # if ans_yes_ex is starting this frame...
                if ans_yes_ex.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    ans_yes_ex.frameNStart = frameN  # exact frame index
                    ans_yes_ex.tStart = t  # local t and not account for scr refresh
                    ans_yes_ex.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(ans_yes_ex, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'ans_yes_ex.started')
                    # update status
                    ans_yes_ex.status = STARTED
                    ans_yes_ex.setAutoDraw(True)
                
                # if ans_yes_ex is active this frame...
                if ans_yes_ex.status == STARTED:
                    # update params
                    pass
                
                # if ans_yes_ex is stopping this frame...
                if ans_yes_ex.status == STARTED:
                    if bool(participant_answered):
                        # keep track of stop time/frame for later
                        ans_yes_ex.tStop = t  # not accounting for scr refresh
                        ans_yes_ex.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'ans_yes_ex.stopped')
                        # update status
                        ans_yes_ex.status = FINISHED
                        ans_yes_ex.setAutoDraw(False)
                
                # *ans_no_ex* updates
                
                # if ans_no_ex is starting this frame...
                if ans_no_ex.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    ans_no_ex.frameNStart = frameN  # exact frame index
                    ans_no_ex.tStart = t  # local t and not account for scr refresh
                    ans_no_ex.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(ans_no_ex, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'ans_no_ex.started')
                    # update status
                    ans_no_ex.status = STARTED
                    ans_no_ex.setAutoDraw(True)
                
                # if ans_no_ex is active this frame...
                if ans_no_ex.status == STARTED:
                    # update params
                    pass
                
                # if ans_no_ex is stopping this frame...
                if ans_no_ex.status == STARTED:
                    if bool(participant_answered):
                        # keep track of stop time/frame for later
                        ans_no_ex.tStop = t  # not accounting for scr refresh
                        ans_no_ex.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'ans_no_ex.stopped')
                        # update status
                        ans_no_ex.status = FINISHED
                        ans_no_ex.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in exComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "ex" ---
            for thisComponent in exComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # Run 'End Routine' code from code_ex
            participant_answered = False
            
            if current_practice == 2:
                current_practice += 1
            elif current_practice == 3:
                current_practice -= 1
            # check responses
            if key_Ex.keys in ['', [], None]:  # No response was made
                key_Ex.keys = None
            loop_ex.addData('key_Ex.keys',key_Ex.keys)
            if key_Ex.keys != None:  # we had a response
                loop_ex.addData('key_Ex.rt', key_Ex.rt)
                loop_ex.addData('key_Ex.duration', key_Ex.duration)
            # store data for loop_ex (TrialHandler)
            # store data for loop_ex (TrialHandler)
            x, y = joystick_Ex.getX(), joystick_Ex.getY()
            joystick_Ex.newButtonState = joystick_Ex.getAllButtons()[:]
            joystick_Ex.pressedState = [joystick_Ex.newButtonState[i] for i in range(joystick_Ex.numButtons)]
            joystick_Ex.time = joystick_Ex.joystickClock.getTime()
            loop_ex.addData('joystick_Ex.x', x)
            loop_ex.addData('joystick_Ex.y', y)
            [loop_ex.addData('joystick_Ex.button_{0}'.format(i), int(joystick_Ex.pressedState[i])) for i in joystick_Ex.activeButtons]
            loop_ex.addData('joystick_Ex.time', joystick_Ex.time)
            # the Routine "ex" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
        # completed two_exemple repeats of 'loop_ex'
        
        
        # --- Prepare to start Routine "next_instr" ---
        continueRoutine = True
        # update component parameters for each repeat
        # Run 'Begin Routine' code from code_next_instr
        if current_practice == 1:
            if english == True:
                text_next_instr.text = "Now we are going to try some practice items. \nAfter each pair of items, there will be a fixation\n cross (+). You should look at this cross when \nthere are no images on the screen.\n\nDo you have any questions before we start?\nRemember to respond as quickly as you can!\n\nRespond 'yes' to begin the practice."
            else:
                text_next_instr.text = "Nous allons maintenant essayer quelques objets\n de pratique. Après chaque paire d'objets, il y aura\n une croix de fixation (+). Vous devez regarder\n cette croix lorsqu'il n'y a pas d'images à l'écran.\n\nAvez-vous des questions avant de commencer?\n\nSouvenez-vous de répondre aussi rapidement que possible!\n\nRépondez 'oui' pour commencer la pratique."
        elif  current_practice == 2:
            if english == True:
                text_next_instr.text = "Now we are going to try some practice items. \nAfter each pair of items, there will be a fixation\n cross (+). You should look at this cross when \nthere are no images on the screen.\n\nDo you have any questions before we start?\nRemember to respond as quickly as you can!\n\nRespond 'yes' to begin the practice."
            else:
                text_next_instr.text = "Nous allons maintenant essayer quelques objets\n de pratique. Après chaque paire d'objets, il y aura\n une croix de fixation (+). Vous devez regarder\n cette croix lorsqu'il n'y a pas d'images à l'écran.\n\nAvez-vous des questions avant de commencer?\n\nSouvenez-vous de répondre aussi rapidement que possible!\n\nRépondez 'oui' pour commencer la pratique."
        
        
        key_next_instr.keys = []
        key_next_instr.rt = []
        _key_next_instr_allKeys = []
        joystick_3.oldButtonState = joystick_3.device.getAllButtons()[:]
        joystick_3.activeButtons=[1]
        # setup some python lists for storing info about the joystick_3
        gotValidClick = False  # until a click is received
        # keep track of which components have finished
        next_instrComponents = [text_next_instr, key_next_instr, joystick_3]
        for thisComponent in next_instrComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        frameN = -1
        
        # --- Run Routine "next_instr" ---
        routineForceEnded = not continueRoutine
        while continueRoutine:
            # get current time
            t = routineTimer.getTime()
            tThisFlip = win.getFutureFlipTime(clock=routineTimer)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            # Run 'Each Frame' code from code_next_instr
            # Reset buttons if they are not pressed
            if button_down  and not joystick_3.getAllButtons()[0]:
               button_down = False
            
            # Go to next routine
            if not button_down and (joystick_3.getAllButtons()[0]):
                button_down = True
                continueRoutine = False
            
            # *text_next_instr* updates
            
            # if text_next_instr is starting this frame...
            if text_next_instr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_next_instr.frameNStart = frameN  # exact frame index
                text_next_instr.tStart = t  # local t and not account for scr refresh
                text_next_instr.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_next_instr, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'text_next_instr.started')
                # update status
                text_next_instr.status = STARTED
                text_next_instr.setAutoDraw(True)
            
            # if text_next_instr is active this frame...
            if text_next_instr.status == STARTED:
                # update params
                pass
            
            # *key_next_instr* updates
            waitOnFlip = False
            
            # if key_next_instr is starting this frame...
            if key_next_instr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                key_next_instr.frameNStart = frameN  # exact frame index
                key_next_instr.tStart = t  # local t and not account for scr refresh
                key_next_instr.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(key_next_instr, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'key_next_instr.started')
                # update status
                key_next_instr.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(key_next_instr.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(key_next_instr.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if key_next_instr.status == STARTED and not waitOnFlip:
                theseKeys = key_next_instr.getKeys(keyList=['1'], waitRelease=False)
                _key_next_instr_allKeys.extend(theseKeys)
                if len(_key_next_instr_allKeys):
                    key_next_instr.keys = _key_next_instr_allKeys[-1].name  # just the last key pressed
                    key_next_instr.rt = _key_next_instr_allKeys[-1].rt
                    key_next_instr.duration = _key_next_instr_allKeys[-1].duration
                    # a response ends the routine
                    continueRoutine = False
            # *joystick_3* updates
            
            # if joystick_3 is starting this frame...
            if joystick_3.status == NOT_STARTED and t >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                joystick_3.frameNStart = frameN  # exact frame index
                joystick_3.tStart = t  # local t and not account for scr refresh
                joystick_3.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(joystick_3, 'tStartRefresh')  # time at next scr refresh
                # add timestamp to datafile
                thisExp.addData('joystick_3.started', t)
                # update status
                joystick_3.status = STARTED
                joystick_3.status = STARTED
                joystick_3.joystickClock.reset()
            if joystick_3.status == STARTED:  # only update if started and not finished!
                joystick_3.newButtonState = joystick_3.getAllButtons()[:]
                if joystick_3.newButtonState != joystick_3.oldButtonState: # New button press
                    joystick_3.pressedButtons = [i for i in range(joystick_3.numButtons) if joystick_3.newButtonState[i] and not joystick_3.oldButtonState[i]]
                    joystick_3.releasedButtons = [i for i in range(joystick_3.numButtons) if not joystick_3.newButtonState[i] and joystick_3.oldButtonState[i]]
                    joystick_3.newPressedButtons = [i for i in joystick_3.activeButtons if i in joystick_3.pressedButtons]
                    joystick_3.oldButtonState = joystick_3.newButtonState
                    joystick_3.buttons = joystick_3.newPressedButtons
                    [logging.data("joystick_{}_button: {}, pos=({:1.4f},{:1.4f})".format(joystick_3.device_number, i, joystick_3.getX(), joystick_3.getY())) for i in joystick_3.pressedButtons]
                    if len(joystick_3.buttons) > 0:  # state changed to a new click
                        if gotValidClick:  # abort routine on response
                            continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
                if eyetracker:
                    eyetracker.setConnectionState(False)
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                routineForceEnded = True
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in next_instrComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # --- Ending Routine "next_instr" ---
        for thisComponent in next_instrComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        # check responses
        if key_next_instr.keys in ['', [], None]:  # No response was made
            key_next_instr.keys = None
        practices_bloc.addData('key_next_instr.keys',key_next_instr.keys)
        if key_next_instr.keys != None:  # we had a response
            practices_bloc.addData('key_next_instr.rt', key_next_instr.rt)
            practices_bloc.addData('key_next_instr.duration', key_next_instr.duration)
        # store data for practices_bloc (TrialHandler)
        # store data for practices_bloc (TrialHandler)
        x, y = joystick_3.getX(), joystick_3.getY()
        joystick_3.newButtonState = joystick_3.getAllButtons()[:]
        joystick_3.pressedState = [joystick_3.newButtonState[i] for i in range(joystick_3.numButtons)]
        joystick_3.time = joystick_3.joystickClock.getTime()
        practices_bloc.addData('joystick_3.x', x)
        practices_bloc.addData('joystick_3.y', y)
        [practices_bloc.addData('joystick_3.button_{0}'.format(i), int(joystick_3.pressedState[i])) for i in joystick_3.activeButtons]
        practices_bloc.addData('joystick_3.time', joystick_3.time)
        # the Routine "next_instr" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # set up handler to look after randomisation of conditions etc
        prac_repeat = data.TrialHandler(nReps=100.0, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=[None],
            seed=None, name='prac_repeat')
        thisExp.addLoop(prac_repeat)  # add the loop to the experiment
        thisPrac_repeat = prac_repeat.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisPrac_repeat.rgb)
        if thisPrac_repeat != None:
            for paramName in thisPrac_repeat:
                exec('{} = thisPrac_repeat[paramName]'.format(paramName))
        
        for thisPrac_repeat in prac_repeat:
            currentLoop = prac_repeat
            # abbreviate parameter names if possible (e.g. rgb = thisPrac_repeat.rgb)
            if thisPrac_repeat != None:
                for paramName in thisPrac_repeat:
                    exec('{} = thisPrac_repeat[paramName]'.format(paramName))
            
            # set up handler to look after randomisation of conditions etc
            practice = data.TrialHandler(nReps=1.0, method='sequential', 
                extraInfo=expInfo, originPath=-1,
                trialList=data.importConditions(practConditions),
                seed=None, name='practice')
            thisExp.addLoop(practice)  # add the loop to the experiment
            thisPractice = practice.trialList[0]  # so we can initialise stimuli with some values
            # abbreviate parameter names if possible (e.g. rgb = thisPractice.rgb)
            if thisPractice != None:
                for paramName in thisPractice:
                    exec('{} = thisPractice[paramName]'.format(paramName))
            
            for thisPractice in practice:
                currentLoop = practice
                # abbreviate parameter names if possible (e.g. rgb = thisPractice.rgb)
                if thisPractice != None:
                    for paramName in thisPractice:
                        exec('{} = thisPractice[paramName]'.format(paramName))
                
                # --- Prepare to start Routine "pract" ---
                continueRoutine = True
                # update component parameters for each repeat
                # Run 'Begin Routine' code from code_pr
                trialClock = core.Clock()
                trialClock.reset() 
                timeElapsed= None
                # The response period started when image 2 started. No need to save it.
                #response_time_pr = -1. # Save when the participant answered (in secs)
                # set the images by parameters of condition file
                img1 = LeftStim
                img2 = RightStim
                # set the good response in a variable
                #response = CorrectResponse
                # Set the duration of the fixation cross and the question
                timeQue = DurationQuestion/1000 #duration of the question
                timeFix = FixDelay/1000 #duration of the fixation cross
                #By default the elements did not start so they are not finished
                item1_finished = False
                que_finished = False
                item2_finished = False
                # Record if the participant answered
                participant_answered = False
                #hide_img2 = False
                # When true, we reached the end of img2 without any answer
                no_answers = False
                im2pratRT = None
                # Reset the response of the participant
                response_pr = 0
                display_fix = False
                lenght = 0
                time_last_responses_pract = 0
                first_frame = True
                startTime = 0
                joyst = 0
                timer_time = 5
                show_img = False
                
                # Change displayed text based on the language previously chosen
                if english == True:
                    ans_yes_prac.text = "YES"
                    ans_no_prac.text = "NO"
                    que_text_pr.text = QuestionEnglish
                else:
                    que_text_pr.text = QuestionFrench
                    ans_yes_prac.text = "OUI"
                    ans_no_prac.text = "NON"
                    
                item1_img_pr.setImage(img1)
                item2_img_pr.setImage(img2)
                key_prac.keys = []
                key_prac.rt = []
                _key_prac_allKeys = []
                joystick_prac.oldButtonState = joystick_prac.device.getAllButtons()[:]
                joystick_prac.activeButtons=[i for i in range(joystick_prac.numButtons)]
                # setup some python lists for storing info about the joystick_prac
                gotValidClick = False  # until a click is received
                # keep track of which components have finished
                practComponents = [ans_no_prac, ans_yes_prac, item1_img_pr, que_text_pr, item2_img_pr, timer_pr, timer_timed_pr, fix_text_pr, key_prac, joystick_prac]
                for thisComponent in practComponents:
                    thisComponent.tStart = None
                    thisComponent.tStop = None
                    thisComponent.tStartRefresh = None
                    thisComponent.tStopRefresh = None
                    if hasattr(thisComponent, 'status'):
                        thisComponent.status = NOT_STARTED
                # reset timers
                t = 0
                _timeToFirstFrame = win.getFutureFlipTime(clock="now")
                frameN = -1
                
                # --- Run Routine "pract" ---
                routineForceEnded = not continueRoutine
                while continueRoutine:
                    # get current time
                    t = routineTimer.getTime()
                    tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                    # update/draw components on each frame
                    # Run 'Each Frame' code from code_pr
                    # Reset buttons if they are not pressed
                    if button_down and not joystick_prac.getAllButtons()[0]:
                       button_down = False
                    
                    if first_frame:
                        startTime = joystick_prac.joystickClock.getTime()
                        first_frame = False
                    
                    if (len(key_prac.keys) > 0):
                        #added this because the escape key print out as an 'e'
                        if key_prac.keys[-1] =='e' or key_prac.keys[-1] =='escape':
                            core.quit() 
                     
                    # Register participant's answers
                    # Button 1 is pressed
                    if(len(key_prac.keys) > lenght and not item2_finished):
                        # Button 1 is pressed
                       if key_prac.keys[-1] == '1':
                            response_pr = 1
                            participant_answered = True
                            lenght = len(key_prac.keys)
                            time_last_responses_pract = key_prac.rt[-1]
                        # Button 2 is pressed
                       elif key_prac.keys[-1] == '2':
                            response_pr = 2
                            participant_answered = True
                            lenght = len(key_prac.keys)
                            time_last_responses_pract = key_prac.rt[-1]
                    # Button 1 is pressed
                    elif not item2_finished and not button_down and joystick_prac.getAllButtons()[0]:
                        response_pr = 1
                        participant_answered = True
                        button_down = True
                        thisExp.addData(f"pressedbuttonJ{joyst}", 1)
                        thisExp.addData(f"timebuttonJ{joyst}", joystick_prac.joystickClock.getTime() - startTime)
                        joyst += 1
                        time_last_responses_pract = joystick_prac.joystickClock.getTime() - startTime
                    # Button 2 is pressed
                    elif not item2_finished and not button_down and joystick_prac.getAllButtons()[2]:
                        response_pr = 2
                        participant_answered = True
                        button_down = True
                        thisExp.addData(f"pressedbuttonJ{joyst}", 2)
                        thisExp.addData(f"timebuttonJ{joyst}", joystick_prac.joystickClock.getTime() - startTime)
                        joyst += 1
                        time_last_responses_pract = joystick_prac.joystickClock.getTime() - startTime
                        
                    
                    # Register participant's answers
                    #4s countdown are done
                    elif not no_answers and not participant_answered and timer_pr.status == FINISHED:
                        no_answers = True
                    
                    #Set the boolean to true when the item2 is done
                    if item2_img_pr.status == FINISHED and not item2_finished and not no_answers:
                        item2_finished = True
                    
                    #Go to next routine when fixation cross is done
                    if fix_text_pr.status == FINISHED:
                        continueRoutine = False
                        
                    if timer_timed_pr.status == FINISHED:
                        display_fix = True 
                        show_img = display_fix
                    
                    
                    
                    # *ans_no_prac* updates
                    
                    # if ans_no_prac is starting this frame...
                    if ans_no_prac.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                        # keep track of start time/frame for later
                        ans_no_prac.frameNStart = frameN  # exact frame index
                        ans_no_prac.tStart = t  # local t and not account for scr refresh
                        ans_no_prac.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(ans_no_prac, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'ans_no_prac.started')
                        # update status
                        ans_no_prac.status = STARTED
                        ans_no_prac.setAutoDraw(True)
                    
                    # if ans_no_prac is active this frame...
                    if ans_no_prac.status == STARTED:
                        # update params
                        pass
                    
                    # if ans_no_prac is stopping this frame...
                    if ans_no_prac.status == STARTED:
                        if bool(show_img):
                            # keep track of stop time/frame for later
                            ans_no_prac.tStop = t  # not accounting for scr refresh
                            ans_no_prac.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'ans_no_prac.stopped')
                            # update status
                            ans_no_prac.status = FINISHED
                            ans_no_prac.setAutoDraw(False)
                    
                    # *ans_yes_prac* updates
                    
                    # if ans_yes_prac is starting this frame...
                    if ans_yes_prac.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                        # keep track of start time/frame for later
                        ans_yes_prac.frameNStart = frameN  # exact frame index
                        ans_yes_prac.tStart = t  # local t and not account for scr refresh
                        ans_yes_prac.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(ans_yes_prac, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'ans_yes_prac.started')
                        # update status
                        ans_yes_prac.status = STARTED
                        ans_yes_prac.setAutoDraw(True)
                    
                    # if ans_yes_prac is active this frame...
                    if ans_yes_prac.status == STARTED:
                        # update params
                        pass
                    
                    # if ans_yes_prac is stopping this frame...
                    if ans_yes_prac.status == STARTED:
                        if bool(show_img):
                            # keep track of stop time/frame for later
                            ans_yes_prac.tStop = t  # not accounting for scr refresh
                            ans_yes_prac.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'ans_yes_prac.stopped')
                            # update status
                            ans_yes_prac.status = FINISHED
                            ans_yes_prac.setAutoDraw(False)
                    
                    # *item1_img_pr* updates
                    
                    # if item1_img_pr is starting this frame...
                    if item1_img_pr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                        # keep track of start time/frame for later
                        item1_img_pr.frameNStart = frameN  # exact frame index
                        item1_img_pr.tStart = t  # local t and not account for scr refresh
                        item1_img_pr.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(item1_img_pr, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'item1_img_pr.started')
                        # update status
                        item1_img_pr.status = STARTED
                        item1_img_pr.setAutoDraw(True)
                    
                    # if item1_img_pr is active this frame...
                    if item1_img_pr.status == STARTED:
                        # update params
                        pass
                    
                    # if item1_img_pr is stopping this frame...
                    if item1_img_pr.status == STARTED:
                        if bool(show_img):
                            # keep track of stop time/frame for later
                            item1_img_pr.tStop = t  # not accounting for scr refresh
                            item1_img_pr.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'item1_img_pr.stopped')
                            # update status
                            item1_img_pr.status = FINISHED
                            item1_img_pr.setAutoDraw(False)
                    
                    # *que_text_pr* updates
                    
                    # if que_text_pr is starting this frame...
                    if que_text_pr.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                        # keep track of start time/frame for later
                        que_text_pr.frameNStart = frameN  # exact frame index
                        que_text_pr.tStart = t  # local t and not account for scr refresh
                        que_text_pr.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(que_text_pr, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'que_text_pr.started')
                        # update status
                        que_text_pr.status = STARTED
                        que_text_pr.setAutoDraw(True)
                    
                    # if que_text_pr is active this frame...
                    if que_text_pr.status == STARTED:
                        # update params
                        pass
                    
                    # if que_text_pr is stopping this frame...
                    if que_text_pr.status == STARTED:
                        if bool(show_img):
                            # keep track of stop time/frame for later
                            que_text_pr.tStop = t  # not accounting for scr refresh
                            que_text_pr.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'que_text_pr.stopped')
                            # update status
                            que_text_pr.status = FINISHED
                            que_text_pr.setAutoDraw(False)
                    
                    # *item2_img_pr* updates
                    
                    # if item2_img_pr is starting this frame...
                    if item2_img_pr.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                        # keep track of start time/frame for later
                        item2_img_pr.frameNStart = frameN  # exact frame index
                        item2_img_pr.tStart = t  # local t and not account for scr refresh
                        item2_img_pr.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(item2_img_pr, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'item2_img_pr.started')
                        # update status
                        item2_img_pr.status = STARTED
                        item2_img_pr.setAutoDraw(True)
                    
                    # if item2_img_pr is active this frame...
                    if item2_img_pr.status == STARTED:
                        # update params
                        pass
                    
                    # if item2_img_pr is stopping this frame...
                    if item2_img_pr.status == STARTED:
                        if bool(show_img):
                            # keep track of stop time/frame for later
                            item2_img_pr.tStop = t  # not accounting for scr refresh
                            item2_img_pr.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'item2_img_pr.stopped')
                            # update status
                            item2_img_pr.status = FINISHED
                            item2_img_pr.setAutoDraw(False)
                    
                    # *timer_pr* updates
                    
                    # if timer_pr is starting this frame...
                    if timer_pr.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                        # keep track of start time/frame for later
                        timer_pr.frameNStart = frameN  # exact frame index
                        timer_pr.tStart = t  # local t and not account for scr refresh
                        timer_pr.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(timer_pr, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'timer_pr.started')
                        # update status
                        timer_pr.status = STARTED
                        timer_pr.setAutoDraw(True)
                    
                    # if timer_pr is active this frame...
                    if timer_pr.status == STARTED:
                        # update params
                        pass
                    
                    # if timer_pr is stopping this frame...
                    if timer_pr.status == STARTED:
                        if bool(participant_answered):
                            # keep track of stop time/frame for later
                            timer_pr.tStop = t  # not accounting for scr refresh
                            timer_pr.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'timer_pr.stopped')
                            # update status
                            timer_pr.status = FINISHED
                            timer_pr.setAutoDraw(False)
                    
                    # *timer_timed_pr* updates
                    
                    # if timer_timed_pr is starting this frame...
                    if timer_timed_pr.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                        # keep track of start time/frame for later
                        timer_timed_pr.frameNStart = frameN  # exact frame index
                        timer_timed_pr.tStart = t  # local t and not account for scr refresh
                        timer_timed_pr.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(timer_timed_pr, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'timer_timed_pr.started')
                        # update status
                        timer_timed_pr.status = STARTED
                        timer_timed_pr.setAutoDraw(True)
                    
                    # if timer_timed_pr is active this frame...
                    if timer_timed_pr.status == STARTED:
                        # update params
                        pass
                    
                    # if timer_timed_pr is stopping this frame...
                    if timer_timed_pr.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > timer_timed_pr.tStartRefresh + timer_time-frameTolerance:
                            # keep track of stop time/frame for later
                            timer_timed_pr.tStop = t  # not accounting for scr refresh
                            timer_timed_pr.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'timer_timed_pr.stopped')
                            # update status
                            timer_timed_pr.status = FINISHED
                            timer_timed_pr.setAutoDraw(False)
                    
                    # *fix_text_pr* updates
                    
                    # if fix_text_pr is starting this frame...
                    if fix_text_pr.status == NOT_STARTED and display_fix == 1:
                        # keep track of start time/frame for later
                        fix_text_pr.frameNStart = frameN  # exact frame index
                        fix_text_pr.tStart = t  # local t and not account for scr refresh
                        fix_text_pr.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(fix_text_pr, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'fix_text_pr.started')
                        # update status
                        fix_text_pr.status = STARTED
                        fix_text_pr.setAutoDraw(True)
                    
                    # if fix_text_pr is active this frame...
                    if fix_text_pr.status == STARTED:
                        # update params
                        pass
                    
                    # if fix_text_pr is stopping this frame...
                    if fix_text_pr.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > fix_text_pr.tStartRefresh + timeFix-frameTolerance:
                            # keep track of stop time/frame for later
                            fix_text_pr.tStop = t  # not accounting for scr refresh
                            fix_text_pr.frameNStop = frameN  # exact frame index
                            # add timestamp to datafile
                            thisExp.timestampOnFlip(win, 'fix_text_pr.stopped')
                            # update status
                            fix_text_pr.status = FINISHED
                            fix_text_pr.setAutoDraw(False)
                    
                    # *key_prac* updates
                    waitOnFlip = False
                    
                    # if key_prac is starting this frame...
                    if key_prac.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                        # keep track of start time/frame for later
                        key_prac.frameNStart = frameN  # exact frame index
                        key_prac.tStart = t  # local t and not account for scr refresh
                        key_prac.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(key_prac, 'tStartRefresh')  # time at next scr refresh
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'key_prac.started')
                        # update status
                        key_prac.status = STARTED
                        # keyboard checking is just starting
                        waitOnFlip = True
                        win.callOnFlip(key_prac.clock.reset)  # t=0 on next screen flip
                        win.callOnFlip(key_prac.clearEvents, eventType='keyboard')  # clear events on next screen flip
                    if key_prac.status == STARTED and not waitOnFlip:
                        theseKeys = key_prac.getKeys(keyList=None, waitRelease=False)
                        _key_prac_allKeys.extend(theseKeys)
                        if len(_key_prac_allKeys):
                            key_prac.keys = [key.name for key in _key_prac_allKeys]  # storing all keys
                            key_prac.rt = [key.rt for key in _key_prac_allKeys]
                            key_prac.duration = [key.duration for key in _key_prac_allKeys]
                    
                    # check for quit (typically the Esc key)
                    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                        core.quit()
                        if eyetracker:
                            eyetracker.setConnectionState(False)
                    
                    # check if all components have finished
                    if not continueRoutine:  # a component has requested a forced-end of Routine
                        routineForceEnded = True
                        break
                    continueRoutine = False  # will revert to True if at least one component still running
                    for thisComponent in practComponents:
                        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                            continueRoutine = True
                            break  # at least one component has not yet finished
                    
                    # refresh the screen
                    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                        win.flip()
                
                # --- Ending Routine "pract" ---
                for thisComponent in practComponents:
                    if hasattr(thisComponent, "setAutoDraw"):
                        thisComponent.setAutoDraw(False)
                # Run 'End Routine' code from code_pr
                # Save variables for correlation with ePrime previous logfiles
                
                # Add the answer of the participant
                thisExp.addData('imprat.RESP', response_pr)
                # Add the correct answer
                thisExp.addData('imprat.CRESP', CorrectResponse)
                # See if that matches with the correct answer
                if response_pr == CorrectResponse:
                    thisExp.addData('imprat.ACC', 1)
                    good_response+=1
                    timedAns +=1
                elif response_pr == 1 or response_pr == 2:
                    thisExp.addData('imprat.ACC', 0)
                    timedAns +=1
                else:
                    thisExp.addData('imprat.ACC', '')
                if response_pr != 0:
                    thisExp.addData('imprat.RT', time_last_responses_pract)
                else:
                    thisExp.addData('imprat.RT', '')
                
                # Save answer rttime since the beginning of the experiment
                thisExp.addData('imprat.RTTime', que_text_pr.tStartRefresh + time_last_responses_pract)
                #win.color = 'white'
                
                item2_img_pr.opacity = 1
                participant_answered = False
                # check responses
                if key_prac.keys in ['', [], None]:  # No response was made
                    key_prac.keys = None
                practice.addData('key_prac.keys',key_prac.keys)
                if key_prac.keys != None:  # we had a response
                    practice.addData('key_prac.rt', key_prac.rt)
                    practice.addData('key_prac.duration', key_prac.duration)
                # store data for practice (TrialHandler)
                # store data for practice (TrialHandler)
                x, y = joystick_prac.getX(), joystick_prac.getY()
                joystick_prac.newButtonState = joystick_prac.getAllButtons()[:]
                joystick_prac.pressedState = [joystick_prac.newButtonState[i] for i in range(joystick_prac.numButtons)]
                joystick_prac.time = joystick_prac.joystickClock.getTime()
                practice.addData('joystick_prac.x', x)
                practice.addData('joystick_prac.y', y)
                [practice.addData('joystick_prac.button_{0}'.format(i), int(joystick_prac.pressedState[i])) for i in joystick_prac.activeButtons]
                practice.addData('joystick_prac.time', joystick_prac.time)
                # the Routine "pract" was not non-slip safe, so reset the non-slip timer
                routineTimer.reset()
                thisExp.nextEntry()
                
            # completed 1.0 repeats of 'practice'
            
            
            # --- Prepare to start Routine "transition1" ---
            continueRoutine = True
            # update component parameters for each repeat
            # Run 'Begin Routine' code from code_transi_1
            # Change displayed text based on the language previously chosen
            if english == True:
                if(timedAns != 5):
                    txt_transi1.text = f"You did not respond to all of the trials. \nPlease try the practice again."
                else:
                    txt_transi1.text = f"Great job, you have completed the practice!"
            else:
                if(timedAns != 5):
                    txt_transi1.text = f"Vous n'avez pas répondu à tous les essais. \nVeuillez essayer à nouveau la pratique."
                else:
                    txt_transi1.text = f"Bravo, vous avez terminé la pratique!"
            # Key 1 or key 2 are not pressed by default
            key1pressed = False
            key2pressed = False
            
            
            key_transi1.keys = []
            key_transi1.rt = []
            _key_transi1_allKeys = []
            joystick_transi1.oldButtonState = joystick_transi1.device.getAllButtons()[:]
            joystick_transi1.activeButtons=[i for i in range(joystick_transi1.numButtons)]
            # setup some python lists for storing info about the joystick_transi1
            gotValidClick = False  # until a click is received
            # keep track of which components have finished
            transition1Components = [txt_transi1, key_transi1, joystick_transi1]
            for thisComponent in transition1Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "transition1" ---
            routineForceEnded = not continueRoutine
            while continueRoutine:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                # Run 'Each Frame' code from code_transi_1
                # Reset buttons if they are not pressed
                if button_down and not joystick_3.getAllButtons()[1] and not '1' in key_transi1.keys:
                   button_down = False
                
                # Check if we pressed keyboard keys
                #if joystick_3.getAllButtons()[0] and not button_down:
                #    timedAns = 0
                #    button_down = True
                #    continueRoutine = False
                #elif joystick_3.getAllButtons()[2] and not button_down:
                #    timedAns = 0
                #    button_down = True
                #    practice.finished = True
                #    prac_repeat.finished = True
                #    continueRoutine = False
                    #to go to the next practice
                #    current_practice+=1
                if "r" in key_transi1.keys and not button_down:
                    timedAns = 0
                    button_down = True
                    continueRoutine = False
                elif "space" in key_transi1.keys and not button_down:
                    timedAns = 0
                    button_down = True
                    practice.finished = True
                    prac_repeat.finished = True
                    continueRoutine = False
                    #to go to the next practice
                    current_practice+=1
                
                # restart the good response counter
                good_response = 0
                
                
                # *txt_transi1* updates
                
                # if txt_transi1 is starting this frame...
                if txt_transi1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    txt_transi1.frameNStart = frameN  # exact frame index
                    txt_transi1.tStart = t  # local t and not account for scr refresh
                    txt_transi1.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(txt_transi1, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'txt_transi1.started')
                    # update status
                    txt_transi1.status = STARTED
                    txt_transi1.setAutoDraw(True)
                
                # if txt_transi1 is active this frame...
                if txt_transi1.status == STARTED:
                    # update params
                    pass
                
                # *key_transi1* updates
                waitOnFlip = False
                
                # if key_transi1 is starting this frame...
                if key_transi1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    key_transi1.frameNStart = frameN  # exact frame index
                    key_transi1.tStart = t  # local t and not account for scr refresh
                    key_transi1.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key_transi1, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'key_transi1.started')
                    # update status
                    key_transi1.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key_transi1.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(key_transi1.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if key_transi1.status == STARTED and not waitOnFlip:
                    theseKeys = key_transi1.getKeys(keyList=['space','r','esc'], waitRelease=False)
                    _key_transi1_allKeys.extend(theseKeys)
                    if len(_key_transi1_allKeys):
                        key_transi1.keys = _key_transi1_allKeys[-1].name  # just the last key pressed
                        key_transi1.rt = _key_transi1_allKeys[-1].rt
                        key_transi1.duration = _key_transi1_allKeys[-1].duration
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in transition1Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "transition1" ---
            for thisComponent in transition1Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # Run 'End Routine' code from code_transi_1
            timedAns = 0
            # check responses
            if key_transi1.keys in ['', [], None]:  # No response was made
                key_transi1.keys = None
            prac_repeat.addData('key_transi1.keys',key_transi1.keys)
            if key_transi1.keys != None:  # we had a response
                prac_repeat.addData('key_transi1.rt', key_transi1.rt)
                prac_repeat.addData('key_transi1.duration', key_transi1.duration)
            # store data for prac_repeat (TrialHandler)
            # store data for prac_repeat (TrialHandler)
            x, y = joystick_transi1.getX(), joystick_transi1.getY()
            joystick_transi1.newButtonState = joystick_transi1.getAllButtons()[:]
            joystick_transi1.pressedState = [joystick_transi1.newButtonState[i] for i in range(joystick_transi1.numButtons)]
            joystick_transi1.time = joystick_transi1.joystickClock.getTime()
            prac_repeat.addData('joystick_transi1.x', x)
            prac_repeat.addData('joystick_transi1.y', y)
            [prac_repeat.addData('joystick_transi1.button_{0}'.format(i), int(joystick_transi1.pressedState[i])) for i in joystick_transi1.activeButtons]
            prac_repeat.addData('joystick_transi1.time', joystick_transi1.time)
            # the Routine "transition1" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
        # completed 100.0 repeats of 'prac_repeat'
        
        thisExp.nextEntry()
        
    # completed 1.0 repeats of 'practices_bloc'
    
# completed skipP repeats of 'skip_practice'


# set up handler to look after randomisation of conditions etc
skip_trial = data.TrialHandler(nReps=skipT, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='skip_trial')
thisExp.addLoop(skip_trial)  # add the loop to the experiment
thisSkip_trial = skip_trial.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisSkip_trial.rgb)
if thisSkip_trial != None:
    for paramName in thisSkip_trial:
        exec('{} = thisSkip_trial[paramName]'.format(paramName))

for thisSkip_trial in skip_trial:
    currentLoop = skip_trial
    # abbreviate parameter names if possible (e.g. rgb = thisSkip_trial.rgb)
    if thisSkip_trial != None:
        for paramName in thisSkip_trial:
            exec('{} = thisSkip_trial[paramName]'.format(paramName))
    
    # --- Prepare to start Routine "preRemind" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from codePreRemind
    # Change displayed text based on the language previously chosen
    if english == True:
        textPreRemind.text = "There are going to be several blocks where \nyou will be asked to make a ‘yes’ or ‘no’ response\n to the question ‘Living’ or ‘Inside’."
        textPreRemind_2.text = " You will see which question you should answer before \neach block begins and the question (‘Living?’ or ‘Inside?’) \nwill be displayed under each pair of images."
        ansYesPreRemind.text = "YES"
        ansNoPreRemind.text = "NO"
    else:
        textPreRemind.text = "Il y aura plusieurs blocs où il vous sera \ndemandé de répondre par 'oui' ou 'non' à la question \n'Vivant' ou 'À l'intérieur'."
        textPreRemind_2.text = "Vous verrez quelle question vous devez répondre avant le début \nde chaque bloc et la question ('Vivant?' ou 'À l'intérieur?') \nsera affichée sous chaque paire d'images."
        ansYesPreRemind.text = "OUI"
        ansNoPreRemind.text = "NON"
    keyPreRemind.keys = []
    keyPreRemind.rt = []
    _keyPreRemind_allKeys = []
    joystickPreRemind.oldButtonState = joystickPreRemind.device.getAllButtons()[:]
    joystickPreRemind.activeButtons=[1]
    # setup some python lists for storing info about the joystickPreRemind
    gotValidClick = False  # until a click is received
    # keep track of which components have finished
    preRemindComponents = [textPreRemind, textPreRemind_2, keyPreRemind, joystickPreRemind, ansYesPreRemind, ansNoPreRemind, polygonYes, polygonNo]
    for thisComponent in preRemindComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "preRemind" ---
    routineForceEnded = not continueRoutine
    while continueRoutine:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        # Run 'Each Frame' code from codePreRemind
        # Reset buttons if they are not pressed
        if button_down  and not joystickPreRemind.getAllButtons()[1]:
           button_down = False
        
        # Go to next routine
        if not button_down and (joystickPreRemind.getAllButtons()[1]):
            button_down = True
            continueRoutine = False
            
        # Register participant's answers with the keyboard
        if (len(keyPreRemind.keys) != lenghtRemind):
            if keyPreRemind.keys[-1] =='escape':
                core.quit()
            elif keyPreRemind.keys[-1] == 'space':
                continueRoutine = False
            elif keyPreRemind.keys[-1] == '1':
                timerRemind = core.Clock()
                buttonSelector(polygonYes)
                lenghtRemind = len(keyPreRemind.keys)
            elif keyPreRemind.keys[-1] == '2':
                timerRemind = core.Clock()
                buttonSelector(polygonNo)
                lenghtRemind = len(keyPreRemind.keys)
                
        if timerRemind != None:        
            if timerRemind.getTime() > 1:
                    polygonNo.fillColor = [1, 1, 1]
                    polygonYes.fillColor = [1, 1, 1]
                    timerRemind = None
           
        
        # *textPreRemind* updates
        
        # if textPreRemind is starting this frame...
        if textPreRemind.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textPreRemind.frameNStart = frameN  # exact frame index
            textPreRemind.tStart = t  # local t and not account for scr refresh
            textPreRemind.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textPreRemind, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textPreRemind.started')
            # update status
            textPreRemind.status = STARTED
            textPreRemind.setAutoDraw(True)
        
        # if textPreRemind is active this frame...
        if textPreRemind.status == STARTED:
            # update params
            pass
        
        # *textPreRemind_2* updates
        
        # if textPreRemind_2 is starting this frame...
        if textPreRemind_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            textPreRemind_2.frameNStart = frameN  # exact frame index
            textPreRemind_2.tStart = t  # local t and not account for scr refresh
            textPreRemind_2.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(textPreRemind_2, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'textPreRemind_2.started')
            # update status
            textPreRemind_2.status = STARTED
            textPreRemind_2.setAutoDraw(True)
        
        # if textPreRemind_2 is active this frame...
        if textPreRemind_2.status == STARTED:
            # update params
            pass
        
        # *keyPreRemind* updates
        waitOnFlip = False
        
        # if keyPreRemind is starting this frame...
        if keyPreRemind.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            keyPreRemind.frameNStart = frameN  # exact frame index
            keyPreRemind.tStart = t  # local t and not account for scr refresh
            keyPreRemind.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(keyPreRemind, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'keyPreRemind.started')
            # update status
            keyPreRemind.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(keyPreRemind.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(keyPreRemind.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if keyPreRemind.status == STARTED and not waitOnFlip:
            theseKeys = keyPreRemind.getKeys(keyList=None, waitRelease=False)
            _keyPreRemind_allKeys.extend(theseKeys)
            if len(_keyPreRemind_allKeys):
                keyPreRemind.keys = [key.name for key in _keyPreRemind_allKeys]  # storing all keys
                keyPreRemind.rt = [key.rt for key in _keyPreRemind_allKeys]
                keyPreRemind.duration = [key.duration for key in _keyPreRemind_allKeys]
        # *joystickPreRemind* updates
        
        # if joystickPreRemind is starting this frame...
        if joystickPreRemind.status == NOT_STARTED and t >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            joystickPreRemind.frameNStart = frameN  # exact frame index
            joystickPreRemind.tStart = t  # local t and not account for scr refresh
            joystickPreRemind.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(joystickPreRemind, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.addData('joystickPreRemind.started', t)
            # update status
            joystickPreRemind.status = STARTED
            joystickPreRemind.status = STARTED
            joystickPreRemind.joystickClock.reset()
        if joystickPreRemind.status == STARTED:  # only update if started and not finished!
            joystickPreRemind.newButtonState = joystickPreRemind.getAllButtons()[:]
            if joystickPreRemind.newButtonState != joystickPreRemind.oldButtonState: # New button press
                joystickPreRemind.pressedButtons = [i for i in range(joystickPreRemind.numButtons) if joystickPreRemind.newButtonState[i] and not joystickPreRemind.oldButtonState[i]]
                joystickPreRemind.releasedButtons = [i for i in range(joystickPreRemind.numButtons) if not joystickPreRemind.newButtonState[i] and joystickPreRemind.oldButtonState[i]]
                joystickPreRemind.newPressedButtons = [i for i in joystickPreRemind.activeButtons if i in joystickPreRemind.pressedButtons]
                joystickPreRemind.oldButtonState = joystickPreRemind.newButtonState
                joystickPreRemind.buttons = joystickPreRemind.newPressedButtons
                [logging.data("joystick_{}_button: {}, pos=({:1.4f},{:1.4f})".format(joystickPreRemind.device_number, i, joystickPreRemind.getX(), joystickPreRemind.getY())) for i in joystickPreRemind.pressedButtons]
                if len(joystickPreRemind.buttons) > 0:  # state changed to a new click
                    if gotValidClick:  # abort routine on response
                        continueRoutine = False
        
        # *ansYesPreRemind* updates
        
        # if ansYesPreRemind is starting this frame...
        if ansYesPreRemind.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ansYesPreRemind.frameNStart = frameN  # exact frame index
            ansYesPreRemind.tStart = t  # local t and not account for scr refresh
            ansYesPreRemind.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ansYesPreRemind, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'ansYesPreRemind.started')
            # update status
            ansYesPreRemind.status = STARTED
            ansYesPreRemind.setAutoDraw(True)
        
        # if ansYesPreRemind is active this frame...
        if ansYesPreRemind.status == STARTED:
            # update params
            pass
        
        # *ansNoPreRemind* updates
        
        # if ansNoPreRemind is starting this frame...
        if ansNoPreRemind.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            ansNoPreRemind.frameNStart = frameN  # exact frame index
            ansNoPreRemind.tStart = t  # local t and not account for scr refresh
            ansNoPreRemind.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(ansNoPreRemind, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'ansNoPreRemind.started')
            # update status
            ansNoPreRemind.status = STARTED
            ansNoPreRemind.setAutoDraw(True)
        
        # if ansNoPreRemind is active this frame...
        if ansNoPreRemind.status == STARTED:
            # update params
            pass
        
        # *polygonYes* updates
        
        # if polygonYes is starting this frame...
        if polygonYes.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygonYes.frameNStart = frameN  # exact frame index
            polygonYes.tStart = t  # local t and not account for scr refresh
            polygonYes.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygonYes, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'polygonYes.started')
            # update status
            polygonYes.status = STARTED
            polygonYes.setAutoDraw(True)
        
        # if polygonYes is active this frame...
        if polygonYes.status == STARTED:
            # update params
            pass
        
        # *polygonNo* updates
        
        # if polygonNo is starting this frame...
        if polygonNo.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            polygonNo.frameNStart = frameN  # exact frame index
            polygonNo.tStart = t  # local t and not account for scr refresh
            polygonNo.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(polygonNo, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'polygonNo.started')
            # update status
            polygonNo.status = STARTED
            polygonNo.setAutoDraw(True)
        
        # if polygonNo is active this frame...
        if polygonNo.status == STARTED:
            # update params
            pass
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in preRemindComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "preRemind" ---
    for thisComponent in preRemindComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if keyPreRemind.keys in ['', [], None]:  # No response was made
        keyPreRemind.keys = None
    skip_trial.addData('keyPreRemind.keys',keyPreRemind.keys)
    if keyPreRemind.keys != None:  # we had a response
        skip_trial.addData('keyPreRemind.rt', keyPreRemind.rt)
        skip_trial.addData('keyPreRemind.duration', keyPreRemind.duration)
    # store data for skip_trial (TrialHandler)
    # store data for skip_trial (TrialHandler)
    x, y = joystickPreRemind.getX(), joystickPreRemind.getY()
    joystickPreRemind.newButtonState = joystickPreRemind.getAllButtons()[:]
    joystickPreRemind.pressedState = [joystickPreRemind.newButtonState[i] for i in range(joystickPreRemind.numButtons)]
    joystickPreRemind.time = joystickPreRemind.joystickClock.getTime()
    skip_trial.addData('joystickPreRemind.x', x)
    skip_trial.addData('joystickPreRemind.y', y)
    [skip_trial.addData('joystickPreRemind.button_{0}'.format(i), int(joystickPreRemind.pressedState[i])) for i in joystickPreRemind.activeButtons]
    skip_trial.addData('joystickPreRemind.time', joystickPreRemind.time)
    # the Routine "preRemind" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # --- Prepare to start Routine "remind" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from code_remind
    # Change displayed text based on the language previously chosen
    if english == True:
        title_remind.text = "Living?"
        text_remind.text = "Reminder: \nRespond ‘yes’ (index finger). \nRespond ‘no’ (middle finger)."
    else:
        title_remind.text = "Vivant?"
        text_remind.text = "Rappel: \nRépondez 'oui' (index). \nRépondez 'non' (majeur)."
    # keep track of which components have finished
    remindComponents = [title_remind, text_remind]
    for thisComponent in remindComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "remind" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 6.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *title_remind* updates
        
        # if title_remind is starting this frame...
        if title_remind.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            title_remind.frameNStart = frameN  # exact frame index
            title_remind.tStart = t  # local t and not account for scr refresh
            title_remind.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(title_remind, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'title_remind.started')
            # update status
            title_remind.status = STARTED
            title_remind.setAutoDraw(True)
        
        # if title_remind is active this frame...
        if title_remind.status == STARTED:
            # update params
            pass
        
        # if title_remind is stopping this frame...
        if title_remind.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > title_remind.tStartRefresh + 6-frameTolerance:
                # keep track of stop time/frame for later
                title_remind.tStop = t  # not accounting for scr refresh
                title_remind.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'title_remind.stopped')
                # update status
                title_remind.status = FINISHED
                title_remind.setAutoDraw(False)
        
        # *text_remind* updates
        
        # if text_remind is starting this frame...
        if text_remind.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text_remind.frameNStart = frameN  # exact frame index
            text_remind.tStart = t  # local t and not account for scr refresh
            text_remind.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_remind, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'text_remind.started')
            # update status
            text_remind.status = STARTED
            text_remind.setAutoDraw(True)
        
        # if text_remind is active this frame...
        if text_remind.status == STARTED:
            # update params
            pass
        
        # if text_remind is stopping this frame...
        if text_remind.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > text_remind.tStartRefresh + 6-frameTolerance:
                # keep track of stop time/frame for later
                text_remind.tStop = t  # not accounting for scr refresh
                text_remind.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'text_remind.stopped')
                # update status
                text_remind.status = FINISHED
                text_remind.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in remindComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "remind" ---
    for thisComponent in remindComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-6.000000)
    
    # --- Prepare to start Routine "ready" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from code_rdy
    # Change displayed text based on the language previously chosen
    if english == True:
        txt_rdy.text = "GET READY!"
    else:
        txt_rdy.text = "SOYEZ PRÊT!"
    key_rdy.keys = []
    key_rdy.rt = []
    _key_rdy_allKeys = []
    # keep track of which components have finished
    readyComponents = [txt_rdy, key_rdy]
    for thisComponent in readyComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "ready" ---
    routineForceEnded = not continueRoutine
    while continueRoutine:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        # Run 'Each Frame' code from code_rdy
        # Register participant's answers with the keyboard
        if (len(key_rdy.keys) > 0):
            if key_rdy.keys[-1] =='escape':
                core.quit()
            elif key_rdy.keys[-1] == '5' or key_rdy.keys[-1] == 5:
                first_pulse = key_ready.rt[-1]
                continueRoutine = False
        
        # *txt_rdy* updates
        
        # if txt_rdy is starting this frame...
        if txt_rdy.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            txt_rdy.frameNStart = frameN  # exact frame index
            txt_rdy.tStart = t  # local t and not account for scr refresh
            txt_rdy.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(txt_rdy, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'txt_rdy.started')
            # update status
            txt_rdy.status = STARTED
            txt_rdy.setAutoDraw(True)
        
        # if txt_rdy is active this frame...
        if txt_rdy.status == STARTED:
            # update params
            pass
        
        # *key_rdy* updates
        waitOnFlip = False
        
        # if key_rdy is starting this frame...
        if key_rdy.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_rdy.frameNStart = frameN  # exact frame index
            key_rdy.tStart = t  # local t and not account for scr refresh
            key_rdy.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_rdy, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'key_rdy.started')
            # update status
            key_rdy.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_rdy.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_rdy.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_rdy.status == STARTED and not waitOnFlip:
            theseKeys = key_rdy.getKeys(keyList=None, waitRelease=False)
            _key_rdy_allKeys.extend(theseKeys)
            if len(_key_rdy_allKeys):
                key_rdy.keys = [key.name for key in _key_rdy_allKeys]  # storing all keys
                key_rdy.rt = [key.rt for key in _key_rdy_allKeys]
                key_rdy.duration = [key.duration for key in _key_rdy_allKeys]
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in readyComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "ready" ---
    for thisComponent in readyComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # check responses
    if key_rdy.keys in ['', [], None]:  # No response was made
        key_rdy.keys = None
    skip_trial.addData('key_rdy.keys',key_rdy.keys)
    if key_rdy.keys != None:  # we had a response
        skip_trial.addData('key_rdy.rt', key_rdy.rt)
        skip_trial.addData('key_rdy.duration', key_rdy.duration)
    # the Routine "ready" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # --- Prepare to start Routine "cntdown" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from code_ctdown
    # Boolean that will state if the signal is received or not
    signal_received = True
    # List that will contains the time where the signal was received
    signal_times = list()
    key_ctdown.keys = []
    key_ctdown.rt = []
    _key_ctdown_allKeys = []
    # keep track of which components have finished
    cntdownComponents = [timer_ctdown, key_ctdown]
    for thisComponent in cntdownComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "cntdown" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 5.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        # Run 'Each Frame' code from code_ctdown
        # Check if we pressed keyboard keys
        keys = event.getKeys()
        
        # Reset signal
        if signal_received and not '5' in keys:
           signal_received = False
        
        # If we received the signal, store the time
        if not signal_received and '5' in keys:
            signal_times.append(t)
            signal_received = True
        
        # *timer_ctdown* updates
        
        # if timer_ctdown is starting this frame...
        if timer_ctdown.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            timer_ctdown.frameNStart = frameN  # exact frame index
            timer_ctdown.tStart = t  # local t and not account for scr refresh
            timer_ctdown.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(timer_ctdown, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'timer_ctdown.started')
            # update status
            timer_ctdown.status = STARTED
            timer_ctdown.setAutoDraw(True)
        
        # if timer_ctdown is active this frame...
        if timer_ctdown.status == STARTED:
            # update params
            timer_ctdown.setText(int(abs(round(5 - t, ndigits = 1))), log=False)
        
        # if timer_ctdown is stopping this frame...
        if timer_ctdown.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > timer_ctdown.tStartRefresh + 5-frameTolerance:
                # keep track of stop time/frame for later
                timer_ctdown.tStop = t  # not accounting for scr refresh
                timer_ctdown.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'timer_ctdown.stopped')
                # update status
                timer_ctdown.status = FINISHED
                timer_ctdown.setAutoDraw(False)
        
        # *key_ctdown* updates
        waitOnFlip = False
        
        # if key_ctdown is starting this frame...
        if key_ctdown.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_ctdown.frameNStart = frameN  # exact frame index
            key_ctdown.tStart = t  # local t and not account for scr refresh
            key_ctdown.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_ctdown, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'key_ctdown.started')
            # update status
            key_ctdown.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_ctdown.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_ctdown.clearEvents, eventType='keyboard')  # clear events on next screen flip
        
        # if key_ctdown is stopping this frame...
        if key_ctdown.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > key_ctdown.tStartRefresh + 5-frameTolerance:
                # keep track of stop time/frame for later
                key_ctdown.tStop = t  # not accounting for scr refresh
                key_ctdown.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'key_ctdown.stopped')
                # update status
                key_ctdown.status = FINISHED
                key_ctdown.status = FINISHED
        if key_ctdown.status == STARTED and not waitOnFlip:
            theseKeys = key_ctdown.getKeys(keyList=['esc'], waitRelease=False)
            _key_ctdown_allKeys.extend(theseKeys)
            if len(_key_ctdown_allKeys):
                key_ctdown.keys = _key_ctdown_allKeys[-1].name  # just the last key pressed
                key_ctdown.rt = _key_ctdown_allKeys[-1].rt
                key_ctdown.duration = _key_ctdown_allKeys[-1].duration
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in cntdownComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "cntdown" ---
    for thisComponent in cntdownComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # Run 'End Routine' code from code_ctdown
    thisExp.addData('signal_ctdown.time', signal_times)
    
    # Set next trial bloc
    bloc = 1
    # check responses
    if key_ctdown.keys in ['', [], None]:  # No response was made
        key_ctdown.keys = None
    skip_trial.addData('key_ctdown.keys',key_ctdown.keys)
    if key_ctdown.keys != None:  # we had a response
        skip_trial.addData('key_ctdown.rt', key_ctdown.rt)
        skip_trial.addData('key_ctdown.duration', key_ctdown.duration)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-5.000000)
    
    # set up handler to look after randomisation of conditions etc
    block = data.TrialHandler(nReps=4.0, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=[None],
        seed=None, name='block')
    thisExp.addLoop(block)  # add the loop to the experiment
    thisBlock = block.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisBlock.rgb)
    if thisBlock != None:
        for paramName in thisBlock:
            exec('{} = thisBlock[paramName]'.format(paramName))
    
    for thisBlock in block:
        currentLoop = block
        # abbreviate parameter names if possible (e.g. rgb = thisBlock.rgb)
        if thisBlock != None:
            for paramName in thisBlock:
                exec('{} = thisBlock[paramName]'.format(paramName))
        
        # set up handler to look after randomisation of conditions etc
        skip_reminder = data.TrialHandler(nReps=skipReminder, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=[None],
            seed=None, name='skip_reminder')
        thisExp.addLoop(skip_reminder)  # add the loop to the experiment
        thisSkip_reminder = skip_reminder.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisSkip_reminder.rgb)
        if thisSkip_reminder != None:
            for paramName in thisSkip_reminder:
                exec('{} = thisSkip_reminder[paramName]'.format(paramName))
        
        for thisSkip_reminder in skip_reminder:
            currentLoop = skip_reminder
            # abbreviate parameter names if possible (e.g. rgb = thisSkip_reminder.rgb)
            if thisSkip_reminder != None:
                for paramName in thisSkip_reminder:
                    exec('{} = thisSkip_reminder[paramName]'.format(paramName))
            
            # --- Prepare to start Routine "reminder" ---
            continueRoutine = True
            # update component parameters for each repeat
            # Run 'Begin Routine' code from code_reminder
            if skipReminder != 0:
                trial += 1;
               
            ##trialConditions1 = getattr(sys.modules[__name__], f'trialConditions{trial}')
             
            if trial == 2:
                rowTrial = '9:18'
            elif trial == 3:
                rowTrial = '18:27'
            elif trial == 4:
                rowTrial = '27:36'
             
            #Display the correct reminder for the trial
            if trial % 2 == 0:
                if english == True:
                    title_reminder.text = "Inside?"
                    text_reminder.text = "Reminder: \nRespond ‘yes’ (index finger).\nRespond ‘no’ (middle finger)."
                else:
                    title_reminder.text = "À l'intérieur?"
                    text_reminder.text = "Rappel : \nRépondez 'oui' (index).\nRépondez 'non' (majeur)."
            else:
                if english == True:
                    title_reminder.text = "Living?"
                    text_reminder.text = "Reminder: \nRespond ‘yes’ (index finger).\nRespond ‘no’ (middle finger)."
                else:
                    title_reminder.text = "Vivant?"
                    text_reminder.text = "Rappel: \nRépondez 'oui' (index).\nRépondez 'non' (majeur)."
            key_reminder.keys = []
            key_reminder.rt = []
            _key_reminder_allKeys = []
            # keep track of which components have finished
            reminderComponents = [title_reminder, text_reminder, key_reminder]
            for thisComponent in reminderComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "reminder" ---
            routineForceEnded = not continueRoutine
            while continueRoutine and routineTimer.getTime() < 6.0:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *title_reminder* updates
                
                # if title_reminder is starting this frame...
                if title_reminder.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    title_reminder.frameNStart = frameN  # exact frame index
                    title_reminder.tStart = t  # local t and not account for scr refresh
                    title_reminder.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(title_reminder, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'title_reminder.started')
                    # update status
                    title_reminder.status = STARTED
                    title_reminder.setAutoDraw(True)
                
                # if title_reminder is active this frame...
                if title_reminder.status == STARTED:
                    # update params
                    pass
                
                # if title_reminder is stopping this frame...
                if title_reminder.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > title_reminder.tStartRefresh + 6-frameTolerance:
                        # keep track of stop time/frame for later
                        title_reminder.tStop = t  # not accounting for scr refresh
                        title_reminder.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'title_reminder.stopped')
                        # update status
                        title_reminder.status = FINISHED
                        title_reminder.setAutoDraw(False)
                
                # *text_reminder* updates
                
                # if text_reminder is starting this frame...
                if text_reminder.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    text_reminder.frameNStart = frameN  # exact frame index
                    text_reminder.tStart = t  # local t and not account for scr refresh
                    text_reminder.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(text_reminder, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'text_reminder.started')
                    # update status
                    text_reminder.status = STARTED
                    text_reminder.setAutoDraw(True)
                
                # if text_reminder is active this frame...
                if text_reminder.status == STARTED:
                    # update params
                    pass
                
                # if text_reminder is stopping this frame...
                if text_reminder.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > text_reminder.tStartRefresh + 6-frameTolerance:
                        # keep track of stop time/frame for later
                        text_reminder.tStop = t  # not accounting for scr refresh
                        text_reminder.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'text_reminder.stopped')
                        # update status
                        text_reminder.status = FINISHED
                        text_reminder.setAutoDraw(False)
                
                # *key_reminder* updates
                waitOnFlip = False
                
                # if key_reminder is starting this frame...
                if key_reminder.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    key_reminder.frameNStart = frameN  # exact frame index
                    key_reminder.tStart = t  # local t and not account for scr refresh
                    key_reminder.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key_reminder, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'key_reminder.started')
                    # update status
                    key_reminder.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key_reminder.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(key_reminder.clearEvents, eventType='keyboard')  # clear events on next screen flip
                
                # if key_reminder is stopping this frame...
                if key_reminder.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > key_reminder.tStartRefresh + 6-frameTolerance:
                        # keep track of stop time/frame for later
                        key_reminder.tStop = t  # not accounting for scr refresh
                        key_reminder.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'key_reminder.stopped')
                        # update status
                        key_reminder.status = FINISHED
                        key_reminder.status = FINISHED
                if key_reminder.status == STARTED and not waitOnFlip:
                    theseKeys = key_reminder.getKeys(keyList=['esc'], waitRelease=False)
                    _key_reminder_allKeys.extend(theseKeys)
                    if len(_key_reminder_allKeys):
                        key_reminder.keys = _key_reminder_allKeys[-1].name  # just the last key pressed
                        key_reminder.rt = _key_reminder_allKeys[-1].rt
                        key_reminder.duration = _key_reminder_allKeys[-1].duration
                        # a response ends the routine
                        continueRoutine = False
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in reminderComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "reminder" ---
            for thisComponent in reminderComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # Run 'End Routine' code from code_reminder
            if trial == 2:
                thisExp.addData(f"block{trial-1}TotalTime", title_reminder.tStartRefresh - (txt_rdy.tStartRefresh + first_pulse))
                timeLastRun = title_reminder.tStartRefresh + 6
                print('timeLastRun', timeLastRun)
            elif trial == 3:
                thisExp.addData(f"block{trial-1}TotalTime", title_reminder.tStartRefresh - timeLastRun)
                timeLastRun = title_reminder.tStartRefresh + 6
                print('timeLastRun', timeLastRun)
            elif trial == 4:
                thisExp.addData(f"block{trial-1}TotalTime", title_reminder.tStartRefresh - timeLastRun)
                timeLastRun = title_reminder.tStartRefresh + 6
                print('timeLastRun', timeLastRun)
            # check responses
            if key_reminder.keys in ['', [], None]:  # No response was made
                key_reminder.keys = None
            skip_reminder.addData('key_reminder.keys',key_reminder.keys)
            if key_reminder.keys != None:  # we had a response
                skip_reminder.addData('key_reminder.rt', key_reminder.rt)
                skip_reminder.addData('key_reminder.duration', key_reminder.duration)
            # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
            if routineForceEnded:
                routineTimer.reset()
            else:
                routineTimer.addTime(-6.000000)
        # completed skipReminder repeats of 'skip_reminder'
        
        
        # set up handler to look after randomisation of conditions etc
        trials = data.TrialHandler(nReps=1.0, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(trialConditions, selection=rowTrial),
            seed=None, name='trials')
        thisExp.addLoop(trials)  # add the loop to the experiment
        thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
        if thisTrial != None:
            for paramName in thisTrial:
                exec('{} = thisTrial[paramName]'.format(paramName))
        
        for thisTrial in trials:
            currentLoop = trials
            # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
            if thisTrial != None:
                for paramName in thisTrial:
                    exec('{} = thisTrial[paramName]'.format(paramName))
            
            # --- Prepare to start Routine "trial" ---
            continueRoutine = True
            # update component parameters for each repeat
            # Run 'Begin Routine' code from code
            # Boolean that will state if the signal is received or not
            signal_received = True
            button_down = True
            first_frame = True
            # List that will contains the time where the signal was received
            signal_times = list()
            # Save the answer of the participant
            # The response period started when image 2 started. No need to save it.
            response_time = -1. # Save when the participant answered (in secs)
            # set the images by parameters of condition file
            img1 = LeftStim
            img2 = RightStim
            # Set the duration of the fixation cross and the question
            timeQue = DurationQuestion/1000 #duration of the question
            timeFix = FixDelay/1000 #duration of the fixation cross
            n_secs_img1 = 2.
            n_secs_img2 = 2.
            #By default the elements did not start so they are not finished
            item1_finished = False
            que_finished = False
            item2_finished = False
            # Record if the participant answered
            participant_answered = False
            # When true, we reached the end of img2 without any answer
            no_answers = False
            # Reset the response of the participant
            responses = 0
            display_fix = False
            time_last_responses = 0
            skipReminder = 1
            im2RT = None
            # to know if we pressed a new letter
            lenght = 0
            # to increment the variable that will store the button data and joystick data
            button = 1
            joyst = 1
            startTime = joystick.joystickClock.getTime()
            
            # Change displayed text based on the language previously chosen
            if english == True:
                que_text.text = QuestionEnglish
                ans_yes_trial.text = "YES"
                ans_no_trial.text = "NO"
            else:
                que_text.text = QuestionFrench
                ans_yes_trial.text = "OUI"
                ans_no_trial.text = "NON"
                
            
            item1_img.setImage(img1)
            item2_img.setImage(img2)
            key.keys = []
            key.rt = []
            _key_allKeys = []
            joystick.oldButtonState = joystick.device.getAllButtons()[:]
            joystick.activeButtons=[1, 2]
            # setup some python lists for storing info about the joystick
            gotValidClick = False  # until a click is received
            # keep track of which components have finished
            trialComponents = [item1_img, que_text, item2_img, timer, fix_text, key, joystick, ans_yes_trial, ans_no_trial]
            for thisComponent in trialComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            frameN = -1
            
            # --- Run Routine "trial" ---
            routineForceEnded = not continueRoutine
            while continueRoutine:
                # get current time
                t = routineTimer.getTime()
                tThisFlip = win.getFutureFlipTime(clock=routineTimer)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                # Run 'Each Frame' code from code
                # Check if we pressed keyboard keys
                keys = event.getKeys()
                
                if first_frame:
                    startTime = joystick.joystickClock.getTime()
                    first_frame = False
                
                # Reset buttons if they are not pressed
                if button_down and not joystick.getAllButtons()[1] and not joystick.getAllButtons()[2]:
                   button_down = False
                
                # Reset signal
                if signal_received and not '5' in keys:
                   signal_received = False
                
                # If we received the signal, store the time
                if not signal_received and '5' in keys:
                    signal_times.append(t)
                    signal_received = True
                
                # Register participant's answers with the keyboard
                if len(key.keys) != lenght:
                    # Button 1 is pressed
                    if(key.keys[-1] == '1' and not item2_finished):
                        responses = 1
                        participant_answered = True
                        lenght = len(key.keys)
                        button += 1
                        time_last_responses = key.rt[-1]
                    # Button 2 is pressed
                    if(key.keys[-1] == '2' and not item2_finished): 
                        responses = 2
                        participant_answered = True
                        lenght = len(key.keys)
                        button += 1
                        time_last_responses = key.rt[-1]
                    # Other button is pressed
                    else:
                        lenght = len(key.keys)
                        button += 1
                #Joystick button 1 is pressed
                elif joystick.getAllButtons()[1] and not item2_finished and not button_down:
                    responses = 1
                    participant_answered = True
                    thisExp.addData(f"pressedbuttonJ{joyst}", 1)
                    thisExp.addData(f"timebuttonJ{joyst}", joystick.joystickClock.getTime() - startTime)
                    joyst += 1
                    time_last_responses = joystick.joystickClock.getTime() - startTime
                    button_down = True
                #Joystick button 2 is pressed
                elif joystick.getAllButtons()[2] and not item2_finished and not button_down:
                    responses = 2
                    participant_answered = True
                    thisExp.addData(f"pressedbuttonJ{joyst}", 2)
                    thisExp.addData(f"timebuttonJ{joyst}", joystick.joystickClock.getTime() - startTime)
                    joyst += 1
                    time_last_responses = joystick.joystickClock.getTime() - startTime
                    button_down = True
                
                # Register participant's answers
                #4s countdown are done
                elif not no_answers and not participant_answered and timer.status == FINISHED:
                    no_answers = True
                #    print("participant did not answer: ", responses.text)
                  
                if (len(key.keys) > 0):
                    if key.keys[-1] =='escape':
                        core.quit() 
                
                if timer.status == FINISHED:
                    item2_finished = True
                    ##responses.finished = True
                    display_fix = True
                    
                ##if responses.status == FINISHED and im2RT == None:
                #if time_last_responses != 0 and im2RT == None:
                #    im2RT = time_last_responses
                
                
                #Go to next routine when fixation cross is done
                if fix_text.status == FINISHED:
                    continueRoutine = False
                    
                    
                
                # *item1_img* updates
                
                # if item1_img is starting this frame...
                if item1_img.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    item1_img.frameNStart = frameN  # exact frame index
                    item1_img.tStart = t  # local t and not account for scr refresh
                    item1_img.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(item1_img, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'item1_img.started')
                    # update status
                    item1_img.status = STARTED
                    item1_img.setAutoDraw(True)
                
                # if item1_img is active this frame...
                if item1_img.status == STARTED:
                    # update params
                    pass
                
                # if item1_img is stopping this frame...
                if item1_img.status == STARTED:
                    if bool(display_fix == 1):
                        # keep track of stop time/frame for later
                        item1_img.tStop = t  # not accounting for scr refresh
                        item1_img.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'item1_img.stopped')
                        # update status
                        item1_img.status = FINISHED
                        item1_img.setAutoDraw(False)
                
                # *que_text* updates
                
                # if que_text is starting this frame...
                if que_text.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                    # keep track of start time/frame for later
                    que_text.frameNStart = frameN  # exact frame index
                    que_text.tStart = t  # local t and not account for scr refresh
                    que_text.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(que_text, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'que_text.started')
                    # update status
                    que_text.status = STARTED
                    que_text.setAutoDraw(True)
                
                # if que_text is active this frame...
                if que_text.status == STARTED:
                    # update params
                    pass
                
                # if que_text is stopping this frame...
                if que_text.status == STARTED:
                    if bool(display_fix == 1):
                        # keep track of stop time/frame for later
                        que_text.tStop = t  # not accounting for scr refresh
                        que_text.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'que_text.stopped')
                        # update status
                        que_text.status = FINISHED
                        que_text.setAutoDraw(False)
                
                # *item2_img* updates
                
                # if item2_img is starting this frame...
                if item2_img.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                    # keep track of start time/frame for later
                    item2_img.frameNStart = frameN  # exact frame index
                    item2_img.tStart = t  # local t and not account for scr refresh
                    item2_img.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(item2_img, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'item2_img.started')
                    # update status
                    item2_img.status = STARTED
                    item2_img.setAutoDraw(True)
                
                # if item2_img is active this frame...
                if item2_img.status == STARTED:
                    # update params
                    pass
                
                # if item2_img is stopping this frame...
                if item2_img.status == STARTED:
                    if bool(display_fix == 1):
                        # keep track of stop time/frame for later
                        item2_img.tStop = t  # not accounting for scr refresh
                        item2_img.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'item2_img.stopped')
                        # update status
                        item2_img.status = FINISHED
                        item2_img.setAutoDraw(False)
                
                # *timer* updates
                
                # if timer is starting this frame...
                if timer.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                    # keep track of start time/frame for later
                    timer.frameNStart = frameN  # exact frame index
                    timer.tStart = t  # local t and not account for scr refresh
                    timer.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(timer, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'timer.started')
                    # update status
                    timer.status = STARTED
                    timer.setAutoDraw(True)
                
                # if timer is active this frame...
                if timer.status == STARTED:
                    # update params
                    pass
                
                # if timer is stopping this frame...
                if timer.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > timer.tStartRefresh + 4-frameTolerance:
                        # keep track of stop time/frame for later
                        timer.tStop = t  # not accounting for scr refresh
                        timer.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'timer.stopped')
                        # update status
                        timer.status = FINISHED
                        timer.setAutoDraw(False)
                
                # *fix_text* updates
                
                # if fix_text is starting this frame...
                if fix_text.status == NOT_STARTED and display_fix == 1:
                    # keep track of start time/frame for later
                    fix_text.frameNStart = frameN  # exact frame index
                    fix_text.tStart = t  # local t and not account for scr refresh
                    fix_text.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fix_text, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'fix_text.started')
                    # update status
                    fix_text.status = STARTED
                    fix_text.setAutoDraw(True)
                
                # if fix_text is active this frame...
                if fix_text.status == STARTED:
                    # update params
                    pass
                
                # if fix_text is stopping this frame...
                if fix_text.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fix_text.tStartRefresh + timeFix-frameTolerance:
                        # keep track of stop time/frame for later
                        fix_text.tStop = t  # not accounting for scr refresh
                        fix_text.frameNStop = frameN  # exact frame index
                        # add timestamp to datafile
                        thisExp.timestampOnFlip(win, 'fix_text.stopped')
                        # update status
                        fix_text.status = FINISHED
                        fix_text.setAutoDraw(False)
                
                # *key* updates
                waitOnFlip = False
                
                # if key is starting this frame...
                if key.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    key.frameNStart = frameN  # exact frame index
                    key.tStart = t  # local t and not account for scr refresh
                    key.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key, 'tStartRefresh')  # time at next scr refresh
                    # add timestamp to datafile
                    thisExp.timestampOnFlip(win, 'key.started')
                    # update status
                    key.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(key.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if key.status == STARTED and not waitOnFlip:
                    theseKeys = key.getKeys(keyList=None, waitRelease=False)
                    _key_allKeys.extend(theseKeys)
                    if len(_key_allKeys):
                        key.keys = [key.name for key in _key_allKeys]  # storing all keys
                        key.rt = [key.rt for key in _key_allKeys]
                        key.duration = [key.duration for key in _key_allKeys]
                
                # *ans_yes_trial* updates
                
                # if ans_yes_trial is starting this frame...
                if ans_yes_trial.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    ans_yes_trial.frameNStart = frameN  # exact frame index
                    ans_yes_trial.tStart = t  # local t and not account for scr refresh
                    ans_yes_trial.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(ans_yes_trial, 'tStartRefresh')  # time at next scr refresh
                    # update status
                    ans_yes_trial.status = STARTED
                    ans_yes_trial.setAutoDraw(True)
                
                # if ans_yes_trial is active this frame...
                if ans_yes_trial.status == STARTED:
                    # update params
                    pass
                
                # if ans_yes_trial is stopping this frame...
                if ans_yes_trial.status == STARTED:
                    if bool(display_fix == 1):
                        # keep track of stop time/frame for later
                        ans_yes_trial.tStop = t  # not accounting for scr refresh
                        ans_yes_trial.frameNStop = frameN  # exact frame index
                        # update status
                        ans_yes_trial.status = FINISHED
                        ans_yes_trial.setAutoDraw(False)
                
                # *ans_no_trial* updates
                
                # if ans_no_trial is starting this frame...
                if ans_no_trial.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    ans_no_trial.frameNStart = frameN  # exact frame index
                    ans_no_trial.tStart = t  # local t and not account for scr refresh
                    ans_no_trial.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(ans_no_trial, 'tStartRefresh')  # time at next scr refresh
                    # update status
                    ans_no_trial.status = STARTED
                    ans_no_trial.setAutoDraw(True)
                
                # if ans_no_trial is active this frame...
                if ans_no_trial.status == STARTED:
                    # update params
                    pass
                
                # if ans_no_trial is stopping this frame...
                if ans_no_trial.status == STARTED:
                    if bool(display_fix == 1):
                        # keep track of stop time/frame for later
                        ans_no_trial.tStop = t  # not accounting for scr refresh
                        ans_no_trial.frameNStop = frameN  # exact frame index
                        # update status
                        ans_no_trial.status = FINISHED
                        ans_no_trial.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                    if eyetracker:
                        eyetracker.setConnectionState(False)
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    routineForceEnded = True
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in trialComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # --- Ending Routine "trial" ---
            for thisComponent in trialComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            # Run 'End Routine' code from code
            # Add the answer of the participant
            thisExp.addData('img.RESP', responses)
            # Add the correct answer
            thisExp.addData('img.CRESP', CorrectResponse)
            # See if that matches with the correct answer
            if responses == CorrectResponse:
                thisExp.addData('img.ACC', 1)
            elif responses == 1 or responses == 2:
                thisExp.addData('img.ACC', 0)
            else:
                thisExp.addData('img.ACC', '')
            if time_last_responses != 0:
                thisExp.addData('img.RT', time_last_responses)
            else:
                thisExp.addData('img.RT', '')
            # Save answer rttime since the beginning of the experiment
            thisExp.addData('img.RTTime', item1_img.tStartRefresh + time_last_responses)
            # Save the time where the participant answered according to the beginning of the countdown
            if responses!=0:
                thisExp.addData('resp.RTTimeSyncCdown', (que_text.tStartRefresh + time_last_responses) - (txt_rdy.tStartRefresh + first_pulse))
            else:
                thisExp.addData('resp.RTTimeSyncCdown', '')
                
            thisExp.addData('img.RTTimeSyncCdown', que_text.tStartRefresh - (txt_rdy.tStartRefresh + first_pulse))
            # Save the time where the signal was received
            thisExp.addData('signal.time', signal_times)
            thisExp.addData('stimulusDuration', fix_text.tStop)
            
            if (len(key.keys) > 0):
                key_signal = []
                key_signal_rt = []
                key_response = []
                key_response_rt = []
            
                # Parcourir la liste key_trial.keys
                for index, value in enumerate(key.keys):
                    if value == '5':
                        # Ajouter à key_signal si la valeur est '5'
                        key_signal.append(value)
                        # Ajouter la valeur correspondante à key_signal_rt
                        key_signal_rt.append(key.rt[index])
                    else:
                        # Ajouter à key_response si la valeur n'est pas '5'
                        key_response.append(value)
                        # Ajouter la valeur correspondante à key_response_rt
                        key_response_rt.append(key.rt[index])
            
                thisExp.addData('keyResponse', key_response)
                thisExp.addData('keyResponseRt', key_response_rt)
                thisExp.addData('keySignal', key_signal)
                thisExp.addData('keySignalRt', key_signal_rt)
            # check responses
            if key.keys in ['', [], None]:  # No response was made
                key.keys = None
            trials.addData('key.keys',key.keys)
            if key.keys != None:  # we had a response
                trials.addData('key.rt', key.rt)
                trials.addData('key.duration', key.duration)
            # store data for trials (TrialHandler)
            # store data for trials (TrialHandler)
            x, y = joystick.getX(), joystick.getY()
            joystick.newButtonState = joystick.getAllButtons()[:]
            joystick.pressedState = [joystick.newButtonState[i] for i in range(joystick.numButtons)]
            joystick.time = joystick.joystickClock.getTime()
            trials.addData('joystick.x', x)
            trials.addData('joystick.y', y)
            [trials.addData('joystick.button_{0}'.format(i), int(joystick.pressedState[i])) for i in joystick.activeButtons]
            trials.addData('joystick.time', joystick.time)
            # the Routine "trial" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1.0 repeats of 'trials'
        
        thisExp.nextEntry()
        
    # completed 4.0 repeats of 'block'
    
    
    # --- Prepare to start Routine "thanks" ---
    continueRoutine = True
    # update component parameters for each repeat
    # Run 'Begin Routine' code from code_thx
    # Change displayed text based on the language previously chosen
    if english == True:
        txt_thx.text = "Great job, you have completed the task!\n\nJust relax until the scanner stops."
    else:
        txt_thx.text = "Excellent travail, vous avez terminé la tâche!\n\nDétendez-vous simplement jusqu'à l'arrêt du scanner."
    key_thx.keys = []
    key_thx.rt = []
    _key_thx_allKeys = []
    # keep track of which components have finished
    thanksComponents = [txt_thx, key_thx]
    for thisComponent in thanksComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    frameN = -1
    
    # --- Run Routine "thanks" ---
    routineForceEnded = not continueRoutine
    while continueRoutine and routineTimer.getTime() < 10.0:
        # get current time
        t = routineTimer.getTime()
        tThisFlip = win.getFutureFlipTime(clock=routineTimer)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *txt_thx* updates
        
        # if txt_thx is starting this frame...
        if txt_thx.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            txt_thx.frameNStart = frameN  # exact frame index
            txt_thx.tStart = t  # local t and not account for scr refresh
            txt_thx.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(txt_thx, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'txt_thx.started')
            # update status
            txt_thx.status = STARTED
            txt_thx.setAutoDraw(True)
        
        # if txt_thx is active this frame...
        if txt_thx.status == STARTED:
            # update params
            pass
        
        # if txt_thx is stopping this frame...
        if txt_thx.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > txt_thx.tStartRefresh + 10.0-frameTolerance:
                # keep track of stop time/frame for later
                txt_thx.tStop = t  # not accounting for scr refresh
                txt_thx.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'txt_thx.stopped')
                # update status
                txt_thx.status = FINISHED
                txt_thx.setAutoDraw(False)
        
        # *key_thx* updates
        waitOnFlip = False
        
        # if key_thx is starting this frame...
        if key_thx.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_thx.frameNStart = frameN  # exact frame index
            key_thx.tStart = t  # local t and not account for scr refresh
            key_thx.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_thx, 'tStartRefresh')  # time at next scr refresh
            # add timestamp to datafile
            thisExp.timestampOnFlip(win, 'key_thx.started')
            # update status
            key_thx.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_thx.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_thx.clearEvents, eventType='keyboard')  # clear events on next screen flip
        
        # if key_thx is stopping this frame...
        if key_thx.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > key_thx.tStartRefresh + 10-frameTolerance:
                # keep track of stop time/frame for later
                key_thx.tStop = t  # not accounting for scr refresh
                key_thx.frameNStop = frameN  # exact frame index
                # add timestamp to datafile
                thisExp.timestampOnFlip(win, 'key_thx.stopped')
                # update status
                key_thx.status = FINISHED
                key_thx.status = FINISHED
        if key_thx.status == STARTED and not waitOnFlip:
            theseKeys = key_thx.getKeys(keyList=['esc'], waitRelease=False)
            _key_thx_allKeys.extend(theseKeys)
            if len(_key_thx_allKeys):
                key_thx.keys = _key_thx_allKeys[-1].name  # just the last key pressed
                key_thx.rt = _key_thx_allKeys[-1].rt
                key_thx.duration = _key_thx_allKeys[-1].duration
                # a response ends the routine
                continueRoutine = False
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
            if eyetracker:
                eyetracker.setConnectionState(False)
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            routineForceEnded = True
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in thanksComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # --- Ending Routine "thanks" ---
    for thisComponent in thanksComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # Run 'End Routine' code from code_thx
    thisExp.addData('block4TotalTime', txt_thx.tStartRefresh - timeLastRun)
    thisExp.addData('RunTotalTime', txt_thx.tStartRefresh - (txt_rdy.tStartRefresh + first_pulse))
    thisExp.addData('ExperiementTotalTime', txt_thx.tStartRefresh)
    # check responses
    if key_thx.keys in ['', [], None]:  # No response was made
        key_thx.keys = None
    skip_trial.addData('key_thx.keys',key_thx.keys)
    if key_thx.keys != None:  # we had a response
        skip_trial.addData('key_thx.rt', key_thx.rt)
        skip_trial.addData('key_thx.duration', key_thx.duration)
    # using non-slip timing so subtract the expected duration of this Routine (unless ended on request)
    if routineForceEnded:
        routineTimer.reset()
    else:
        routineTimer.addTime(-10.000000)
# completed skipT repeats of 'skip_trial'


# --- End experiment ---
# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
